/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Header: /plx/source/Xclients/generic/RCS/JPEG.h,v 1.17 1996/01/19 00:13:22 drapeau Exp $ */
/* $Log: JPEG.h,v $
 * Revision 1.17  1996/01/19  00:13:22  drapeau
 * Fixed compilation errors for g++.
 *
 * Revision 1.16  1995/09/26  07:15:25  drapeau
 * Made the file friendly to C++ compilers.
 *
 * Revision 1.15  1995/09/21  01:43:05  drapeau
 * Added code to take advantage of enhanced server reporting
 * capabilities: the XPlxQueryConfig() function new reports more specific
 * information about the capabilities of the hardware, including whether
 * JPEG hardware is available or not.
 *
 * Revision 1.14  1995/05/02  01:42:51  drapeau
 * Added new resource to support hardware zoom when available.
 *
 * Revision 1.13  1994/09/03  06:16:09  drapeau
 * Added a resource "drawMethod", allowing the application programmer to
 * draw graphics over a JPEG image.
 *
 * Revision 1.12  1994/05/03  17:57:41  drapeau
 * Added a resource called "diagnostics"; when set, the widget will print
 * diagnostic messages about itself to aid in debugging.
 *
 * Revision 1.11  1993/10/26  17:58:54  drapeau
 * Slight modification: moved the RCS id inside the ifndef to avoid
 * multiple inclusions.
 *
 * Revision 1.10  1993/09/10  12:01:22  drapeau
 * This is the first public release of the JPEG widget header files.
 * */
#ifndef _JPEG_h
#define _JPEG_h
static char jpegHeaderRcsId[] = "$Header: /plx/source/Xclients/generic/RCS/JPEG.h,v 1.17 1996/01/19 00:13:22 drapeau Exp $";
#ifdef __cplusplus
extern "C"	{
#endif



/****************************************************************
 *
 * JPEG widget
 *
 ****************************************************************/
/* Resources:
 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 sourceWin	     SourceWin		Window		0
 compressSourceRect  CompressSourceRect XRectangle*	NULL
 compressDestRect    CompressDestRect	XRectangle*	NULL
 jpegData	     JPEGData		XPlxCImage*	NULL
 destWin	     DestWin		Window		0
 displaySourceRect   DisplaySourceRect	XRectangle*	NULL
 displayDestRect     DisplayDestRect	XRectangle*	NULL
 squeezeDest	     SqueezeDest	Boolean		False
 qFactor	     QFactor		Integer		100
 getNewImage	     GetNewImage	Boolean		False
 putNewImage	     PutNewImage	Boolean		False
 jfifInputFile	     JFIFInputFile	String		NULL
 jfifOutputFile	     JFIFOutputFile	String		NULL
 useSharedMemory     UseSharedMemory	Boolean		False
 diagnostics	     Diagnostics	Boolean		False
 drawMethod	     DrawMethod		DrawMethod	NULL
 zoomFactor	     ZoomFactor		Integer		1
 jpegAvailable	     JPEGAvailable	Boolean		True
*/


#define XtNsourceWin		"sourceWin"			    /* Special resource names not defined in <X11/StringDefs.h> */
#define XtNcompressSourceRect	"compressSourceRect"
#define XtNcompressDestRect	"compressDestRect"
#define XtNjpegData		"jpegData"
#define XtNdestWin		"destWin"
#define XtNdisplaySourceRect	"displaySourceRect"
#define XtNdisplayDestRect	"displayDestRect"
#define XtNsqueezeDest		"squeezeDest"
#define XtNqFactor		"qFactor"
#define XtNgetNewImage		"getNewImage"
#define XtNputNewImage		"putNewImage"
#define XtNjfifInputFile	"jfifInputFile"
#define XtNjfifOutputFile	"jfifOutputFile"
#define XtNuseSharedMemory	"useSharedMemory"
#define XtNdiagnostics		"diagnostics"
#define XtNdrawMethod		"drawMethod"
#define XtNzoomFactor		"zoomFactor"
#define XtNjpegAvailable	"jpegAvailable"

#define XtCSourceWin		"SourceWin"
#define XtCCompressSourceRect	"compressSourceRect"
#define XtCCompressDestRect	"compressDestRect"
#define XtCJPEGData		"JPEGData"
#define XtCDestWin		"DestWin"
#define XtCDisplaySourceRect	"DisplaySourceRect"
#define XtCDisplayDestRect	"DisplayDestRect"
#define XtCSqueezeDest		"SqueezeDest"
#define XtCQFactor		"QFactor"
#define XtCGetNewImage		"GetNewImage"
#define XtCPutNewImage		"PutNewImage"
#define XtCJFIFInputFile	"JFIFInputFile"
#define XtCJFIFOutputFile	"JFIFOutputFile"
#define XtCUseSharedMemory	"UseSharedMemory"
#define XtCDiagnostics		"Diagnostics"
#define XtCDrawMethod		"DrawMethod"
#define XtCZoomFactor		"ZoomFactor"
#define XtCJPEGAvailable	"JPEGAvailable"

typedef struct _JPEGClassRec*	JPEGWidgetClass;		    /* Declare specific JPEGWidget class and instance datatypes */
typedef struct _JPEGRec*	JPEGWidget;

extern WidgetClass jpegWidgetClass;				    /* Declare the class constant */

#ifdef __cplusplus
}
#endif
#endif /* _JPEG_h */
