/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Header: /plx/source/Xclients/generic/RCS/O_GCinfo.h,v 1.4 1996/01/19 00:44:40 drapeau Exp $ */
/* $Log: O_GCinfo.h,v $
 * Revision 1.4  1996/01/19  00:44:40  drapeau
 * Fixed compilation errors for g++.
 *
 * Revision 1.3  1995/09/26  07:14:57  drapeau
 * Made the file friendly to C++ compilers.
 *
 * Revision 1.2  1995/04/12  23:12:44  drapeau
 * Added a key field to the GC-Window mapping data structure to help
 * verify that the proper widget registers and removes a GC-Window
 * mapping.
 *
 * Revision 1.1  1995/04/12  05:04:36  drapeau
 * Initial revision
 * */
static char O_GCinfoHeaderRcsId[] = "$Header: /plx/source/Xclients/generic/RCS/O_GCinfo.h,v 1.4 1996/01/19 00:44:40 drapeau Exp $";

#ifndef O_GCinfo_INCLUDED
#define O_GCinfo_INCLUDED

#ifdef __cplusplus
extern "C"	{
#endif


/*           O_GCinfo_add
 *           ------------
 *
 *   win - window id of pair to be added to registry
 *   gc  - graphics context id of pair to be added to registry
 */
#define O_GCinfo_add(obj, owner, win, gc) \
	(*((obj)->atv->add))(obj, owner, win, gc)


/*           O_GCinfo_del_by_gc
 *           ------------------
 *
 *   gc  - graphics context id of pair(s) to be deleted from registry
 */
#define O_GCinfo_del_by_gc(obj, gc) (*((obj)->atv->del_by_gc))(obj, gc)


/*           O_GCinfo_del_by_win
 *           -------------------
 *
 *   win - window id of pair(s) to be deleted from registry
 */
#define O_GCinfo_del_by_win(obj, win) (*((obj)->atv->del_by_win))(obj, win)


/*           O_GCinfo_find_by_gc
 *           -------------------
 *
 *   gc  - graphics context id of pair to be found in registry
 */
#define O_GCinfo_find_by_gc(obj, gc, p_win, p_owner) \
	(*((obj)->atv->find_by_gc))(obj, gc, p_win, p_owner)


/*           O_GCinfo_find_by_win
 *           --------------------
 *
 *   win - window id of pair to be found in registry
 */
#define O_GCinfo_find_by_win(obj, win, p_gc, p_owner) \
	(*((obj)->atv->find_by_win))(obj, win, p_gc, p_owner)


/*           O_GCinfo_terminate
 *           ------------------
 * 
 */
#define O_GCinfo_terminate(obj) (*((obj)->atv->terminate))(obj)

typedef struct _TV_GCinfo {
	int	 (*add)();			/* Add a pair to registry. */
	int	 (*del_by_gc)();	/* Delete pairs with given gc from registry. */
	int	 (*del_by_win)();	/* Delete pairs with given window from registry. */
	int	 (*find_by_gc)();	/* Find a pair given a gc. */
	int	 (*find_by_win)();	/* Find a pair given a window. */
	void (*terminate)();	/* Destructor for this object. */
} TV_GCinfo;

typedef struct _O_GCinfo {
	TV_GCinfo*	atv;	/* Methods transfer vector. */
} O_GCinfo;

O_GCinfo* O_GCinfo_O_GCinfo(/* int max_pairs */); /* Constructor for object. */

#ifdef __cplusplus
}
#endif
#endif  O_GCinfo_INCLUDED
