/* $Header: /plx/source/Xclients/generic/RCS/XPlxProtos.h,v 1.17 1996/01/19 00:13:37 drapeau Exp $ */
/*
 *   Copyright (c) 1994 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Log: XPlxProtos.h,v $
 * Revision 1.17  1996/01/19  00:13:37  drapeau
 * Fixed compilation errors for g++.
 *
 * Revision 1.16  1996/01/03  21:56:50  lovvik
 * Added an argument for the signal standard to the XPlxRtvPutCImage()
 * call.
 *
 * Revision 1.15  1995/12/20  02:04:37  drapeau
 * Fixed an incorrect function prototype for XPlxShmQueryVersion().
 *
 * Revision 1.14  1995/12/20  00:47:03  drapeau
 * Added some missing function prototypes, for shared memory operations.
 *
 * Revision 1.13  1995/11/01  02:55:40  lovvik
 * Fixed function prototypes for the RTV calls.
 *
 * Revision 1.12  1995/10/17  17:44:22  lovvik
 * Changed Boolean to Bool.
 *
 * Revision 1.11  1995/10/17  01:53:16  lovvik
 * Added function prototypes for file utility functions.
 *
 * Revision 1.10  1995/10/11  20:25:54  drapeau
 * Added function prototypes for new RTV functionality.
 *
 * Revision 1.9  1995/09/28  05:21:11  drapeau
 * Added support for C++ compilers.
 *
 * Revision 1.8  1995/09/19  23:14:13  drapeau
 * Added function prototypes for two new utility functions.
 *
 * Revision 1.7  1995/08/30  18:57:31  drapeau
 * Added support for C++ compilation.
 *
 * Revision 1.6  1995/05/30  22:55:29  drapeau
 * Add function prototype for new function
 * XPlxGetCurrentHardwareInstance() that indicates the current board
 * being used.  Useful when working on a computer that supports multiple
 * Parallax boards per Screen.
 *
 * Revision 1.5  1995/04/27  19:50:47  drapeau
 * Added two new functions for setting and getting the zoom factor.
 * Currently only applicable on HP and IBM platforms.
 *
 * Revision 1.4  1995/04/21  20:14:51  drapeau
 * Added function prototypes for new functions that allow for using
 * multiple boards per screen.
 *
 * Revision 1.3  1994/10/22  02:23:48  drapeau
 * Fixed a function declaration for XPlxPutTable().
 *
 * Revision 1.2  1994/08/27  22:51:11  drapeau
 * Repaired an errant function prototype for XPlxVideoInput().
 *
 * Revision 1.1  1994/08/27  05:14:03  drapeau
 * Initial revision
 * */

#ifndef _XPlxProtosHeader_
#define _XPlxProtosHeader_

#include <X11/Xutil.h>

#ifdef __cplusplus
extern "C"	{
#endif

#if NeedFunctionPrototypes

XVisualInfo*	XPlxGetVideoVisual(int		screenNumber,
				   Display*	display);

void		XPlxSleep(unsigned int microseconds);

int		XPlxGetZoomFactor(Display*	dpy,
				  Drawable	d);

Bool		XPlxSetZoomFactor(Display*	dpy,
				  Drawable	d,
				  int		zoomFactor);

Bool		XPlxSelectHardwareInstance(Display*	dpy,
					   int		instance);

int		XPlxGetHardwareInstances(Display*	dpy);

int		XPlxGetCurrentHardwareInstance(Display*	dpy);

Bool		XPlxFindMatchingSignal(plx_IO*	plxIO,
				       int	channel,
				       int	standard,
				       int	format,
				       int	instance);

plx_IO*		XPlxQueryConfig(register Display*	dpy,
				Drawable		d,
				GC			gc);

plx_signal*	XPlxQueryVideo(register Display*	dpy,
			       Drawable			d,
			       GC			gc);

void		XPlxVideoOutput(register Display*	dpy,
				Drawable		d,
				GC			gc,
				int			vx,
				int			vy,
				int			x,
				int			y,
				int			w,
				int			h);

void		XPlxVideoScaleOutput(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int		vx,
				     int		vy,
				     int		vw,
				     int		vh,
				     int		x,
				     int		y,
				     int		w,
				     int		h);

void		XPlxVideoTag(register Display*		dpy,
			     Drawable			d,
			     GC				gc,
			     int			type);

void		XPlxVideoInputSelect(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int		channel,
				     int		standard,
				     int		format,
				     int		type);

void		XPlxVideoOutputSelect(register Display*	dpy,
				      Drawable		d,
				      GC		gc,
				      int		channel,
				      int		standard,
				      int		format,
				      int		type);

void		XPlxVideoValueLoad(register Display*	dpy,
				   Drawable		d,
				   GC			gc,
				   int			sat,
				   int			cont,
				   int			hue,
				   int			brit);

void		XPlxVideoValueQuery(register Display*	dpy,
				    Drawable		d,
				    GC			gc,
				    int*		sat,
				    int*		cont,
				    int*		hue,
				    int*		brit);

void		XPlxVideoValueSave(register Display*	dpy,
				   Drawable		d,
				   GC			gc,
				   int			nvselect);

void		XPlxVideoValueRecall(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int		nvselect);

void		XPlxVideoLive(register Display*		dpy,
			      Drawable			d,
			      GC			gc,
			      int			vx,
			      int			vy,
			      int			x,
			      int			y,
			      int			w,
			      int			h);

void		XPlxVideoStill(register Display*	dpy,
			       Drawable			d,
			       GC			gc,
			       int			vx,
			       int			vy,
			       int			x,
			       int			y,
			       int			w,
			       int			h);

void		XPlxVideoScale(register Display*	dpy,
			       Drawable			d,
			       GC			gc,
			       int			vx,
			       int			vy,
			       int			vw,
			       int			vh,
			       int			x,
			       int			y,
			       int			w,
			       int			h);

void		XPlxVideoSqueezeLive(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int		vx,
				     int		vy,
				     int		vw,
				     int		vh,
				     int		x,
				     int		y,
				     int		w,
				     int		h);

void		XPlxVideoSqueezeStill(register Display*	dpy,
				      Drawable		d,
				      GC		gc,
				      int		vx,
				      int		vy,
				      int		vw,
				      int		vh,
				      int		x,
				      int		y,
				      int		w,
				      int		h);

void		XPlxVideoStop(register Display*	dpy,
			      Drawable		d,
			      GC		gc);

void		XPlxVideoPriority(register Display*	dpy,
				  Drawable		d,
				  GC			gc,
				  int			pri);

void		XPlxVideoInput(register Display*	dpy,
			       Drawable			d,
			       GC			gc,
			       int			channel);

void		XPlxScaleCopyArea(register Display*	dpy,
				  Drawable		sd,
				  Drawable		dd,
				  GC			gc,
				  int			sx,
				  int			sy,
				  int			sw,
				  int			sh,
				  int			dx,
				  int			dy,
				  int			dw,
				  int			dh);

void		XPlxSetVideoParameterString(register Display*	dpy,
					    Drawable		d,
					    GC			gc,
					    char*		buf);

char* 		XPlxXvGetVideoParameterString(register Display*	dpy,
					      Drawable		d,
					      GC		gc);

int		MakeQTables(unsigned int factor,
			    unsigned char* buf[]);

XPlxCImage*	XPlxCreateCImage(Display*	dpy,
				 char*		data,
				 int		size,
				 unsigned int	width,
				 unsigned int	height);

int		XPlxDestroyCImage(XPlxCImage*	ximage);

XPlxCImage*	XPlxGetCImage(register Display*	dpy,
			      Drawable		d,
			      GC		gc,
			      int		src_x,
			      int		src_y,
			      unsigned int	src_w,
			      unsigned int	src_h,
			      unsigned int	dst_w,
			      unsigned int	dst_h);

void		XPlxPutCImage(register Display*		dpy,
			      Drawable			d,
			      GC			gc,
			      register XPlxCImage*	image,
			      int			src_x,
			      int			src_y,
			      unsigned int		src_w,
			      unsigned int		src_h,
			      int			dst_x,
			      int			dst_y,
			      unsigned int		dst_w,
			      unsigned int		dst_h,
			      int			flag);

void		XPlxPutTable(Display*	dpy,
			     Drawable	d,
			     GC		gc,
			     char*	data,
			     int	size,
			     int	dir);

#include	<X11/extensions/XShm.h>

XPlxCImage*	XPlxShmCreateCImage(register Display*	dpy,
				    char*		data,
				    XShmSegmentInfo*	shminfo,
				    int			size,
				    unsigned int	width,
				    unsigned int	height);

Status		XPlxShmGetCImage(register Display*	dpy,
				 Drawable		d,
				 GC			gc,
				 XPlxCImage*		image,
				 int			src_x,
				 int			src_y,
				 unsigned int		src_w,
				 unsigned int		src_h);

Status		XPlxShmPutCImage(register Display*	dpy,
				 Drawable		d,
				 GC			gc,
				 XPlxCImage*		image,
				 int			src_x,
				 int			src_y,
				 unsigned int		src_w,
				 unsigned int		src_h,
				 int			dst_x,
				 int			dst_y,
				 unsigned int		dst_w,
				 unsigned int		dst_h,
				 int			flag,
				 Bool			send_event);

XShmSegmentInfo*	XPlxGetShmInfo(void);

void			XPlxFreeShmInfo(XShmSegmentInfo* shminfo);

Bool			XPlxShmQueryVersion(Display*,
					    int*,
					    int*,
					    Bool*);

int			XPlxShmGetEventBase(Display*);

Status			XPlxShmAttach(Display*,
				      XShmSegmentInfo*);

Status			XPlxShmDetach(Display*,
				      XShmSegmentInfo*);



int 	XPlxRtvGetCImage(Display*		dpy,
			 Drawable		d,
			 GC			gc,
			 int			src_x,
			 int			src_y,	
			 unsigned int		src_w,
			 unsigned int		src_h,
			 unsigned int		dst_w,
			 unsigned int		dst_h);


int	XPlxRtvPutCImage(register Display*	dpy,
			 Drawable		d,
			 GC			gc,
			 int			src_x,
			 int			src_y,
			 unsigned int		src_w,
			 unsigned int		src_h,
			 int			dst_x,
			 int			dst_y,
			 unsigned int		dst_w,
			 unsigned int		dst_h,
			 int			standard);

int 	XPlxSetRtvWindow(Display*		dpy,
			 Drawable		d,
			 GC			gc);

int	XPlxUnsetRtvWindow(register Display*	dpy,
			   Drawable		d,
			   GC			gc);

Bool		XPlxIsJPEGFile(char*		filename);
Bool		XPlxIsRTVFile(char*		filename);
Bool		XPlxIsJFIFFile(char*		filename);

XExtCodes*	XPlxFindExtension(Display*	display,
				  int*		majorOpcodePtr);


/*
 * Function prototypes below this line are for XPlx-to-Xv protocol
 * translation and are not part of the public API.  Application
 * programmers need not pay attention to the function prototypes below
 * this point.
 */

int		XPlxXvGetZoomFactor(Display*	dpy,
				    Drawable	d);

Bool		XPlxXvSetZoomFactor(Display*	dpy,
				    Drawable	d,
				    int		zoomFactor);

Bool		XPlxXvSelectHardwareInstance(Display*	dpy,
					     int	instance);

int		XPlxXvGetHardwareInstances(Display*	dpy);

int		XPlxXvGetCurrentHardwareInstance(Display*	dpy);

plx_IO*		XPlxXvQueryConfig(register Display*	dpy,
				  Drawable		d,
				  GC			gc);

plx_signal*	XPlxXvQueryVideo(register Display*	dpy,
				 Drawable			d,
				 GC			gc);

void		XPlxXvVideoOutput(register Display*	dpy,
				  Drawable		d,
				  GC			gc,
				  int			vx,
				  int			vy,
				  int			x,
				  int			y,
				  int			w,
				  int			h);

void		XPlxXvVideoScaleOutput(register Display*	dpy,
				       Drawable		d,
				       GC			gc,
				       int		vx,
				       int		vy,
				       int		vw,
				       int		vh,
				       int		x,
				       int		y,
				       int		w,
				       int		h);

void		XPlxXvVideoTag(register Display*		dpy,
			       Drawable			d,
			       GC				gc,
			       int			type);

void		XPlxXvVideoInputSelect(register Display*	dpy,
				       Drawable		d,
				       GC			gc,
				       int		channel,
				       int		standard,
				       int		format,
				       int		type);

void		XPlxXvVideoOutputSelect(register Display*	dpy,
					Drawable		d,
					GC		gc,
					int		channel,
					int		standard,
					int		format,
					int		type);

void		XPlxXvVideoValueLoad(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int			sat,
				     int			cont,
				     int			hue,
				     int			brit);

void		XPlxXvVideoValueQuery(register Display*	dpy,
				      Drawable		d,
				      GC			gc,
				      int*		sat,
				      int*		cont,
				      int*		hue,
				      int*		brit);

void		XPlxXvVideoValueSave(register Display*	dpy,
				     Drawable		d,
				     GC			gc,
				     int			nvselect);

void		XPlxXvVideoValueRecall(register Display*	dpy,
				       Drawable		d,
				       GC			gc,
				       int		nvselect);

void		XPlxXvVideoLive(register Display*		dpy,
				Drawable			d,
				GC			gc,
				int			vx,
				int			vy,
				int			x,
				int			y,
				int			w,
				int			h);

void		XPlxXvVideoStill(register Display*	dpy,
				 Drawable			d,
				 GC			gc,
				 int			vx,
				 int			vy,
				 int			x,
				 int			y,
				 int			w,
				 int			h);

void		XPlxXvVideoScale(register Display*	dpy,
				 Drawable			d,
				 GC			gc,
				 int			vx,
				 int			vy,
				 int			vw,
				 int			vh,
				 int			x,
				 int			y,
				 int			w,
				 int			h);

void		XPlxXvVideoSqueezeLive(register Display*	dpy,
				       Drawable		d,
				       GC			gc,
				       int		vx,
				       int		vy,
				       int		vw,
				       int		vh,
				       int		x,
				       int		y,
				       int		w,
				       int		h);

void		XPlxXvVideoSqueezeStill(register Display*	dpy,
					Drawable		d,
					GC		gc,
					int		vx,
					int		vy,
					int		vw,
					int		vh,
					int		x,
					int		y,
					int		w,
					int		h);

void		XPlxXvVideoStop(register Display*	dpy,
				Drawable		d,
				GC		gc);

void		XPlxXvVideoPriority(register Display*	dpy,
				    Drawable		d,
				    GC			gc,
				    int			pri);

void		XPlxXvVideoInput(register Display*	dpy,
				 Drawable			d,
				 GC			gc,
				 int			channel);

void		XPlxXvScaleCopyArea(register Display*	dpy,
				    Drawable		sd,
				    Drawable		dd,
				    GC			gc,
				    int			sx,
				    int			sy,
				    int			sw,
				    int			sh,
				    int			dx,
				    int			dy,
				    int			dw,
				    int			dh);

void		XPlxXvSetVideoParameterString(register Display*	dpy,
					      Drawable		d,
					      GC		gc,
					      char*		buf);

char*		XPlxGetVideoParameterString(register Display*	dpy,
					    Drawable		d,
					    GC			gc);

XPlxCImage*	XPlxXvGetCImage(register Display*	dpy,
				Drawable		d,
				GC		gc,
				int		src_x,
				int		src_y,
				unsigned int	src_w,
				unsigned int	src_h,
				unsigned int	dst_w,
				unsigned int	dst_h);

void		XPlxXvPutCImage(register Display*		dpy,
				Drawable			d,
				GC			gc,
				register XPlxCImage*	image,
				int			src_x,
				int			src_y,
				unsigned int		src_w,
				unsigned int		src_h,
				int			dst_x,
				int			dst_y,
				unsigned int		dst_w,
				unsigned int		dst_h,
				int			flag);

void		XPlxXvPutTable(Display*	dpy,
			       Drawable	d,
			       GC		gc,
			       char*	data,
			       int	size,
			       int	dir);

Status		XPlxXvShmGetCImage(register Display*	dpy,
				   Drawable		d,
				   GC			gc,
				   XPlxCImage*		image,
				   int			src_x,
				   int			src_y,
				   unsigned int		src_w,
				   unsigned int		src_h);

Status		XPlxXvShmPutCImage(register Display*	dpy,
				   Drawable		d,
				   GC			gc,
				   XPlxCImage*		image,
				   int			src_x,
				   int			src_y,
				   unsigned int		src_w,
				   unsigned int		src_h,
				   int			dst_x,
				   int			dst_y,
				   unsigned int		dst_w,
				   unsigned int		dst_h,
				   int			flag,
				   Bool			send_event);

#endif

#ifdef __cplusplus
}
#endif

#endif
