/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Header: /plx/source/Xclients/generic/RCS/XVideoOut.h,v 1.13 1996/01/19 00:49:58 drapeau Exp $ */
/* $Log: XVideoOut.h,v $
 * Revision 1.13  1996/01/19  00:49:58  drapeau
 * Fixed compilation errors for g++.
 *
 * Revision 1.12  1995/09/26  07:13:33  drapeau
 * Made the file friendly to C++ compilers.
 *
 * Revision 1.11  1994/05/03  17:57:25  drapeau
 * Added a resource called "diagnostics"; when set, the widget will print
 * diagnostic messages about itself to aid in debugging.
 *
 * Revision 1.10  1993/09/10  12:15:20  drapeau
 * This is the first public release of the VideoOut widget header files.
 * */
#ifndef _XVideoOut_h
#define _XVideoOut_h
#ifdef __cplusplus
extern "C"	{
#endif

static char xVideoOutHeaderRcsId[] = "$Header: /plx/source/Xclients/generic/RCS/XVideoOut.h,v 1.13 1996/01/19 00:49:58 drapeau Exp $";


/****************************************************************
 *
 * XVideoOut widget
 *
 ****************************************************************/

/* Resources specific to this widget:
   
 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 normalAspectRatio   NormalAspectRatio	Boolean		True
 sourceWin	     SourceWin		Window		0
 sourceRect	     sourceRect 	XRectangle*	NULL
 destRect	     destRect		XRectangle*	NULL
 signalStandard	     SignalStandard	Int		PLX_NTSC
 signalFormat	     SignalFormat	Int		PLX_COMP
 hardwareType	     HardwareType	Int		PLX_XVIDEO_24
 channel	     Channel		Int		PLX_OUTPUT_0
 signalWidth	     SignalWidth	Int		640
 signalHeight	     SignalHeight	Int		480
 diagnostics	     Diagnostics	Boolean		False
 
*/

#define XtNnormalAspectRatio	"normalAspectRatio"		    /* Special resource names not defined in <X11/StringDefs.h> */
#define XtNsourceWin		"sourceWin"
#define XtNsourceRect		"sourceRect"
#define XtNdestRect		"destRect"
#define XtNsignalStandard	"signalStandard"
#define XtNsignalFormat		"signalFormat"
#define XtNhardwareType		"hardwareType"
#define XtNchannel		"channel"
#define XtNsignalWidth		"signalWidth"
#define XtNsignalHeight		"signalHeight"
#define XtNdiagnostics		"diagnostics"

#define XtCNormalAspectRatio	"NormalAspectRatio"
#define XtCSourceWin		"SourceWin"
#define XtCSourceRect		"SourceRect"
#define XtCDestRect		"DestRect"
#define XtCSignalStandard	"SignalStandard"
#define XtCSignalFormat		"SignalFormat"
#define XtCHardwareType		"HardwareType"
#define XtCChannel		"Channel"
#define XtCSignalWidth		"SignalWidth"
#define XtCSignalHeight		"SignalHeight"
#define XtCDiagnostics		"Diagnostics"

/* declare specific XVideoOutWidget class and instance datatypes */

typedef struct _XVideoOutClassRec*	XVideoOutWidgetClass;
typedef struct _XVideoOutRec*		XVideoOutWidget;

/* declare the class constant */

extern WidgetClass xVideoOutWidgetClass;

#ifdef __cplusplus
}
#endif
#endif /* _XVideoOut_h */
