/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: XVideoP.h,v $
 * Revision 1.5  1996/01/19  00:50:23  drapeau
 * Fixed compilation errors for g++.
 *
 * Revision 1.4  1995/09/26  07:13:16  drapeau
 * Made the file friendly to C++ compilers.
 *
 * Revision 1.3  1991/11/20  17:23:51  janet
 * added VideoView support so that this will support all our products
 *
 * Revision 1.2  91/08/19  12:40:44  eric
 * added rcs header
 * 
 *
 */

#ifdef H_ID
#ifdef __cplusplus
extern "C"	{
#endif

#ifndef lint
static char *rcsid_XVideoP_h = "@(#)$Id: XVideoP.h,v 1.5 1996/01/19 00:50:23 drapeau Exp $ Parallax Graphics Inc";
#endif
#endif

#ifndef _XtPVideoP_h
#define _XtPVideoP_h

#include <X11/IntrinsicP.h>
#include <X11/CoreP.h>

#include "XVideo.h"

typedef struct confstr
{
	Window window;
	int windowtype;
	plx_IO *plxio;
} Config;

typedef struct {
	Position x, y;
	Dimension width, height;
} sourcerect;

typedef struct {
        Boolean live;
        Boolean scale;
	Boolean squeeze;
	Boolean zoom;
	Boolean aspect;
	Boolean stillsave;
	Boolean newframe;
	Boolean factory;
	Boolean saveuser0;
	Boolean loaduser0;
	Boolean saveuser1;
	Boolean loaduser1;
	Boolean redisplay;
	Boolean resizeparent;
	short channel;
	short subchannel;
	short outputchannel;
	short windowtype;
	short inputtype;
	short inputformat;
	short outputtype;
	short outputformat;
	short flip;
	short back_white;	
	int saturation;
	int hue;
	int contrast;
	int brightness;
	int cgain;
	int lgain;
	int oldw;
	int oldh;
	int videowidth;
	int videoheight;
	int window_gravity;
        sourcerect source;
	Widget zoomwidget;
	Widget configwidget;
	Config *conf;
	plx_IO	*plxio;
	Pixmap pixmap;
	GC gc;
	Pixmap cursorpixmap;

} VideoPart;

typedef struct _VideoRec {
   CorePart core;
   VideoPart video;
} VideoRec;

typedef struct {int dummy;} VideoClassPart;

typedef struct _VideoClassRec {
   CoreClassPart core_class;
   VideoClassPart video_class;
} VideoClassRec;

extern VideoClassRec videoClassRec;

#ifdef __cplusplus
}
#endif
#endif /** _XtVVideoP_h         */
