/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: audio.h,v $
 * Revision 1.9  1996/01/19  00:52:03  drapeau
 * Fixed compilation errors for g++.
 *
 * Revision 1.8  1995/09/26  07:12:54  drapeau
 * Made the file friendly to C++ compilers.
 *
 * Revision 1.7  1993/11/19  04:48:54  drapeau
 * Added support for SVR4.  Changes too numerous to mention here.
 *
 * Revision 1.2  91/08/19  13:09:14  eric
 * added rcs header
 * 
 *
 */

#ifdef H_ID
#ifdef __cplusplus
extern "C"	{
#endif

#ifndef lint
static char *rcsid_audio_h = "@(#)$Id: audio.h,v 1.9 1996/01/19 00:52:03 drapeau Exp $ Parallax Graphics Inc";
#endif
#endif

/*
 *
 *	audio.h - Include file for audio.c
 *
 *	Written by John Malleo-Roach
 *
 */

/* CONSTANTS */

#define MAX_GAIN				100
#define DEFAULT_RECORD_GAIN  	50
#define DEFAULT_MONITOR_GAIN 	50

/* EXTERNAL VARIABLES */

extern int AudioFd;					/* File descriptor for audio device				*/
extern Window AudioXID;				/* X Window associated with AudioCanvas pw		*/
extern GC AudioGCB;					/* Graphics context with Black foreground		*/
extern GC AudioGCR;					/* Graphics context	with Red foreground			*/
extern GC AudioGCW;					/* Graphics context	with White foreground		*/
extern int AudioWidth;				/* Width of audio volume canvas					*/
extern int AudioHeight;				/* Height of audio volume canvas				*/
extern double AudioLevel;			/* Current remembered audio level				*/

/* EXTERNAL FUNCTIONS */

extern int OpenAudio();
extern Notify_value SigPollHandler();
extern int CloseAudio();
extern BOOLEAN AudioDone();
extern void UpdateAudioDisplay();
extern void AudioPanelProc();
extern void AudioRepaintProc();

/* end of audio.h */
#ifdef __cplusplus
}
#endif
