/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: None (taken from C-Cube Microsystems)
 */
#ifndef _QTabHeader_
#define _QTabHeader_
#ifdef __cplusplus
extern "C"	{
#endif

static char qtabRcsId[] = "$Id: qtab.h,v 1.4 1996/01/22 08:47:40 drapeau Exp $";

/******************************************************************************
 *                                                                          
 *  The visibility matrices are Psychovisual Weighting values from  Databook 
 *                                                                            
 ******************************************************************************/
    
static unsigned int lumaVisibility[64]={
      16, 11, 10, 16, 24, 40, 51, 61, 
      12, 12, 14, 19, 26, 58, 60, 55,
      14, 13, 16, 24, 40, 57, 69, 56,
      14, 17, 22, 29, 51, 87, 80, 62,
      18, 22, 37, 56, 68,109,103, 77,         /* Luminance Component Matrix   */
      24, 35, 55, 64, 81,104,113, 92,
      49, 64, 78, 87,103,121,120,101,
      72, 92, 95, 98,112,100,103, 99};   
                                       
static unsigned int chromaVisibility[64]={
      17, 18, 24, 47, 99, 99, 99, 99,  
      18, 21, 26, 66, 99, 99, 99, 99,     
      24, 26, 56, 99, 99, 99, 99, 99,        
      47, 66, 99, 99, 99, 99, 99, 99,         /* Chrominance Component Matrix */
      99, 99, 99, 99, 99, 99, 99, 99,        
      99, 99, 99, 99, 99, 99, 99, 99,        
      99, 99, 99, 99, 99, 99, 99, 99,        
      99, 99, 99, 99, 99, 99, 99, 99};
    

/******************************************************************************
 *      
 * The following structure defines the Define Quantization Table (DQT)
 * marker code
 *
 *****************************************************************************/

static struct {
	unsigned char 	dqt0; 
	unsigned char 	dqt1;

	unsigned char	lq0;
	unsigned char	lq1;

	unsigned char	pt0;
	unsigned char	lumaTable[64];

	unsigned char 	pt1;
	unsigned char	chromaTable[64];
} DQTmarker = {

      0xff, 0xdb, 0, 2 + 2*65,  

      0, 
      16, 11, 10, 16, 24, 40, 51, 61, 
      12, 12, 14, 19, 26, 58, 60, 55,
      14, 13, 16, 24, 40, 57, 69, 56,
      14, 17, 22, 29, 51, 87, 80, 62,
      18, 22, 37, 56, 68,109,103, 77,         /* Luminance Component Matrix   */
      24, 35, 55, 64, 81,104,113, 92,
      49, 64, 78, 87,103,121,120,101,
      72, 92, 95, 98,112,100,103, 99,

      1,
      17, 18, 24, 47, 99, 99, 99, 99,  
      18, 21, 26, 66, 99, 99, 99, 99,     
      24, 26, 56, 99, 99, 99, 99, 99,        
      47, 66, 99, 99, 99, 99, 99, 99,         /* Chrominance Component Matrix */
      99, 99, 99, 99, 99, 99, 99, 99,        
      99, 99, 99, 99, 99, 99, 99, 99,        
      99, 99, 99, 99, 99, 99, 99, 99,        
      99, 99, 99, 99, 99, 99, 99, 99
};   
                                       
#ifdef __cplusplus
}
#endif
#endif /* define _QTabHeader_ */
