/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: vaa.h,v $
 * Revision 1.12  1996/01/19  01:02:14  drapeau
 * Fixed compilation errors for g++.
 *
 * Revision 1.11  1995/09/26  07:11:10  drapeau
 * Made the file friendly to C++ compilers.
 *
 * Revision 1.10  1993/12/01  06:04:32  drapeau
 * Added support for SVR4 compilation.
 *
 * Revision 1.9  1993/11/19  04:48:54  drapeau
 * Added support for SVR4.  Changes too numerous to mention here.
 *
 * Revision 1.2  91/08/19  13:09:55  eric
 * added rcs header
 * 
 *
 */

#ifdef H_ID
#ifdef __cplusplus
extern "C"	{
#endif

#ifndef lint
static char *rcsid_vaa_h = "@(#)$Id: vaa.h,v 1.12 1996/01/19 01:02:14 drapeau Exp $ Parallax Graphics Inc";
#endif
#endif

/*
 *
 *	vaa.h - Include file for vaa.c
 *
 *	Written by John Malleo-Roach
 *
 */

/* INCLUDE FILES */

#include    <xview/xview.h>
#include    <xview/panel.h>
#include    <xview/canvas.h>
#include    <xview/scrollbar.h>
#include    <xview/textsw.h>
#include    <xview/icon.h>
#include    <xview/cms.h>
#include    <xview/cursor.h>
#include    <xview/font.h>
#include    <xview/fullscreen.h>
#include    <xview/svrimage.h>
#include    <xview/icon.h>
#include    <xview/screen.h>
#include    <xview/notice.h>
#include    <xview/notify.h>
#include	<xview/defaults.h>
#ifdef OW3
#include	<xview/dragdrop.h>
#endif
#include    <X11/Xlib.h>
#include    "rasterfile.h"
#include    <pixrect/pr_io.h>

#ifdef AUDIO
#include    <multimedia/libaudio.h>
#include    <multimedia/audio_device.h>
#ifdef SVR4
#include <multimedia/audio_encode.h>
#else
#include <multimedia/ulaw2linear.h>
#endif
#endif

#include	"Video.h"
#include	"player.h"

/* CONSTANTS */

/* #define DEBUG            /* Define this symbol for generating debuging code */
/* #define TRACE            /* Define this symbol for generating tracing output */

#define BOOLEAN     int
#ifndef FALSE
#define FALSE       0
#endif
#ifndef TRUE
#define TRUE        1
#endif

#define PANEL_DATA				1000
#define ITEM_DATA				1001

/* Constants for the audio device */

#define MAX_GAIN				100
#define DEFAULT_RECORD_GAIN  	50
#define DEFAULT_MONITOR_GAIN 	50

/* TYPEDEFS */

typedef struct {
	Xv_Window frame;
	VideoIn   video;
	Player   *player;
#ifdef OW3
	Xv_drop_site dropsite;
#endif
} Context;

/* EXTERNAL VARIABLES */

extern Display  *VAADisplay;		/* Local display, XView Screen and X11 Screen	*/
extern Xv_Screen VAAXVScreen;
extern int       VAAScreen;

extern Xv_Window VAAFrame;			/* Top level frame for VAA						*/
extern Xv_Window OutputFrame;		/* Frame for output panel						*/

extern Panel_item RecordVolume;		/* Pointer to panel item for record volume		*/
extern Panel_item MonitorVolume;	/* Pointer to panel item for monitor volume		*/
extern Panel_item FrameSpeed;		/* Pointer to panel item for frame speed		*/
extern Panel_item AudioOut;			/* Pointer to panel item for where audio goes	*/
extern Panel_item AudioIn;			/* Pointer to panel item for where audio goes	*/

extern Panel_item InterlaceButton;	/* Pointer to panel item for Deinterlace		*/
extern Panel_item VideoItem;		/* Pointer to panel item for live/still			*/
extern Panel_item FormatItem;		/* Pointer to panel item video format			*/
extern Panel_item TypeItem;			/* Pointer to panel item input type				*/

extern Panel_item FileButton;		/* Pointer to panel item for File button		*/

extern Panel_item HueItem;			/* Pointer to panel item hue adjustment			*/
extern Panel_item BrightnessItem;	/* Pointer to panel item brightness adjustment	*/
extern Panel_item ContrastItem;		/* Pointer to panel item contrast adjustment	*/
extern Panel_item SaturationItem;	/* Pointer to panel item saturation adjustment	*/

extern Context *CurrentContext;		/* Pointer to current video context				*/
extern VideoOut VideoOutput;		/* Pointer to video output object				*/

/* end of vaa.h */
#ifdef __cplusplus
}
#endif
