/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: c3dma.c,v $
 * Revision 1.12  1994/12/22  00:13:27  dave
 * added slow mb_mapalloc work around
 *
 * Revision 1.11  1993/07/13  01:42:51  rocky
 * squash update for C3Stall
 *
 * Revision 1.10  92/03/06  11:22:45  dave
 * made compatable with turbo, and took out eoi stuff
 * 
 * Revision 1.9  92/01/20  08:31:49  dave
 * fixed problem with read count
 * 
 * Revision 1.8  92/01/20  08:19:03  dave
 * fixed dma problem!!!
 * 
 * Revision 1.7  92/01/16  14:32:30  dave
 * fixed some minor stuff
 * 
 * Revision 1.6  91/12/18  14:28:29  dave
 * fixed potential timeout
 * 
 * Revision 1.5  91/10/24  15:04:36  mears
 * c3 stuff and dec stuff
 * 
 * Revision 1.4  91/09/10  13:53:58  dave
 * nochange
 * 
 * Revision 1.3  91/08/14  12:08:53  dave
 * lotsa changes
 * 
 * Revision 1.2  91/07/28  02:23:44  eric
 * new version from marty
 * 
 * Revision 1.1  91/07/11  18:00:43  eric
 * Initial revision
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: c3dma.c,v 1.12 1994/12/22 00:13:27 dave Exp dave $ Parallax Graphics Inc";
#endif

#include "xvideo.h"
#include "c3.h"
#include <stdio.h>
#include <machine/param.h>
#include "c3dma.h"

#include <sys/ioctl.h>
#include <sun/tv2io.h>

#define _Int_CCube	0x2

/*#define doerr(a1, a2)     printf("state %x: %s\n",a1,a2) */

#define SLOWALLOCS	/* support for slow mb_mapallocs on some sparcs */

static int start_addr, end_addr, xfr_count, gdmacnt;

static int timeout_flag=0;

extern k_addr;

purge_fifo()
{
	XV_WREG(CCube.l,XVC3_START_DMA_TO_HOST_1);
	XV_WREG(CCube.l,XVC3_START_DMA_TO_HOST_2);
	DELAY(1);
	XV_WREG(CCube.l, XVC3_PURGE_BIC_GO_PIO);
	DELAY(10);
	XV_WREG(CCube.l, XVC3_RESET_TO_PIO);
	DELAY(5);
}

/*
 * The following is a read from the C3, which is a compression operation.
 */

#ifdef mips
c3_start_read(dmabuf, dmacnt, unit)
#else
#ifdef SLOWALLOCS
static unsigned int canoverrun;
static unsigned int dmastopped;
extern int lastaddr;
c3_start_read(dmabuf, dmacnt, xtracount)
unsigned int xtracount;		/* amount we can go passed dmacnt */
#else
c3_start_read(dmabuf, dmacnt)
#endif
#endif
unsigned int 	*dmabuf;	/* DMA buffer address			*/
unsigned int	dmacnt;		/* DMA max transfer count (bytes)	*/
				/* ...MUST BE A MULTIPLE OF 4		*/
{
	unsigned int c3_status,xv_status;
	int i;

	/* Set initial state */

	XV_WREG(C3Stall.l,0x100);

	XV_WREG(DMASA1.l, (unsigned) (dmabuf)>>2);	
	XV_WREG(DMASA2.l, (unsigned) (dmabuf)>>2);
	XV_WREG(DMAEA1.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
	XV_WREG(DMAEA2.l, ((unsigned) dmabuf + dmacnt - 4)>>2);

	purge_fifo();

	XV_WREG(C3Stall.b.cond,STALL_H);

	start_addr = (int) dmabuf;
	gdmacnt = dmacnt;
	
	/* load the DMA buffers the same, maybe */

	XV_WREG(DMASA1.l, (unsigned) (dmabuf)>>2);	
	XV_WREG(DMAEA1.l, ((unsigned) dmabuf + dmacnt - 4)>>2);

#ifdef SLOWALLOCS
	dmastopped = 0;
	if(canoverrun = xtracount)
	{
	XV_WREG(DMASA2.l, ((unsigned) dmabuf + dmacnt)>>2);
	XV_WREG(DMAEA2.l, ((unsigned) dmabuf + dmacnt + xtracount - 4)>>2);
	}
	else
	{
#endif
	XV_WREG(DMASA2.l, (unsigned) (dmabuf)>>2);
	XV_WREG(DMAEA2.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
#ifdef SLOWALLOCS
	}
#endif

	/* start the compressor */

	C3_WREG(HV_Enable, ~0);
	C3_WREG(HV_Enable, 0);
	C3_WREG(HV_Enable, ~0);
	C3_WREG(Start, ~0);

	/* wait for the video to go active and enable interrupts */

	do
	{
	    C3_RREG(c3_status, Flags);
	} while (c3_status & _Int_VInactive);

	XV_WREG(C3Stall.b.cond,STALL_H_O_FE);

	C3_WREG(NMRQ_Enable, _Int_VInactive);
	C3_WREG(DRQ_Enable, _Int_Codec_RegBusy | _Int_FIFO_QFull);

	/* Start the DMA going */

	XV_WREG(CCube.l,XVC3_START_DMA_TO_HOST_1);
	XV_WREG(CCube.l,XVC3_START_DMA_TO_HOST_2);

	XV_WREG(IntMask.l, _Int_CCube | 0x8000);
	XV_WREG(BIntMask.l, 1);
#ifdef mips
	set_timeout(unit);
#else
	set_timeout();
#endif
	return(STATER1);
}

/*
 * The following is a write of an image to the C3.  It assumes that the 
 * specified buffer contains the complete image and that a "~0" terminates
 * the buffer.  A write to the C3 is a decompression operation.   The write
 * returns once all data has been transferred to the C3; however, the video
 * pipeline may still be busy.
 */
#ifdef mips
c3_start_write(dmabuf, dmacnt, unit)
#else
c3_start_write(dmabuf, dmacnt)
#endif
unsigned int 	*dmabuf;	/* DMA buffer address			*/
unsigned int	dmacnt;		/* DMA max transfer count (bytes)	*/
				/* ...MUST BE A MULTIPLE OF 4		*/
{
	unsigned int c3_status,xv_status,endadd;
	int pri;

	/* Set initial state */

	XV_WREG(C3Stall.l,0x140);

        XV_WREG(CCube.l,XVC3_RESET_TO_PIO);
        XV_WREG(C3Stall.b.cond,STALL_ALWAYS);

	start_addr = (int) dmabuf;
	gdmacnt = dmacnt;

	/* Load the DMA buffer address */

	XV_WREG(DMASA1.l, (unsigned) (dmabuf)>>2);	
	XV_WREG(DMASA2.l, (unsigned) (dmabuf)>>2);
#if 0
	XV_WREG(DMAEA1.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
	XV_WREG(DMAEA2.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
#else
	endadd = (((unsigned)dmabuf + dmacnt) + 15) >> 2;
	XV_WREG(DMAEA1.l, endadd);
	XV_WREG(DMAEA2.l, endadd);
#endif


	/*
	 * DRQ until FIFO is 3/4 full, then interrupt.  DRQs are
	 * disabled and an interrupt is generated if a marker code is
	 * found. 
	 */

	C3_WREG(NMRQ_Enable, _Int_FIFO_3QFull /* | _Int_MarkerCode */);
	C3_WREG(DRQ_Enable, _Int_Codec_RegBusy | _Int_FIFO_Not3QFull);

	/* 
	 * Enable interrupts in the XVideo hardware 
	 */
	XV_WREG(IntMask.l, _Int_CCube | 0x8000);
	XV_WREG(BIntMask.l, 1);

        XV_WREG(CCube.l,XVC3_START_DMA_FROM_HOST_1);
        XV_WREG(CCube.l,XVC3_START_DMA_FROM_HOST_2);

#ifdef mips
	set_timeout(unit);
#else
	set_timeout();
#endif

	return(STATEW1);
}

#ifdef SLOWALLOCS
c3_cont_dma(dmabuf, dmacnt, xtracount)
unsigned int dmabuf, dmacnt;
{

        start_addr = dmabuf;
	gdmacnt = dmacnt;

	XV_WREG(DMASA1.l, dmabuf >> 2);	
	XV_WREG(DMAEA1.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
	if(canoverrun = xtracount)
	{
	    XV_WREG(DMASA2.l, ((unsigned) dmabuf + dmacnt)>>2);
	    XV_WREG(DMAEA2.l, ((unsigned) dmabuf + dmacnt + xtracount - 4)>>2);
	}
	else
	{
	    XV_WREG(DMASA2.l, (unsigned) (dmabuf)>>2);
	    XV_WREG(DMAEA2.l, ((unsigned) dmabuf + dmacnt - 4)>>2);
	}

#if 0
	XV_WREG(C3Stall.b.cond,STALL_H_O_FE);
#endif

	C3_WREG(NMRQ_Enable, _Int_VInactive);
	C3_WREG(DRQ_Enable, _Int_Codec_RegBusy | _Int_FIFO_QFull);

	XV_WREG(CCube.l, XVC3_START_DMA_TO_HOST_1);
	XV_WREG(CCube.l, XVC3_START_DMA_TO_HOST_2);

	XV_WREG(IntMask.l, _Int_CCube | 0x8000); 
	XV_WREG(BIntMask.l, 1);

	dmastopped = 0;
}
#endif

#ifdef mips
xvbuf_int_svc(c3_state,c3_rcount, unit)
#else
xvbuf_int_svc(c3_state,c3_rcount)
#endif
unsigned int c3_state;
unsigned int *c3_rcount;
{
	unsigned int c3_status,xv_status;

	if (c3_state == STATE_ERR) return;


#ifdef NOTDEF /* this is done at beginning of int serve */

	XV_RREG(end_addr, DMARB.l);
	end_addr += 4;

	if (c3_state & STATEW) {
		XV_WREG(CCube.l, XVC3_PAUSE_DMA_FROM_HOST);
		DELAY(10);
		XV_WREG(CCube.l, XVC3_WRITE_GO_PIO);
	} else {
		XV_WREG(CCube.l, XVC3_PAUSE_DMA_TO_HOST);
		DELAY(50);
		XV_WREG(CCube.l, XVC3_PURGE_BIC_GO_PIO);
	}
	DELAY(10);

#endif
	C3_RREG(c3_status, Flags);
	C3_WREG(NMRQ_Enable, 0);
	C3_WREG(DRQ_Enable, 0);

	switch (c3_state) {
	case STATEW1:	
		/*
		 * all the data has been read from the bus...now start the
		 * decompressor and wait for the video pipe to go inactive.
		 */
		C3_WREG(HV_Enable, ~0);
		C3_WREG(HV_Enable, 0);
		C3_WREG(HV_Enable, ~0);
		C3_WREG(Start, ~0);

		XV_WREG(C3Stall.b.cond, STALL_NEVER);
		do
		{
		    C3_RREG(c3_status, Flags);
		} while ((c3_status & _Int_VInactive));

		C3_WREG(NMRQ_Enable, _Int_VInactive);
		XV_WREG(C3Stall.b.cond, STALL_FE);

		c3_state = STATEW3;
		break;

	case STATEW2:
	    {
		unsigned int timers, timernow;
		/*
		 * all the data has been read from the bus... now wait for
		 * the video pipe to go inactive.
		 */
#ifdef mips
		clear_timeout(unit);
#else
		clear_timeout();
#endif

		XV_WREG(C3Stall.b.cond, STALL_NEVER);
		XV_RREG(timers, TmrCnt.l);
		timers += 60;
		do
		{
			C3_RREG(c3_status, Flags);
			XV_RREG(timernow, TmrCnt.l);
			if((timers < 60) && (timernow > 10000))
			    timernow = 0;
		} while ((timernow < timers) &&
			     (!(c3_status & _Int_VInactive)));

		C3_WREG(HV_Enable, ~0);
		C3_WREG(HV_Enable, 0);
		C3_WREG(HV_Enable, ~0);
		C3_WREG(Start, 0);
		xfr_count = end_addr - start_addr;
		*c3_rcount = xfr_count;
		c3_state = STATE0;
		break;
	    }
#ifdef SLOWALLOCS
	case STATER1:
	case STATER2:
	    {
#if 0
		XV_WREG(C3Stall.b.cond,STALL_ALWAYS);
#endif
		dmastopped = 1;
		if(canoverrun)
		{
		    unsigned int addr, count, xc;
		    XV_RREG(end_addr, DMARB.l);
		    if(end_addr < (start_addr + gdmacnt))
		    {
			doerr(c3_state,"Interrupt took to long on read");
			c3_state = STATE_ERR;
		    }
		    break;
		}			/* else fall into default */
	    }
#endif
	default:
		/* 
		 * the buffer must have been overrun...flag the error
		 */
		doerr(c3_state,"Buffer overrun on read");
		c3_state = STATE_ERR;
		break;
	}

	if (c3_state == STATE_ERR) {
		C3_WREG(DRQ_Enable, 0);
		C3_WREG(NMRQ_Enable, 0);
		XV_WREG(CCube.l, XVC3_RESET_TO_PIO);

#ifdef mips
		clear_timeout(unit);
#else
		clear_timeout();
#endif

#ifdef NOTDEF /* this is done in library, not here */
		/*
		 * Clear out buffer, leave EOI marker code.
		 */
		* (int * ) start_addr = 0xffd90000;
		*c3_rcount = 4;
#endif
		*c3_rcount = 0;
	} else {
#ifndef SLOWALLOCS
		XV_WREG(IntMask.l, _Int_CCube | 0x8000); 
#endif
		if (c3_state & STATEW) {
#ifdef SLOWALLOCS
			XV_WREG(IntMask.l, _Int_CCube | 0x8000); 
#endif
			XV_WREG(BIntMask.l, 1);
			XV_WREG(CCube.l, XVC3_CONT_DMA_FROM_HOST_1);
			XV_WREG(CCube.l, XVC3_CONT_DMA_FROM_HOST_2);
		}
	}
	return(c3_state);
}


#ifdef mips
c3_int_svc(c3_state,c3_rcount, unit)
#else
c3_int_svc(c3_state,c3_rcount)
#endif
unsigned int c3_state;
unsigned int *c3_rcount;
{
	unsigned int c3_status,xv_status;
	unsigned int c3_mask,xv_mask;
	unsigned int xv_status2;
	unsigned int eadd;
	unsigned int i,rval,rval2;


	if (c3_state == STATE_ERR) return;

        XV_WREG(C3Stall.b.cond,STALL_ALWAYS);

	/*
	 * Temporarily stop DMA and get XV and C3 state, clearing interrupt
	 * condition.
	 */

#ifdef NOTDEF /* done at begging of int serve */
	if (c3_state & STATEW) {
		XV_WREG(CCube.l, XVC3_PAUSE_DMA_FROM_HOST);
		DELAY(10);
		XV_WREG(CCube.l, XVC3_WRITE_GO_PIO);
	} else {
		XV_WREG(CCube.l, XVC3_PAUSE_DMA_TO_HOST);
		DELAY(50);
		XV_WREG(CCube.l, XVC3_PURGE_BIC_GO_PIO);
	}
	DELAY(10);
#endif

	C3_RREG(c3_status, Flags);
	C3_WREG(NMRQ_Enable, 0);
	C3_WREG(DRQ_Enable, 0);

#ifdef mips
	clear_timeout(unit);
	set_timeout(unit);
#else
	clear_timeout();
	set_timeout();
#endif

	/*
	 * Process the interrupt depending on which state we're in.
	 */
	switch (c3_state) {
	case STATEW1:	
		if (c3_status & _Int_FIFO_3QFull) {
			/*
			 * The FIFO is now 3/4 full.  Reset the DRQ and IRQ
			 * conditions: DRQ while FIFO is not 3/4 full and 
			 * interrupt when end of buffer has been reached.
			 */

			C3_WREG(NMRQ_Enable, _Int_FIFO_NotQFull);
			C3_WREG(DRQ_Enable, _Int_Codec_RegBusy 
				| _Int_FIFO_Not3QFull);
			/*
			 * Start the decompressor.
			 */
			C3_WREG(HV_Enable, ~0);
			C3_WREG(HV_Enable, 0);
			C3_WREG(HV_Enable, ~0);
			C3_WREG(Start, ~0);

			XV_WREG(C3Stall.b.cond, STALL_NH);

			c3_state = STATEW2;
		} else {
			doerr(c3_state, "Bad Interrupt");
			*c3_rcount = 0;
			c3_state = STATE_ERR;
		}
		break;

	case STATEW2:
		/*
		* End of buffer has been reached. or the fifo is less than 1
		* quarter full.
		*/
		if(c3_status & _Int_FIFO_NotQFull)
		{
		 printf("int not q full\n");
		 /*
		 * DRQ until FIFO is 3/4 full, then interrupt.  DRQs are
		 * disabled and an interrupt is generated if a marker code is
		 * found.
		 */
		 C3_WREG(NMRQ_Enable, _Int_FIFO_3QFull /* | _Int_MarkerCode*/);
		 C3_WREG(DRQ_Enable, _Int_Codec_RegBusy | _Int_FIFO_Not3QFull);


		 c3_state = STATEW1;
		}
		else
		{
		 /*
		  * If we get here instead
		  * of processing this state in xvbuf_int_svc(), its an error. 
		  */
		 doerr(c3_state, "Bad Interrupt");
		 *c3_rcount = 0;
		 c3_state = STATE_ERR;
		}
		break;

	case STATEW3:
		/*
		 * The video pipe has gone inactive.  We need to tell the
		 * decompressor to stop so that it doesn't expect more
		 * frames.
		 */
		C3_WREG(HV_Enable, ~0);
		C3_WREG(HV_Enable, 0);
		C3_WREG(HV_Enable, ~0);
		C3_WREG(Start, 0);
		xfr_count = end_addr - start_addr;
		*c3_rcount = xfr_count;
		c3_state = STATE0;
		break;

	case STATER1:
		/* 
		 * The video pipeline is now stopped.  Now tell the C3
		 * to stop and drain the FIFO.
		 */
		if (c3_status & _Int_VInactive) {
#if 1			/* do this here, not in STATER2 */
			XV_RREG(end_addr, DMARB.l);
#ifdef SLOWALLOCS
			lastaddr = end_addr;
#endif
			xfr_count = end_addr - start_addr + 4;
#endif
			C3_WREG(HV_Enable, ~0);
			C3_WREG(HV_Enable, 0);
			C3_WREG(HV_Enable, ~0);
			C3_WREG(Start, 0);

#if 0
			C3_WREG(DRQ_Enable, _Int_Codec_RegBusy 
				| _Int_FIFO_NotEmpty);
#else
			C3_WREG(DRQ_Enable, _Int_Codec_RegBusy 
				| _Int_FIFO_NotEmpty | _Int_FIFO_Empty);
#endif
			C3_WREG(NMRQ_Enable, _Int_FIFO_Empty);

			c3_state = STATER2;
		} else {
			doerr(c3_state, "Bad Interrupt");
			*c3_rcount = 0;
			c3_state = STATE_ERR;
		}
		break;

	case STATER2:
		/*
		 * The FIFO is now empty.  Pump the Codec one more time
		 * to get the last word.  Gather stats and exit.
		if (c3_status & _Int_FIFO_Late) {
			doerr(c3_state, "Overrun Error");
			*c3_rcount = 0;
			c3_state = STATE_ERR;
		}
	 	 */
		if (c3_status & _Int_FIFO_Empty) {
			/*
			 * We're done 
			 */
#if 0	/* word count done in STATER1 not here */
			XV_RREG(end_addr, DMARB.l);
#endif
			get_last_word_r();
#if 0
			xfr_count = end_addr - start_addr + 4;
#endif
			*c3_rcount = xfr_count;
			c3_state = STATE0; 
		} else {
			doerr(c3_state, "Bad Interrupt");
			*c3_rcount = 0;
			c3_state = STATE_ERR;
		}
		break;

	default:
		doerr(c3_state,"Bad c3int state");
		*c3_rcount = 0;
		c3_state = STATE_ERR;
		break;
	}

	/* 
 	 * IF c3_state = STATE0, we're done, so clean up and get out.  
	 * Otherwise, enable interrupts and restart DMA.
	 */
	if ((c3_state == STATE0) || (c3_state == STATE_ERR)) {
		unsigned int ovr;

		C3_WREG(DRQ_Enable, 0);
		C3_WREG(NMRQ_Enable, 0);

		XV_WREG(CCube.l, XVC3_RESET_TO_PIO);
#ifdef mips
		clear_timeout(unit);
#else
		clear_timeout();
#endif
		if (c3_state==STATE_ERR) {
			*c3_rcount = 0;
		}	
	} else {
		XV_WREG(IntMask.l, _Int_CCube | 0x8000); 
		if (c3_state != STATEW3) {
			if (c3_state & STATEW) {
				XV_WREG(BIntMask.l, 1);
				XV_WREG(CCube.l, XVC3_CONT_DMA_FROM_HOST_1);
				XV_WREG(CCube.l, XVC3_CONT_DMA_FROM_HOST_2);
#ifdef SLOWALLOCS
			} else if(!dmastopped) { 
#else
			} else { 
#endif
				XV_WREG(BIntMask.l, 1);
				XV_WREG(CCube.l, XVC3_CONT_DMA_TO_HOST_1);
				XV_WREG(CCube.l, XVC3_CONT_DMA_TO_HOST_2);
			}
		}
	}
	return(c3_state);
}

doerr(state,s)
unsigned int state;
char *s;
{

	unsigned int c3_status, xv_status;
	unsigned int xv_status2;
	unsigned int c3_status2;

	XV_RREG(xv_status, IntStat.l);
	XV_RREG(xv_status2, IntStatC.l);
	C3_RREG(c3_status, Flags);
	printf("%s in state %x:  ",s,state);
	printf("C3_STATUS = %x  XV_STATUS = %x\n",c3_status, xv_status);

	C3_WREG(Flags, 0);
	C3_WREG(Flags, ~0);
	C3_WREG(Flags, 0);

}


do_marker()
{
	return(FALSE);
}


get_last_word_r()
{
	end_addr += 4;

	XV_WREG(CCube.l, XVC3_CONT_DMA_TO_HOST_1);
	XV_WREG(CCube.l, XVC3_CONT_DMA_TO_HOST_2);

	XV_WREG(CCube.l,XVC3_PURGE_C3_CONT_DMA);

	DELAY(10);
	XV_WREG(CCube.l,XVC3_PAUSE_DMA_TO_HOST);

	DELAY(10);
	XV_WREG(CCube.l,XVC3_PURGE_BIC_GO_PIO);
	XV_WREG(CCube.l,XVC3_PURGE_BIC_GO_PIO);
	DELAY(10);
	XV_WREG(CCube.l,XVC3_RESET_TO_PIO);
	DELAY(10);
	C3_WREG(DRQ_Enable,0);
}


extern c3intr();

#ifdef mips
do_timeout(unit)
#else
do_timeout()
#endif
{
	printf("do_timeout\n");

	timeout_flag = 1;

	XV_WREG(CCube.l,XVC3_PURGE_BIC_GO_PIO);
	DELAY(10);
	XV_WREG(CCube.l, XVC3_RESET_TO_PIO);
	DELAY(10);
	C3_WREG(DRQ_Enable, 0);
	C3_WREG(NMRQ_Enable, 0);

#ifdef MIPS
	service_timeout(unit);
#else
	service_timeout();
#endif
}

#ifdef mips
set_timeout(unit)
#else
set_timeout()
#endif
{
	timeout_flag = 0;
#ifdef mips
	timeout(do_timeout,unit, 500);
#else
	timeout(do_timeout,0, 500);
#endif
}

#ifdef mips
clear_timeout(unit)
int unit;
#else
clear_timeout()
#endif
{
	timeout_flag = 0;
#ifdef mips
        untimeout(do_timeout,unit);
#else
	untimeout(do_timeout,0);
#endif
}
