/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: tv2.c,v $
 * Revision 1.21  1994/12/22  00:12:19  dave
 * added slow mb_mapalloc work around
 *
 * Revision 1.20  1993/07/30  12:50:19  rocky
 * correct 1 bit unmapping
 *
 * Revision 1.19  93/07/29  19:15:58  rocky
 * updates for purvis mode
 * 
 * Revision 1.18  93/07/26  00:12:45  rocky
 * *** empty log message ***
 * 
 * Revision 1.17  93/07/23  00:48:27  rocky
 * always map maximum memory for bitplanes (1152 x 900)
 * 
 * Revision 1.16  93/07/13  01:43:42  rocky
 * squash, new FCode attributes
 * 
 * Revision 1.15  93/04/06  00:41:25  rocky
 * update status messages
 * 
 * Revision 1.14  93/03/11  00:46:32  rocky
 * new device mapping (Tex Micro, SVR4)
 * 
 * Revision 1.13  92/07/23  13:22:28  rocky
 * Updates for SBus expansion box and revision notice
 * 
 * Revision 1.12  92/03/06  11:21:09  dave
 * fixed bugs found with turbo in case they ever show up here
 * 
 * Revision 1.11  92/01/30  11:31:09  dave
 * added ifdefs for sun4e
 * 
 * Revision 1.10  92/01/29  14:23:24  dave
 * fixed crashing with no ccube
 * 
 * Revision 1.9  92/01/20  08:18:45  dave
 * fixed dma problem!!!
 * 
 * Revision 1.8  92/01/16  14:31:54  dave
 * patched as per sun and fixed compressed image degredation
 * 
 * Revision 1.7  91/12/20  15:56:12  dave
 * fixed loading with no board
 * 
 * Revision 1.6  91/11/22  14:29:18  eric
 * use include file constants
 * 
 * Revision 1.5  91/10/24  15:02:38  mears
 * ccube fixes
 * 
 * Revision 1.4  91/08/14  12:09:13  dave
 * lotsa changes
 * 
 * Revision 1.3  91/07/28  02:58:41  eric
 * misc cleanup
 * 
 * Revision 1.2  91/07/28  02:27:11  eric
 * new version from dave
 * 
 * Revision 1.1  91/07/11  18:00:43  eric
 * Initial revision
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: tv2.c,v 1.21 1994/12/22 00:12:19 dave Exp dave $ Parallax Graphics Inc";
#endif

/*
 * Copyright 1991 by Parallax Graphics, Inc.
 */

/*
 * Color frame buffer with video io (tv2) driver
 */

#include "xvideo.h"
#include "tvtwo.h"
#include "plxv.h"
#include "win.h"
#include "release.h"

#include <sys/param.h>
#include <sys/errno.h>
#include <sys/ioctl.h>
#include <sys/map.h>
#include <sys/user.h>
#include <sys/vmmac.h>
#include <sys/buf.h>
#include <sys/conf.h>
#include <sys/buf.h>
#include <sys/uio.h>

#include <machine/enable.h>
#include <machine/pte.h>
#include <machine/psl.h>

#include <sun/vddrv.h>
#include <sun/openprom.h>
#include <sun/fbio.h>
#include <sun/tv2io.h>

#include <sundev/mbvar.h>

#include <pixrect/pixrect.h>
#include <pixrect/pr_planegroups.h>
#include <pixrect/tv2var.h>

#include "c3.h"
#include "c3dma.h"

#define BUSTYPE 1

/* #define	TV2_DEBUGGING /* */
#ifdef	TV2_DEBUGGING
int tv2_debug = 1;
#define DEBUG_PRT(x)	printf x
#else
int tv2_debug = 0;
#define DEBUG_PRT(x)
#endif


#define BAD_TV2(x) {trial_count = (x) ; goto bad_tv2;}


/* convert the offset to a pte */
#ifdef sun4c
#define TV2_PHYS_ADDR		(softc->tv2_physical)
#define TV2_PHYS(p)    (TV2_PHYS_ADDR + (p))
#define TV2_PHYSICAL(p)    (PGT_OBIO + btop(TV2_PHYS_ADDR + (p)))
#endif

/* same as above, except for a SUN4e..... with 4.1 OS */
#ifdef sun4e

#define TV2_PHYS_ADDR		(softc->tv2_physical)
#define TV2_PHYS(p)    (TV2_PHYS_ADDR + (p))
#define TV2_PHYSICAL(p)    (PGT_OBIO + btop(TV2_PHYS_ADDR + (p)))
#define dvmamap mb_hd.mh_map

#endif

/* same as above, except for a SUN4m..... with 4.1.2 OS */
#ifdef sun4m

#define TV2_PHYS_ADDR		(softc->tv2_physical)
#define TV2_PHYS(p)    (TV2_PHYS_ADDR + (p))
#define TV2_PHYSICAL(p)    (MAKE_PGT(0xE) + btop(TV2_PHYS_ADDR + (p)))

#endif

/* same as above, except for a SUN4r..... not tested yet */
#ifdef sun4r

#define TV2_PHYS_ADDR		(softc->tv2_physical)
#define TV2_PHYS(p)    (TV2_PHYS_ADDR + (p))
#define TV2_PHYSICAL(p)    (PTE_DSI_PPN(DSI_SBUS,btop(TV2_PHYS_ADDR + (p))))

#endif

extern int nodev();
extern int spec_segmap();
extern XV_struct *plxv_init_drvr();

XV_shdw_regs xv_shdwregs;
XV_shdw_regs *xv_shdw = &xv_shdwregs;
XV_write_regs *xv_wreg;
XV_read_regs  *xv_rreg;

C3_WREGS *c3_wreg;
C3_RREGS *c3_rreg;
unsigned int k_addr;	/* address of dma buffer in driver space */

#define ATTMAGIC 0x12345678

static int BIntStat,IntStat;
static unsigned int ladd;

#define SLOWALLOCS	/* support for slow mb_mapallocs on some sparcs */

#ifdef SLOWALLOCS
#define ALLOCSIZE 32768 /* */
/* #define ALLOCSIZE 65536 /* */
static int slowmallocflag = 0;
#endif

static struct addr_table {
    u_int           vaddr;
    u_int           paddr;
    int             size;
} addr_table[] = {
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
    0, 0, 0,
};

#define ADDR_TABLE_SIZE	7

/* driver per-unit data */

#define TV2_CMAP_SIZE 256
#define TV2_OMAP_SIZE 4

static struct tv2_softc {
    int             w,
                    h;		       /* resolution */
    int             bit24size;	       /* total size of 24 bit frame buffer */
    int		    bit8size;	       /* total size of 8 bit frame buffer */
    int             bit1size;	       /* total size of 1 bit frame buffer */
    struct proc     *owner;	       /* owner of the frame buffer */
    struct fbgattr  gattr;	       /* current attributes */
    u_long          tv2_physical;      /* board physical base address */
    int		    int_pri;		/* interrupt priority		  */
    int		    attached;		/* we were attached		 */
    XV_struct       *tv2_xvstrp;	/* structure returned by hardware */
					/* has pointers below */
#ifdef NOTDEF
    rw_regs	    *register_base;    /* board registers base address */
    long            *bit1ptr;	       /* 1 bit frame buffer base address */
    long            *bit24ptr;	       /* 24 bit frame buffer base address */
    char	    *bit8ptr;	       /* 8 bit frame buffer base address */
    long	    *ccubeptr;	       /* ccube register base address */
#endif

    int		    blank;		/* blank or not */
    int		    dmastate;		/* dma / interupt state */
    caddr_t	    fb[TV2_NFBS];	/* ponters to frame buffer sections */
    union fbunit    omap_rgb[TV2_OMAP_SIZE];
    struct buf	    dmabuf;	       /* buffer struct for dma */
#if NWIN > 0
    Pixrect         pr;
/*
    struct tv2_data tv2d;
*/
    struct cg4_data cgd;

#endif NWIN > 0
} tv2_softc[NTVTWO];


#define	TV2_PROBESIZE	(NBPG)

/* Mainbus device data */
int		tvtwoidentify(), tvtwoattach();
int		tvtwoopen(), tvtwoclose(), tvtwommap(), tvtwoioctl();
int		tvtworead(), tvtwowrite();

static void	tvtwostrategy(), tvtwominphys(); 
int 		tvtwointr();

static struct device_info *tvtwoinfo[NTVTWO];

struct dev_ops tvtwo_ops = {
	1, tvtwoidentify, tvtwoattach,
};

extern int seltrue();

static struct cdevsw tv2_pr_ops = {
	tvtwoopen,	tvtwoclose,	tvtworead,	tvtwowrite,
	tvtwoioctl,	nodev,		nodev,		tvtwommap,
	0,		spec_segmap,
};

static struct vdldrv tvtwo_vdldrv = {
	VDMAGIC_DRV,
	"tvtwo",
	&tvtwo_ops,
	0,
	&tv2_pr_ops,
	0,
	0,
};


/* default structure for FBIOGTYPE ioctl */

static struct fbtype tv2typedefault = {
/*	type           h  w  depth cms size */
    FBTYPE_SUN4COLOR, 0, 0, 8, 256, 0
};

/* default structure for FBIOGATTR ioctl */
static struct fbgattr tv2attrdefault = {
/*	real_type         owner */
    FBTYPE_NOTSUN1, 0,
/* fbtype: type             h  w  depth cms  size */
    {FBTYPE_NOTSUN1, 0, 0, 32, 256, 0},
/* fbsattr: flags           emu_type       dev_specific */
    {0, FBTYPE_NOTSUN1, {0}},
/*        emu_types */
    {FBTYPE_SUN4COLOR, -1, -1, -1}
};

/* frame buffer description table */
static struct cg4_fbdesc {
        short   depth;                  /* depth, bits */
        short   group;                  /* plane group */
        int     allplanes;              /* initial plane mask */
} cg4_fbdesc[CG4_NFBS + 1] = {
        { 1, PIXPG_OVERLAY,               0 },
        { 1, PIXPG_OVERLAY_ENABLE,        0 },
        { 8, PIXPG_8BIT_COLOR,          255 }
};

#define	TV2_FBINDEX_OVERLAY	0
#define TV2_FBINDEX_ENABLE	1
#define	TV2_FBINDEX_COLOR	2

/* initial active frame buffer */
#ifndef	TV2_INITFB
#define	TV2_INITFB	TV2_FBINDEX_COLOR
#endif

#if NWIN > 0

/* SunWindows specific stuff */

static cg4_putattributes(pr, planesp)
	Pixrect *pr;
	int *planesp;
{
	register int planes;
	register struct cg4_data *cgd;
	register int group;

	if (planesp == 0)
		return 0;

	planes = *planesp;
        /*
         * for those call putattributes with ~0.  This can be better
         * handled if the check for PIX_DONT_SET_PLANE is inverted.   
         */
        if (planes == ~0)
                planes &= ~PIX_DONT_SET_PLANES; 
	cgd = cg4_d(pr);

	/*
	 * If user is trying to set the group, look for the frame
	 * buffer which implements the desired group and make it
	 * the active frame buffer.
	 */
	group = PIX_ATTRGROUP(planes);
	if (group == PIX_GROUP_MASK)
		planes &= PIX_ALL_PLANES;
	if (group != PIXPG_CURRENT || group == PIXPG_INVALID) {
		register int active;
		register struct cg4fb *fbp;
		int	cmsize;

		for (active = 0, fbp = cgd->fb; 
			active < CG4_NFBS; active++, fbp++)
			if (group == fbp->group) {
				cgd->planes = PIX_GROUP(group);
				cgd->active = active;

				if (!(planes & PIX_DONT_SET_PLANES))
					fbp->mprp.planes = 
						planes & PIX_ALL_PLANES;

				cgd->mprp = fbp->mprp;
				cgd->planes |= fbp->mprp.planes;
				pr->pr_depth = fbp->depth;
/*
				cmsize = (pr->pr_depth==8) ? 256 : 2;
				(void) cg4_ioctl(pr, FBIOSCMSIZE, (caddr_t)&cmsize);
*/
				return 0;
			}
	}

	/* set planes for current group */
	if (!(planes & PIX_DONT_SET_PLANES)) {
		planes &= PIX_ALL_PLANES;
		cgd->planes = (cgd->planes & ~PIX_ALL_PLANES) | planes;
		cgd->mprp.planes = planes;
		cgd->fb[cgd->active].mprp.planes = planes;
	}

	return 0;
}

/* kernel pixrect ops vector */
struct pixrectops tv2_ops = {
    mem_rop,
    tv2_putcolormap,
    cg4_putattributes,
    0,
};

tv2_putcolormap(pr, index, count, red, green, blue)
	Pixrect *pr;
	unsigned int index, count;
	unsigned char *red, *green, *blue;
{
	register u_int rindex = (u_int) index;
	register u_int rcount = (u_int) count;
	register u_int entries;

	entries = TV2_CMAP_SIZE;

	/* check arguments */
	if ((rindex >= entries) || ((rindex + rcount) > entries))  {
		return PIX_ERR;
	}

	if (rcount == 0)
		return 0;

	plxv_load_clts(0, index , count, red, green, blue);

	return 0;
}
#endif NWIN > 0

static int dididentify = 0;
static int tvtwoidentify(name)
char *name;
{
	if(strcmp(name, "PGI,tvtwo") == 0)
	{
		DEBUG_PRT(("leaving identify, accepted\n"));
		return (dididentify = 1);
	}
	DEBUG_PRT(("leaving identify, %s rejected\n", name));
	return 0;
}

static long slot = 1;

static int do_mapping(md, softc)
register struct dev_info *md;
register struct tv2_softc *softc;
{
    register struct dev_reg *dvrp;
    long *reg, id0, id1;
    int trial_count, i;
    int pages1;
    register caddr_t fbaddr;
    long poke_value;
    unsigned long slotaddr;
    int *m1;
    char *m8;
    int *m24;
    int *c3;
    int *ep;
    int Xsize, Ysize;
    char *retval;
    char freqcode;

    softc->blank = 1;

    if((md == NULL) || (md->devi_nreg == 0) || (md->devi_reg == 0))
    {
	/* if you're in here, all bets are off... */

	printf("tvtwo driver warning -- md or reg was NULL\n");

	for(slot = 1, slotaddr = 0xfa000000; slot < 4; ++slot)
	{
	    softc->tv2_physical = slotaddr;
	    reg = (long *) map_regs(TV2_PHYS(REGBASE), REGSIZE, BUSTYPE);
	    if(reg == 0)
		goto badmap;

    	    xv_wreg = (XV_write_regs *) reg;
    	    xv_rreg = (XV_read_regs *) reg;

	    if(peekl(&xv_rreg->BIntStatC, &id0) >= 0)
		break;

	    slotaddr += 0x2000000;
	}
	if(slot == 4)
	{
	    softc->tv2_physical = 0xfa000000;
	    goto peekfail;
	}
    }
    else
    {
        dvrp = md->devi_reg;
/*
	printf("do_mapping: regaddr = %x, bustype = %d\n",
		dvrp->reg_addr, dvrp->reg_bustype);

	printf("REGBASE,M24BASE = 0x%x 0x%x\n",REGBASE,M24BASE);
*/
	softc->tv2_physical = (unsigned long) dvrp->reg_addr;
/*
	printf("number of register areas = %d\n",md->devi_nreg);
*/
	if(md->devi_nreg == 1) /* new Boot PROM (2.02 and above) */
	{
	    reg = (long *) map_regs(TV2_PHYS(REGBASE),
				REGSIZE, dvrp->reg_bustype);
	}
	else
	{
/*	    the address we get is the base + the register offset so phys 0 */

	    reg = (long *) map_regs(TV2_PHYS(0), REGSIZE, dvrp->reg_bustype);
	}

	if(reg == 0)
	{
badmap:	    printf("map_regs failed\n");
	    return(-1);
	}

    	xv_wreg = (XV_write_regs *) reg;
    	xv_rreg = (XV_read_regs *) reg;

	if(peekl(&xv_rreg->BIntStatC, &id0) < 0)
	{
peekfail:   printf("tv2probe: peek failed\n");
	    return -1;	/* peek failed */
	}
    }

#ifdef NOTDEF
    softc->register_base = (rw_regs *) reg;
#endif

    if(md->devi_nreg != 1) /* old Boot PROM (up thru 2.01) */
    {
    	softc->tv2_physical -= REGBASE;
	printf("XVideo Physical Address = 0x%x\n",TV2_PHYS_ADDR);
    }
    else
    {
	printf("XVideo Physical Address = 0x%x (*)\n",TV2_PHYS_ADDR);
    }

    /* get screen dimension properties from FCode */
    /* (get freqcode attribute) */

    if(md == NULL)
    {
	printf("XVideo not in device tree, freqcode default = 1\n");
	freqcode = '1';
    } 
    else
    {
	/* grab the FCode attribute */
	retval = (char *)getlongprop(md->devi_nodeid,"freqcode");
	if(retval == NULL)
	{
	    /* pre-squash, no frequency code in Boot PROM */
/*
	    printf("X,Y Size = 1152,900\n");
*/
	    freqcode = '1';
	}
	else
	{
/*
	    printf("freqcode = %c\n",retval[0]);
*/
	    freqcode = retval[0];
	}
    }

    switch(freqcode)
    {
	case '1':
	case '2':
	case '3':
	default:
	    Xsize = 1152;
	    Ysize = 900;
	    break;
	case '4':
	    Xsize = 1024;
	    Ysize = 768;
	    break;
	case '5':
	    Xsize = 640;
	    Ysize = 480;
	    break;
    }

/* can't put this in case statement??? */

    if(freqcode == 'g')
    {
	    Xsize = 1024;
	    Ysize = 1024;
    }

    printf("XVideo Screen Resolution %d x %d\n",Xsize,Ysize);

/*
    if(TV2_PHYS_ADDR & 0xffffff) printf("XVideo installed in SEC\n");
*/

/* squash */
    /* got the screen resolution, pass to server thru softc */
    softc->w = Xsize;
    softc->h = Ysize;

    /* get enough to map in a one-bit plane (btoc round up to PAGESIZE) */

/* squash */
    if(softc->h == 480)softc->w = 1024;

    pages1 = btoc (mpr_linebytes (softc->w, 1) * softc->h);

    softc->bit1size = ctob (pages1);    /* get back # of bytes */
    softc->bit24size = ctob(btoc (mpr_linebytes (softc->w, 32) * softc->h));
    softc->bit8size = ctob(btoc (mpr_linebytes (softc->w, 8) * softc->h));

/* squash */
	softc->bit1size  = 0x20000;
	softc->bit24size = 0x400000; 
	softc->bit8size  = 0x100000;

/*
printf("1,8,24 bit sizes: %d %d %d\n",
	softc->bit1size,softc->bit8size,softc->bit24size);
*/
/* squash */
    if(softc->h == 480)softc->w = 640;

#ifdef NOTDEF
    softc->bit1ptr = (long *) 0;
    softc->bit8ptr = (char *) 0;
    softc->bit24ptr = (long *) 0;
#endif

    m24 = ep = NULL;    /* m24 and eprom are nulls */

    /* map frame buffer sections */

    /*
    * tv2 is too big for kernel to handle, we'll mapin one by one and
    * poke the selected few addresses.
    */
    /*
    * what we are doing first is mapping the 24bit and 1 bit maps
    * and peek/poking them to make sure they are there, then
    * mapping the 8 bit, testing, and leaving it mapped if it's there
    */

    /* map the 24 bit map */

    fbaddr = (caddr_t)map_regs(TV2_PHYS(M24BASE), ctob(pages1),
				dvrp->reg_bustype);
    if (fbaddr == NULL || peekl ((long *) fbaddr, &poke_value) ||
      pokel ((long *) fbaddr, ~poke_value) ||
      pokel ((long *) fbaddr, poke_value)) /* restore old value */
	BAD_TV2(0);
    unmap_regs(fbaddr, ctob(pages1));



    /* now map the 8 bit map */

    fbaddr = (caddr_t) map_regs(TV2_PHYS(M8BASE), softc->bit8size,
				dvrp->reg_bustype);
    if (fbaddr == NULL || peekl ((long *) fbaddr, &poke_value) ||
      pokel ((long *) fbaddr, ~poke_value) ||
      pokel ((long *) fbaddr, poke_value)) /* restore old value */
	BAD_TV2(1);
    m8 = (char *) fbaddr;

    /* now map the one bit map */

/* squash */
/*    fbaddr = (caddr_t) map_regs(TV2_PHYS(M1BASE), ctob(pages1), */
    fbaddr = (caddr_t) map_regs(TV2_PHYS(M1BASE), softc->bit1size,
				dvrp->reg_bustype);
    if (fbaddr == NULL || peekl ((long *) fbaddr, &poke_value) ||
      pokel ((long *) fbaddr, ~poke_value) ||
      pokel ((long *) fbaddr, poke_value)) /* restore old value */
	BAD_TV2(2);
    m1 = (int *) fbaddr;
    softc->fb[0] = softc->fb[1] = (caddr_t) fbaddr;
    softc->fb[2] = (caddr_t) m8;


    fbaddr = (caddr_t) map_regs(TV2_PHYS(C3BASE), C3SIZE,
				dvrp->reg_bustype);
    c3 = (int *) fbaddr;

    softc->tv2_xvstrp = plxv_init_drvr(reg, m1, m8, m24, c3, ep);
/*
    printf("softc xv x,y = %d %d \n",
	softc->tv2_xvstrp->main.xsize,
	softc->tv2_xvstrp->main.ysize);
*/
    softc->owner = NULL;
    softc->gattr = tv2attrdefault;
    softc->gattr.fbtype.fb_height = softc->h;
    softc->gattr.fbtype.fb_width = softc->w;
    softc->gattr.fbtype.fb_size = softc->bit24size;

    addr_table[0].vaddr = (u_int)TV2_VADDR_REG;
    addr_table[0].paddr = (u_int)REGBASE;
    addr_table[0].size = REGSIZE;
    addr_table[1].vaddr = (u_int)TV2_VADDR_PROM;
    addr_table[1].paddr = (u_int)PROMBASE;
    addr_table[1].size = PROMSIZE;
    addr_table[2].vaddr = TV2_VADDR_C3;
    addr_table[2].paddr = (u_int)C3BASE;
    addr_table[2].size = C3SIZE;
    addr_table[3].vaddr = (u_int) 0 /* TV2_VADDR_FB1 */;
    addr_table[3].paddr = (u_int)M1BASE;
    addr_table[3].size = softc->bit1size;
    addr_table[4].vaddr = addr_table[3].vaddr + addr_table[3].size;
    addr_table[4].paddr = (u_int)M1BASE;
    addr_table[4].size = softc->bit1size;
    addr_table[5].vaddr = addr_table[4].vaddr + addr_table[4].size;
    addr_table[5].paddr = (u_int)M8BASE;
    addr_table[5].size = (0x100000) /* softc->bit8size */;
    addr_table[6].vaddr = TV2_VADDR_FB24;
    addr_table[6].paddr = (u_int)M24BASE;
    addr_table[6].size = softc->bit24size;

    DEBUG_PRT(("vaddr for fb8 = %x\n", addr_table[5].vaddr));
    DEBUG_PRT(("vaddr for fb24 = %x\n", addr_table[6].vaddr));

    return(0);
bad_tv2:
    /* this section missing, map out everything */
    printf (("tvtwoprobe: map %d failed to respond\n", trial_count));
    return (-1);
}

int tvtwoinit(command, vdp, vdi, vds)
int command;
struct vddrv *vdp;
struct vdioctl_load *vdi;
struct vdstat *vds;
{
    struct vdconf *vdcp;
    char *sp;
    int pages1, err, id0, id1;
    register struct tv2_softc *softc = &tv2_softc[0];
    switch(command)
    {
	case VDLOAD:
	    DEBUG_PRT(("init: VDLOAD\n"));
#ifdef NOTDEF
    	    softc->bit8ptr = NULL;
    	    softc->bit1ptr = NULL;
    	    softc->register_base = NULL;
#endif
	    if(vdi)
	    {
		if(vdcp = vdi->vdi_userconf)
		{
		    while(vdcp->vdc_type != VDCEND)
		    {
			switch(vdcp->vdc_type)
			{
			    case VDCCONTROLLER:
				sp = "VDCCONTROLLER";
				break;
			    case VDCDEVICE:
				sp = "VDCDEVICE";
				break;
			    case VDCBLOCKMAJOR:
				sp = "VDCBLOCKMAJOR";
				break;
			    case VDCCHARMAJOR:
				sp = "VDCCHARMAJOR";
				break;
			    case VDCSYSCALLNUM:
				sp = "SYSCALLNUM";
				break;
			    default:
				sp = "SWITCH ERROR!";
				break;
			}
			DEBUG_PRT(("vdc_type: %d %s %s 0x%x\n", vdcp->vdc_type,
				  sp, "vdc_data", vdcp->vdc_data));
			vdcp++;
		    }
		}
		else
		    DEBUG_PRT(("no config info, vdi_userconf is NULL\n"));
	    }
    	    /* map frame buffer sections if identify was not run */
#ifdef NOTDEF
	    if(dididentify == 0)
	    {
	        if(err = do_mapping(NULL, softc))
		    DEBUG_PRT(("do_mapping returns %d\n", err));
	    }
#endif
	    vdp->vdd_vdtab = (struct vdlinkage *) &tvtwo_vdldrv;
	    return(0);
	case VDUNLOAD:
	    DEBUG_PRT(("init: VDUNLOAD\n"));
	    if(softc->attached == ATTMAGIC)
	    {
	      if(softc->tv2_xvstrp->m8base)
    		unmap_regs(softc->tv2_xvstrp->m8base, softc->bit8size);
	      if(softc->tv2_xvstrp->m1base)
    		unmap_regs(softc->tv2_xvstrp->m1base, softc->bit1size);
	      if(softc->tv2_xvstrp->regbase)
    		unmap_regs(softc->tv2_xvstrp->regbase, REGSIZE);
	      if(softc->tv2_xvstrp->c3base)
    		unmap_regs(softc->tv2_xvstrp->c3base, 0x10000);
#ifndef sun4e
	      if(softc->int_pri);
		remintr(softc->int_pri, tvtwointr);
#endif
	    }
	    return(0);
	case VDSTAT:
	    DEBUG_PRT(("init: VDSTAT\n"));
	    return(0);
	default:
	    DEBUG_PRT(("init: BAD COMMAND!!"));
	    return (1);
    }
}

extern dev_t fbdev;

static dev_t makefbdev(unit)
int unit;
{
	extern int nchrdev;
	register int i;

/* look backwords through the table since we must be near the end */

	for(i = nchrdev - 1; i >= 0; --i)
	{
	    if(cdevsw[i].d_open == tvtwoopen)
	    {
		DEBUG_PRT(("found major dev. no %d\n", i));
		return(makedev(i, unit));
	    }
	}
	return fbdev;
}

#ifdef SLOWALLOCS
static char tb[64 * 1024];
#endif

tvtwoattach (md)
    register struct dev_info *md;
{
    register struct tv2_softc *softc = &tv2_softc[md->devi_unit];
    int err;
    char *retval;

    DEBUG_PRT (("tvtwoattach:\n"));

    DEBUG_PRT(("attach: dvi_nreg = %d, dvi_reg = %x, devi_unit = %d\n",
		md->devi_nreg, md->devi_reg, md->devi_unit));

    /* get revision property from FCode */

    if(md == NULL)
    {
	printf("XVideo not in device tree, no revision determined!\n");
    } 
    else
    {
	retval = (char *)getlongprop(md->devi_nodeid,"revision");
	if(retval == NULL)
	{
	    printf("XVideo Boot PROM Revision 2.00 1/14/92\n");
	}
	else
	{
	    printf("XVideo Boot PROM Revision %s\n",retval);
	}
    }
    printf("XVideo Device Driver Release %s",RELEASE);

#ifdef sun4c
    printf(" (sun4c)\n");
#endif sun4c

#ifdef sun4m
    printf(" (sun4m)\n");
#endif sun4m

    err = do_mapping(md, softc);
    if(err) return(err);
    if(md->devi_nintr)
    {
	DEBUG_PRT(("adding interrupt\n"));
	adddma(md->devi_intr->int_pri);
	addintr(md->devi_intr->int_pri,tvtwointr,md->devi_name,md->devi_unit);
	softc->int_pri = md->devi_intr->int_pri;
    }

    if((fbdev < 0) || (fbdev == 22))
	fbdev = makefbdev(md->devi_unit);

    plxv_inc_powerups();
    plxv_set_hourint();
    plxv_inc_hours();

#if defined(SLOWALLOCS) && !defined(FORCE)
	{
	    unsigned int stime, etime;
	    struct buf *bp;
	    caddr_t tbuf;
	    bp = &softc->dmabuf;
	    bp->b_un.b_addr = (caddr_t) tb;
	    bp->b_bcount = 64 * 1024;
	    plxv_switch_context(softc->tv2_xvstrp);
	    stime = plxv_read_timer();
	    bp->b_mbinfo = mb_mapalloc(dvmamap, bp,0,((int (*)())0),(caddr_t)0);
	    etime = plxv_read_timer();
	    mb_mapfree(dvmamap, &bp->b_mbinfo);
	    if(etime < stime)
	    {
		etime += (0 - stime);
		stime = 0;   
	    }
	    if(((etime - stime) / 90) > 3)
	    {
		slowmallocflag = 1;
		printf("XVideo slow mapping workaround enabled\n");
	    }
	    else
	    {
		slowmallocflag = 0;
		printf("XVideo slow mapping workaround disabled\n");
	    }
	}
#else
#ifdef FORCE	/* no slow mapping on force machines */
	slowmallocflag = 0;
	printf("XVideo slow mapping workaround defeated\n");
#endif
#endif
    report_dev(md);
    softc->attached = ATTMAGIC;
    return(err);
}

do_coef(xv)
XV_struct *xv;
{
	
/* crashing the computer when no c3 is present */

	/* Load DCT coefficients */

	plxv_switch_context(xv);

	C3_WREG(DCT[0],0x00005A82);
	C3_WREG(DCT[1],0x00007FFF);
	C3_WREG(DCT[2],0x000030FC);
	C3_WREG(DCT[3],0x00007642);
	C3_WREG(DCT[4],0x00005A82);
	C3_WREG(DCT[5],0x00007FFF);
	C3_WREG(DCT[6],0x000030FC);
	C3_WREG(DCT[7],0x00007642);
	C3_WREG(DCT[9],0x00000000);
}

static void pxv_initc3(xv)
XV_struct *xv;
{

	if(xv->main.c3_rev < 1)
	    return;

	plxv_switch_context(xv);

	XV_WREG(C3Stall.l, 0x140);
	C3_WREG(S_reset, ~0);
	do_coef(xv);
}

tvtwoopen (dev, flag)
    dev_t           dev;
    int             flag;
{
	u_char unit_no;

	struct tv2_softc *softc;
	int i;

	DEBUG_PRT (("tvtwoopen: called minor = %d, flag = %d\n",
		    minor (dev), flag));
	/*
	 * Initialize the CL550
	 */

	unit_no = minor(dev);
	softc = &tv2_softc[unit_no];

	pxv_initc3(softc->tv2_xvstrp);

	return(0);
}

/*ARGSUSED*/
tvtwoclose (dev, flag)
    dev_t           dev;
    int             flag;
{
    DEBUG_PRT (("tvtwoclose: called minor = %d, flag = %d\n",
		minor (dev), flag));
    return 0;
}

/*ARGSUSED*/
tvtwommap (dev, off, prot)
    dev_t           dev;
    off_t           off;
    int             prot;
{
    register struct tv2_softc *softc = &tv2_softc[minor (dev)];
    register int    i;
    register struct addr_table *tbl;

    if (off >= 0 && off < softc->bit1size)	    /* bw2 emulation */
	return TV2_PHYSICAL(off + M1BASE);

    for (i = 0, tbl = addr_table; i < ADDR_TABLE_SIZE; i++, tbl++) 
	if (off >= tbl->vaddr && off < (tbl->vaddr + tbl->size)) {
	    off -= tbl->vaddr;
	    break;
	}

    return i < ADDR_TABLE_SIZE ? TV2_PHYSICAL ((u_int) off + tbl->paddr) : -1;

}

/*ARGSUSED*/
tvtwoioctl (dev, cmd, data, flag)
    dev_t           dev;
    int             cmd;
    caddr_t         data;
    int             flag;
{
    static struct buf *dmap = NULL;
    register struct tv2_softc *softc = &tv2_softc[minor (dev)];

    plxv_switch_context(softc->tv2_xvstrp);

#   ifdef TV2_DEBUGGING
    DEBUG_PRT ( ("tvtwoioctl: cmd = "));
    switch (cmd) {
    case FBIOSATTR: DEBUG_PRT ( ("FBIOSATTR\n")); break;
    case FBIOGATTR: DEBUG_PRT ( ("FBIOGATTR\n")); break;
    case FBIOGETCMAP: DEBUG_PRT ( ("FBIOGETCMAP\n")); break;
    case FBIOPUTCMAP: DEBUG_PRT ( ("FBIOPUTCMAP\n")); break;
    case FBIOGTYPE: DEBUG_PRT ( ("FBIOGTYPE\n")); break;
    case FBIOGINFO: DEBUG_PRT ( ("FBIOGINFO\n")); break;
    case FBIOGPIXRECT: DEBUG_PRT ( ("FBIOGPIXRECT\n")); break;
    case FBIOSVIDEO: DEBUG_PRT ( ("FBIOSVIDEO\n")); break;
    case FBIOGVIDEO: DEBUG_PRT ( ("FBIOGVIDEO\n")); break;
    case TV2REDIRFB: DEBUG_PRT ( ("TV2REDIRFB\n")); break;
    default: DEBUG_PRT ( ("not supported (0x%x)\n", cmd)); break;
    }
#   endif TV2_DEBUGGING
/*
if((cmd & 0xf000) == 0xf000)
{
	XV_WREG(C3Stall.l,cmd & 0xfff);
}
*/
    switch (cmd) {
    case TV2REDIRFB:
	fbdev = dev;
	break;
    case FBIOGETCMAP:
    case FBIOPUTCMAP:
	    {
		struct	fbcmap	*cmap = (struct fbcmap *) data;
		u_int		index = (u_int) cmap->index;
		u_int		count = (u_int) cmap->count;
		int		pgroup = PIX_ATTRGROUP (index);
		union	fbunit	*map;
		u_int		entries;
		int		i, j, type;
		u_char          tmp[3][TV2_CMAP_SIZE];


		if (count == 0 || !cmap->red || !cmap->green || !cmap->blue)
		    return 0;

		/* The most significant 7 bits is the group number. */
		switch (pgroup) {
		case 0:
		case PIXPG_8BIT_COLOR:
		    type	= 0;
		    entries	= TV2_CMAP_SIZE;
		    break;
		case PIXPG_24BIT_COLOR:
		    type	= 1;
		    entries	= TV2_CMAP_SIZE;
		    break;
		case PIXPG_OVERLAY:
		    type	= 2;
		    map		= softc->omap_rgb;
		    entries	= TV2_OMAP_SIZE;
		    break;
		default:
		    return EINVAL;
		}

		if ((index &= PIX_ALL_PLANES) >= entries ||
		    index + count > entries)
		    return EINVAL;

		if (cmd == FBIOPUTCMAP)
		{

		    DEBUG_PRT(("user putcmap\n",0));
		    if (copyin((caddr_t)cmap->red,(caddr_t)tmp[0],count) ||
			copyin((caddr_t)cmap->green,(caddr_t)tmp[1],count)||
			copyin((caddr_t)cmap->blue,(caddr_t)tmp[2],count))
			    return EFAULT;
 
		    if(type < 2)
		    {
			plxv_load_clts(type, index , count,
				tmp[0], tmp[1], tmp[2]);
			return 0;
		    }
		    
		    for (i=0,map+=index; count; i++,count--,map++)
			map->packed =
			    tmp[0][i]|(tmp[1][i]<<8)|(tmp[2][i]<<16);

		    plxv_colors_1(softc->omap_rgb[3].packed | (PLXV_TAG_TRUE_COLOR << 24),
				  softc->omap_rgb[1].packed | (PLXV_TAG_TRUE_COLOR << 24),
				  PLXV_WMASK_ALL);
		    plxv_wmask(PLXV_WMASK_ALL);
		     
		    break;
		}
		else  		       /* FBIOGETCMAP */
		{
		    if(type == 2)
		    {         
			for (i=0; i<count; i++,index++)
			{     
			    tmp[0][i] = softc->omap_rgb[index].channel.R;
			    tmp[1][i] = softc->omap_rgb[index].channel.G;
			    tmp[2][i] = softc->omap_rgb[index].channel.B;
			}     
		    }         
		    else      
		    {         
			plxv_read_clts(type, index , count,
					tmp[0], tmp[1], tmp[2]);

		    }         
		    if (copyout((caddr_t)tmp[0],(caddr_t)cmap->red,count) ||
			copyout((caddr_t)tmp[1],(caddr_t)cmap->green,count) ||
			copyout((caddr_t)tmp[2],(caddr_t)cmap->blue,count))
			return EFAULT;
		    break;
		}
	    }
    case FBIOSATTR:{
	    register struct fbsattr *sattr = (struct fbsattr *) data;

#ifdef ONLY_OWNER_CAN_SATTR
	    /* this can only happen for the owner */
	    if (softc->owner != u.u_procp)
		return ENOTTY;
#endif ONLY_OWNER_CAN_SATTR

	    softc->gattr.sattr.flags = sattr->flags;

	    if (sattr->emu_type != -1)
	    {
		DEBUG_PRT(("setting emu type to %d\n", sattr->emu_type));
		softc->gattr.sattr.emu_type = sattr->emu_type;
	    }

	    if (sattr->flags & FB_ATTR_DEVSPECIFIC) {
		bcopy ((char *) sattr->dev_specific,
		       (char *) softc->gattr.sattr.dev_specific,
		       sizeof sattr->dev_specific);

		if (softc->gattr.sattr.dev_specific
		    [FB_ATTR_TV2_SETOWNER_CMD] == 1) {
		    struct proc    *pfind ();
		    register struct proc *newowner = 0;

		    if (softc->gattr.sattr.dev_specific
			[FB_ATTR_TV2_SETOWNER_PID] > 0 &&
			(newowner = pfind (
					   softc->gattr.sattr.dev_specific
					   [FB_ATTR_TV2_SETOWNER_PID]))) {
			softc->owner = newowner;
			softc->gattr.owner = newowner->p_pid;
		    }
		    softc->gattr.sattr.dev_specific
			[FB_ATTR_TV2_SETOWNER_CMD] = 0;
		    softc->gattr.sattr.dev_specific
			[FB_ATTR_TV2_SETOWNER_PID] = 0;

		    if (!newowner)
			return ESRCH;
		}
	    }
	}
	break;

    case FBIOGATTR:{
	    register struct fbgattr *gattr = (struct fbgattr *) data;

	    /* set owner if not owned or previous owner is dead */
	    if (softc->owner == NULL ||
		softc->owner->p_stat == NULL ||
		softc->owner->p_pid != softc->gattr.owner) {

		softc->owner = u.u_procp;
		softc->gattr.owner = u.u_procp->p_pid;
	    }

	    *gattr = softc->gattr;

	    if (u.u_procp == softc->owner) {
		gattr->owner = 0;
	    }
	}
	break;

    case FBIOGTYPE:{
	    register struct fbtype *fb = (struct fbtype *) data;

	    /* set owner if not owned or previous owner is dead */
	    if (softc->owner == NULL ||
		softc->owner->p_stat == NULL ||
		softc->owner->p_pid != softc->gattr.owner) {

		softc->owner = u.u_procp;
		softc->gattr.owner = u.u_procp->p_pid;
	    }

	    switch (softc->gattr.sattr.emu_type) {
	    case FBTYPE_SUN4COLOR:
		*fb = tv2typedefault;
		fb->fb_height = softc->h;
		fb->fb_width = softc->w;
		fb->fb_size = softc->bit8size;
		break;
	    default:
		*fb = softc->gattr.fbtype;
		break;
	    }
	}
	break;

#if NWIN > 0

    case FBIOGPIXRECT:{
	    struct fbpixrect *fbpr = (struct fbpixrect *) data;
	    register struct cg4fb *fbp;
	    register struct cg4_fbdesc *descp;
	    register int    i;

#ifdef NOTDEF
	    plxv_tag(PLXV_TAG_DISPLAY_ATTR, PLXV_TAG_PSEUDO_COLOR);
	    plxv_transp_off();
	    plxv_stencil(0, 0);
	    plxv_wmask(PLXV_WMASK_PIXEL_ALL);
#endif

	    /* "Allocate" pixrect and private data */
	    fbpr->fbpr_pixrect = &softc->pr;
	    softc->pr.pr_data = (caddr_t) & softc->cgd;

	    /* initialize pixrect */
	    softc->pr.pr_ops = &tv2_ops;
	    softc->pr.pr_size.x = softc->w;
	    softc->pr.pr_size.y = softc->h;

	    /* initialize private data */
	    softc->cgd.flags = 0;
	    softc->cgd.planes = 0;
	    softc->cgd.fd = minor (dev);


	    /* set up everything except for the image pointer */
	    for (fbp = softc->cgd.fb, descp = cg4_fbdesc, i = 0;
		 i < TV2_NFBS; fbp++, descp++, i++) {
		fbp->group = descp->group;
		fbp->depth = descp->depth;
		fbp->mprp.mpr.md_linebytes =
		    mpr_linebytes (softc->w, descp->depth);
		fbp->mprp.mpr.md_image = (short *) softc->fb[i];
		fbp->mprp.mpr.md_offset.x = 0;
		fbp->mprp.mpr.md_offset.y = 0;
		fbp->mprp.mpr.md_primary = 0;
		fbp->mprp.mpr.md_flags = descp->allplanes != 0
		    ? MP_DISPLAY | MP_PLANEMASK
		    : MP_DISPLAY;
		fbp->mprp.planes = descp->allplanes;

	    }

	    {
		u_int             initplanes;
		Pixrect        *tmppr = &softc->pr;
		initplanes = PIX_GROUP (cg4_fbdesc[TV2_FBINDEX_COLOR].group) |
		    cg4_fbdesc[TV2_FBINDEX_COLOR].allplanes;

		(void) cg4_putattributes (tmppr, &initplanes);
	    }
#ifdef NOTDEF
	    /* enable video */
	    if (softc->p4reg)
		*softc->p4reg = (*softc->p4reg & ~P4_REG_RESET) | 
		    P4_REG_VIDEO;
	    else
		setvideoenable (1);
#endif
	}
	break;

#endif NWIN > 0

    case FBIOSVIDEO:{
	    register int    on = *(int *) data & FBVIDEO_ON;
	    softc->blank = on;
	    plxv_disp_blank ((on) ? 0 : 1);
	}
	break;

	/* get video flags */
    case FBIOGVIDEO:
	*(int *) data = softc->blank;
	break;

    default:
	return ENOTTY;

    }				       /* switch(cmd) */
    return 0;
}

extern struct user u;

int tvtwowrite(dev, uio)
dev_t	dev;
struct uio *uio;
{
	u_char unit_no;
	u_short retval = 0;
	struct tv2_softc *softc;
	unit_no = minor(dev);
	softc = &tv2_softc[unit_no];

	if(softc->tv2_xvstrp->main.c3_rev < 1)
	{
	    DEBUG_PRT(("tvtwowrite: no ccube on board\n"));
	    u.u_error = ENODEV;
	    return(-1);
	}

	do_coef(softc->tv2_xvstrp);

	k_addr = (unsigned int )&softc->dmabuf;
	retval = physio(tvtwostrategy, &softc->dmabuf, dev, B_WRITE,
			tvtwominphys, uio);
	return(retval);
}

int tvtworead(dev, uio)
dev_t	dev;
struct uio *uio;
{
	u_char unit_no;
	u_short retval = 0;

	struct tv2_softc *softc;
	unit_no = minor(dev);
	softc = &tv2_softc[unit_no];
	
	if(softc->tv2_xvstrp->main.c3_rev < 1)
	{
	    DEBUG_PRT(("tvtworead: no ccube on board\n"));
	    u.u_error = EIO;
	    return(-1);
	}

	do_coef(softc->tv2_xvstrp);

	k_addr = (unsigned int )&softc->dmabuf;
	retval = physio(tvtwostrategy, &softc->dmabuf, dev, B_READ,
			tvtwominphys, uio);
	return(retval);
}

static void tvtwostrategy(bp)
struct buf *bp;
{
	u_int unit_no;
	struct tv2_softc *softc;
	int pri;
#ifdef SLOWALLOCS
	unsigned int xtrabufs, addr;
	unsigned int count;
#endif

	unit_no = minor(bp->b_dev);
	softc = &tv2_softc[unit_no];

	plxv_switch_context(softc->tv2_xvstrp);

#ifdef SLOWALLOCS
	xv_init_xfr(bp, &count, &xtrabufs);
#endif

	bp->b_mbinfo = mb_mapalloc(dvmamap, bp, 0, ((int (*)())0), (caddr_t) 0);

	pri = spl5(); 

	ladd = (unsigned int) (MBI_ADDR(bp->b_mbinfo) + DVMA);

	if (bp->b_flags & B_READ) 
#ifdef SLOWALLOCS
		softc->dmastate = c3_start_read(ladd, count, xtrabufs);
#else
		softc->dmastate = c3_start_read(ladd, bp->b_bcount);
#endif
	else
		softc->dmastate = c3_start_write(ladd, bp->b_bcount);
 
#ifndef SLOWALLOCS
	splx(pri);
#endif
	if (softc->dmastate == 0)
	{
	    if (bp->b_mbinfo) {
		mb_mapfree(dvmamap, &bp->b_mbinfo);
#ifdef SLOWALLOCS
		splx(pri);
		xv_end_xfr(bp);
#endif
		bp->b_resid = bp->b_bcount;	/* must be an error */
		bp->b_flags |= B_ERROR;
		bp->b_error = EIO;
	  	iodone(bp);
	    }
	}
	else
	{
	    if (bp->b_mbinfo)
	    {
#ifdef SLOWALLOCS
	      while(1)
	      {
#endif
	   	sleep(bp, PRIBIO);
		mb_mapfree(dvmamap, &bp->b_mbinfo);
#ifdef SLOWALLOCS
		if((softc->dmastate == STATER1) || (softc->dmastate == STATER2))
		{
		    if(xv_next_buffer(bp, &addr, &count, &xtrabufs))
		        c3_cont_dma(addr, count, xtrabufs);
		    else
		    {
	      		splx(pri);
			printf("badd next buffer\n");
			softc->dmastate = STATE_ERR;
			xv_end_xfr(bp);
		    	bp->b_flags |= B_ERROR;
		    	bp->b_error = EIO;
			break;
		    }
		}
		else
		{
	      	    splx(pri);
		    xv_end_xfr(bp);
		    break;
		}
	      }
#endif
	  	iodone(bp);
	    }
#ifdef SLOWALLOCS
	    else
		splx(pri);
#endif
        }

	return;
}

int tvtwointr()
{
    struct tv2_softc *softc;
    struct buf *bp;
    
    extern void service_ccube(),service_timer(),service_disp();
    extern void service_ccube(),service_ext(),service_video();
    extern void service_video(),service_video(),service_video();
    extern void service_blit();
    extern void service_dmabuf();

    static void (*service_routine[10])() = {
	service_dmabuf,service_timer,service_disp,service_ccube,service_ext,
	service_video,service_video,service_video,service_video,service_blit};

    unsigned int c3_rcount;
    int pri, bits,check_bit, savebits;
    int i,j,k,l;
    int rM,rBM;

    /* get the buffer stuff from softC */
    softc = &tv2_softc[0];
    bp = &softc->dmabuf;

    plxv_switch_context(softc->tv2_xvstrp);

    /* read the Interrupt Status registers & Clear */

    XV_RSDW(rBM,BIntMask.l);
    XV_RSDW(rM,IntMask.l);

    /* sometimes the board doesn't respond during dma, so shut it down */
    if(softc->dmastate > 0)
    {
	if(softc->dmastate & STATEW) {
		XV_WREG(CCube.l, XVC3_PAUSE_DMA_FROM_HOST);
		DELAY(10);
		XV_WREG(CCube.l, XVC3_WRITE_GO_PIO);
		XV_WREG(CCube.l, XVC3_WRITE_GO_PIO);
	} else {
		XV_WREG(CCube.l, XVC3_PAUSE_DMA_TO_HOST);
		DELAY(50);
		XV_WREG(CCube.l, XVC3_PURGE_BIC_GO_PIO);
		XV_WREG(CCube.l, XVC3_PURGE_BIC_GO_PIO);
	}
        DELAY(10);
    }


    XV_RREG(BIntStat,BIntStatC.l);
    XV_RREG(IntStat,IntStatC.l);

#if 0
    if(softc->dmastate > 0)		/* shut down both bus, and c3 ints */
    {
	XV_WREG(IntMask.l, 0);
	XV_WREG(BIntMask.l, 0);
    }
#endif

    bits = ((IntStat & rM & 0xff) <<2 ) | ( BIntStat & rBM & 0x3);
    savebits = bits;
    check_bit = 1;

    DEBUG_PRT(("tvtwointr: bits = %x\n", bits));

    /* look thru the bits one at a time */
    for (i=0;i<10;i++)
    {   /* look thru the bits one at a time */
	if ( bits == 0 ) break;	/* no more bits */
	if ( bits & check_bit)
	{
		(*service_routine[i])(&bits);
	}
	check_bit <<= 1;
    }

    XV_RREG(IntStat,IntStatC.l);

    /* let the dma continue if not restarted by ccube routines */

    if((softc->dmastate > 0) && ((savebits & 0x9) == 0))
    {
	if(softc->dmastate & STATEW)
	{
		XV_WREG(CCube.l, XVC3_CONT_DMA_FROM_HOST_1);
		XV_WREG(CCube.l, XVC3_CONT_DMA_FROM_HOST_2);
	}
	else
	{
		XV_WREG(CCube.l, XVC3_CONT_DMA_TO_HOST_1);
		XV_WREG(CCube.l, XVC3_CONT_DMA_TO_HOST_2);
	}
    }

    return(1);
}

void service_disp(b)
int *b;
{/* display vertical interrupt */
    *b &= ~0x4;

#ifdef print_in_isr
        printf("display vertical interrupt\n");
#endif
}

void service_dmabuf(b) 
int *b;
{
    struct tv2_softc *softc;
    struct buf *bp;
    unsigned int c3_rcount;
    int pri;


#ifdef NOTDEF /* do this last */
     /*
      * If there's a c-cube interrupt pending, service it first
      */
     if (*b & 0x8) service_ccube(b);
#endif

/*
     printf("Buffer: bits = %x, state = %x\n",*b,softc->dmastate);
*/
     *b &= ~0x1;

#ifdef print_in_isr
    printf("DMA interrupt\n");
#endif

    /* get the buffer stuff from softC */
    softc = &tv2_softc[0];
    bp = &softc->dmabuf;

    if ((!softc) || (!bp)) return;

    if((softc->dmastate == 0) || (softc->dmastate == -1))
	return;

    pri = spl5();
    softc->dmastate = xvbuf_int_svc(softc->dmastate,&c3_rcount);
    splx(pri);

    if (softc->dmastate == -1) {
        if (bp->b_mbinfo) {
    	bp->b_resid = bp->b_bcount;	/* its an error */
    	bp->b_flags |= B_ERROR;
    	bp->b_error = EIO;
	wakeup(bp);
        }
    }
    else if (softc->dmastate == 0)
    {
        if (bp->b_mbinfo) {
#if 0	/* only writes can get here */
	    XV_RREG(c3_rcount, DMARB.l);
    	    bp->b_resid = bp->b_bcount - (c3_rcount - ladd);
#else
	    bp->b_resid = 0;	/* assume all was consumed */
#endif
	    wakeup(bp);
        }
    }
    else if (*b & 0x8) service_ccube(b);

    if((softc->dmastate == STATER1) || (softc->dmastate == STATER2))
	wakeup(bp);
}

void service_ccube(b)
int *b;
{/* CCbus interrupt */
    struct tv2_softc *softc;
    struct buf *bp;
    unsigned int c3_rcount;
    int pri;

/*
     printf("C-cube: bits = %x, state = %x\n",*b,softc->dmabuf);
*/

    *b &= ~0x8;

#ifdef print_in_isr
    printf("CCube interrupt\n");
#endif

    /* get the buffer stuff from softC */
    softc = &tv2_softc[0];
    bp = &softc->dmabuf;

    if ((!softc) || (!bp)) return;

    pri = spl5();
    softc->dmastate = c3_int_svc(softc->dmastate,&c3_rcount);
    splx(pri);

    if (softc->dmastate == -1) {
        if (bp->b_mbinfo) {
    	bp->b_resid = bp->b_bcount;	/* its an error */
    	bp->b_flags |= B_ERROR;
    	bp->b_error = EIO;
	wakeup(bp);
        }
    }

    if (softc->dmastate == 0)
    {
        if (bp->b_mbinfo) {
#if 0	/* honor the return */
	XV_RREG(c3_rcount, DMARB.l);
    	bp->b_resid = bp->b_bcount - (c3_rcount - ladd);
#else
    	bp->b_resid = bp->b_bcount - c3_rcount;
#endif
	wakeup(bp);
        }
    }

}

void service_timeout()
{
    struct tv2_softc *softc;
    struct buf *bp;

    /* get the buffer stuff from softC */
    softc = &tv2_softc[0];
    bp = &softc->dmabuf;

        if (bp->b_mbinfo) {
    	bp->b_resid = bp->b_bcount;	/* its an error */
    	bp->b_flags |= B_ERROR;
    	bp->b_error = EIO;
	wakeup(bp);
        }
}

void service_ext(b)
int *b;
{/* external interrupt */
    *b &= ~0x10;

#ifdef print_in_isr
        printf("external interrupt\n");
#endif
}

void service_video(b)
int *b;
{/* Video interrupt */
	*b &= ~0x20;
	*b &= ~0x40;
	*b &= ~0x80;
	*b &= ~0x100;
#ifdef print_in_isr
        printf("Video interrupt\n");
#endif
}

void service_blit(b)
int *b;
{/* Blit done  interrupt */
	*b &= ~0x200;
#ifdef print_in_isr
        printf("Blit done  interrupt\n");
#endif
}

void service_timer(b)			/* Timer  interrupt */
int *b;
{
	*b &= ~0x2;
#ifdef print_in_isr
	printf("Timer interrupt\n");
#endif
	plxv_set_hourint();
	plxv_inc_hours();
}

c3intr()
{
	tvtwointr();
}

static void tvtwominphys(bp)
struct buf *bp;
{
#ifdef SMALLXFERS
	if(bp->b_bcount > (64 * 1024))
	    bp->b_bcount = (64 * 1024);
#else
	if(bp->b_bcount > (256 * 1024))
	    bp->b_bcount = (256 * 1024);
#endif
}

#ifdef SLOWALLOCS
static unsigned int tbu;
static unsigned int ocount;
static unsigned int oaddr;
static int xtrabufs;
static int lastlen;
int lastaddr;

xv_init_xfr(bp, count, xtracount)
struct buf *bp;
unsigned int *count, *xtracount;
{
    ocount = bp->b_bcount;
    oaddr = (unsigned int)bp->b_un.b_addr;
    tbu = 0;
    if (slowmallocflag &&
	(bp->b_flags & B_READ) && (ocount > (ALLOCSIZE + PAGESIZE)))
    {
	bp->b_bcount = ALLOCSIZE + PAGESIZE;
	*count = ALLOCSIZE;
	*xtracount = PAGESIZE;
	xtrabufs = 1;
    }
    else
    {
	*count = ocount;
	*xtracount = 0;
	xtrabufs = 0;
    }
    lastlen = *count;
}

xv_next_buffer(bp, add, count, xtracount)
struct buf *bp;
unsigned int *add, *count, *xtracount;
{
    unsigned int tadd;
    int len, buffused;
    unsigned int blp;    /* bytes in last page */

    XV_RREG(tadd, DMARB.l);
    buffused = tadd - ladd;

    blp = buffused - lastlen;

    if(buffused  < lastlen)
	return 0;

    tbu += buffused;

    if ((ocount - tbu) > (ALLOCSIZE + PAGESIZE))
    {
	len = ALLOCSIZE + PAGESIZE;
	*xtracount = PAGESIZE;
	xtrabufs = 1;
    }
    else
    {
	len = (ocount - tbu) + blp;
	*xtracount = 0;
	xtrabufs = 0;
    }

    bp->b_un.b_addr += ALLOCSIZE;

    bp->b_bcount = len;

    bp->b_mbinfo = mb_mapalloc(dvmamap, bp, 0, ((int (*)())0), (caddr_t) 0);

    ladd = (unsigned int) (MBI_ADDR(bp->b_mbinfo) + DVMA);
    ladd += blp;
    *add = ladd;
    len -= (blp + *xtracount);
    lastlen = len;
    *count = len;
    return 1;
}

xv_end_xfr(bp)
struct buf *bp;
{
    unsigned int bu, tadd;
    struct tv2_softc *softc;
    softc = &tv2_softc[0];

#if 0
    XV_RREG(tadd, DMARB.l);
#else
    tadd = lastaddr;
#endif
    bu = tadd - ladd;
    tbu += bu;

    bp->b_bcount = ocount;
    bp->b_un.b_addr = (caddr_t)oaddr;

    if(softc->dmastate == STATE_ERR)
	bp->b_resid = bp->b_bcount;
    else
	bp->b_resid = bp->b_bcount - tbu;
}

#endif
