/* $Header: /plx/source/Xclients/generic/RCS/aboutBox.c,v 1.1 1995/09/21 00:28:34 lovvik Exp $ */

/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */

/* $Log: aboutBox.c,v $
 * Revision 1.1  1995/09/21  00:28:34  lovvik
 * Initial revision
 * */

static char movieCatRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/aboutBox.c,v 1.1 1995/09/21 00:28:34 lovvik Exp $";

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>

#include <xpm.h>

#include "interface.h"
#include "globals.h"
#include "structs.h"
#include "prototypes.h"
#include <icon/.plxlogo>

void InitializeAboutBox(void)
{
  /*
   * This function places a parallax logo pixmap in
   * the about box.  Note that this must be done
   * after the main dialog box is realized.  To
   * accomplish this, we will set up a work proceedure.
   */
  XtAppAddWorkProc(app_context, CreateLogoWorkProc, NULL);
}

Boolean CreateLogoWorkProc(XtPointer unusedData)
{
  if(XtIsRealized(mainWindow))
  {
    CreateLogoPixmap(aboutShell);
    return(True);
  }
  else
  {
    return(False);
  }
}


void CreateLogoPixmap(Widget	parentWidget)			    /* Creates a masked Pixmap in shape of the company logo... */
{								    /* ...to display in the application's "About..." panel. */
  unsigned long	background;
  Display*	display = XtDisplay(parentWidget);
  int		depth;
  XGCValues	gcValues;
  Pixmap	logoPixmap;
  Pixmap	logoShapeMask;
  XpmAttributes	logoAttrs;
  GC		logoGC;
  int		result;
  Pixmap	thePixmap;
  Window	window = XtWindow(parentWidget);
  
  logoAttrs.valuemask = 0;
  result = XpmCreatePixmapFromData(display,			    /* Attempt to create a Pixmap from XPM data */
				   window,			    /* The function, if successful, will return both a Pixmap... */
				   plxLogoData,			    /* ...in the shape of the company logo, in color, plus... */
				   &logoPixmap,			    /* ...a mask that can be used to show only the Pixmap... */
				   &logoShapeMask,		    /* ...data (as if it were transparent). */
				   &logoAttrs);
  if (result != 0)						    /* Did the Pixmap creation fail? */
    return;							    /* Yes, don't use any Pixmap for the logo panel */
  XtVaGetValues(parentWidget,					    /* Get the depth and background color of the parent widget */
		XmNdepth, &depth,
		XmNbackground, &background,
		NULL);
  thePixmap = XCreatePixmap(display,				    /* Create a new Pixmap to be used as the application's logo */
			    window,
			    logoAttrs.width, logoAttrs.height,
			    depth);
  gcValues.background = background;
  gcValues.foreground = background;
  logoGC = XCreateGC(display,					    /* Create a GC that paints the application's background... */
		     window,					    /* ...color into the final logo Pixmap */
		     (GCBackground | GCForeground),
		     &gcValues);
  XFillRectangle(display, thePixmap, logoGC, 0, 0,		    /* Paint the bkgnd color into the final logo Pixmap */
		 logoAttrs.width, logoAttrs.height);
  XSetClipMask(display, logoGC, logoShapeMask);			    /* Make sure that painting the new, color logo data only... */
  XCopyArea(display, logoPixmap, thePixmap, logoGC,		    /* ...paints into the areas it's supposed to, making... */
	    0, 0, logoAttrs.width, logoAttrs.height,		    /* ...a "transparent" effect. */
	    0, 0);
  XtVaSetValues(aboutDialog, XmNsymbolPixmap, thePixmap, NULL);	    /* Use the newly-created icon as the About panel's symbol */
  return;
} /* end function CreateLogoPixmap */
