/* $Header: /plx/source/Xclients/generic/RCS/error.c,v 1.3 1995/12/12 19:59:43 lovvik Exp $ */

/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */

/* $Log: error.c,v $
 * Revision 1.3  1995/12/12  19:59:43  lovvik
 * Removed a printed message from PrintError().
 *
 * Revision 1.2  1995/10/27  16:57:56  lovvik
 * Added PrintErrorWorkProc which will process the error messages that
 * occur during setup.  This way, the error box does not pop up before
 * the main window.
 *
 * Revision 1.1  1995/09/21  00:29:36  lovvik
 * Initial revision
 * */

static char movieCatRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/error.c,v 1.3 1995/12/12 19:59:43 lovvik Exp $";

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/List.h>
#include <Xm/PushB.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleBG.h>
#include <stdio.h>
#include <stdlib.h>

#include "interface.h"
#include "globals.h"
#include "structs.h"
#include "prototypes.h"

static int previousState;

Boolean PrintErrorWorkProc(XtPointer errorMessage)
{
  PrintError(errorMessage);
  return(True);
}


void PrintError(char *errorMessage)
{
  XmString errorString;

  /*
   * Launch a work-proc if the main window has not been realized.
   */
  if(!XtIsRealized(mainWindow))
  {
    XtAppAddWorkProc(app_context,
		     PrintErrorWorkProc,
		     (XtPointer)errorMessage);
  }

  else
  {
    previousState = GetMovieCatStatus();
    if(previousState == MC_CREATING)
    {
      /*
       * If there was an error during the creation of a movie,
       * give the user the option of canceling the save operation
       * or creating drive space and continuing.
       */
      
      XtManageChild(errorShellCancelButton);
    }
  
    SetMovieCatStatus(MC_ERROR);
    errorString = XmStringCreateSimple(errorMessage);
    XtVaSetValues(errorMessageLabel,
		  XmNlabelString, errorString,
		  NULL);
    XmStringFree(errorString);
    XtManageChild(errorDialog);
    XtPopup(errorShell, XtGrabExclusive);
  }
}

int GetStateBeforeError(void)
{
  return(previousState);
}


