/* $Header: /plx/source/Xclients/generic/RCS/prototypes.h,v 1.2 1995/10/27 17:04:21 lovvik Exp $ */

/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */

/* $Log: prototypes.h,v $
 * Revision 1.2  1995/10/27  17:04:21  lovvik
 * Added prototypes for 2 functions in callbacks.c.
 *
 * Revision 1.1  1995/09/21  00:37:00  lovvik
 * Initial revision
 * */

static char movieCatProtosRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/prototypes.h,v 1.2 1995/10/27 17:04:21 lovvik Exp $";

/*
 * Prototypes for functions in mainDialog.c
 */

void Initialize(void);
char *GetDestinationFile(void);
void SetDestinationFile(char *);
int GetNumberOfClips(void);
void SetNumberOfClips(int);
int GetCurrentClip(void);
void SetCurrentClip(int);
int GetMovieCatStatus(void);
void SetMovieCatStatus(int);
void ShutDown(void);
void AppendClipToList(ClipListEntry);
void InsertClipInList(ClipListEntry);
char *GetCurrentClipFileName(void);
int GetCurrentClipFromFrame(void);
int GetCurrentClipToFrame(void);
int GetCurrentClipCopyAudio(void);
Boolean MakeMovieWorkProc(XtPointer);
void CreateMovie(void);
void StartToModifyClip(void);
void ModifyClip(ClipListEntry);
void DeleteClip(void);
void DeleteClipList(void);
void SetEstimatedMovieSize(void);
void SelectClipNumber(int clipListEntry);

/*
 * Prototypes for callbacks.c
 */
void FromFrameEntered (Widget, XtPointer, XtPointer);
void ToFrameEntered (Widget, XtPointer, XtPointer);

/*
 * Prototypes for functions in movieSelection.c
 */

void InitializeMovieSelectionModule(void);
void ChangeSelectionBoxTitle(char *);
int SelectMovieFileName(char *, int);
void UpdateClipLength(int);
void SetCopyEntireMovie(void);
void SetCopySelectedFrames(void);
void SetCopyAudio(void);
void SetOmitAudio(void);
void UpdateFromFrame(int);
void UpdateToFrame(int);
void AddMovieClip(void);
void InsertMovieClip(void);
void ModifyMovieClip(void);
int GetClipLength(void);
int GetFromFrame(void);
int GetToFrame(void);
char *GetMovieFilename(void);
void InitializeSelectionBox(ClipListEntry);


/*
 * Prototypes for functions in error.c
 */

void PrintError(char *);
int GetStateBeforeError(void);


/*
 * Prototypes for functions in progress.c
 */

void SetCurrentMovieFilename(char *);
void SetPercentDone(int);


/*
 * Prototypes for functions in aboutBox.c
 */

void InitializeAboutBox(void);
Boolean CreateLogoWorkProc(XtPointer);
void CreateLogoPixmap(Widget);


/*
 * Prototypes for functions in jpegMovie.c
 */
#include <movie.h>

int IsJPEGMovieFile(char *);
int GetJPEGLastFrame(char *);
void JPEGSetDestinationFile(char*);
void JPEGInitializeMovieHeader(jpheader);
int JPEGIsCompatibleMovie(char *);
int JPEGAudioIsCompatible(char *);
unsigned int EstimateClipSize(char *, int, int, int);
int JPEGIsDoneWithMovie(void);
int JPEGCopyFrame(void);
void JPEGCopyFile(char*, int, int, int);
void JPEGSyncFiles(void);
void JPEGFinishMovieNow(void);
void JPEGCloseClipFile(void);
void JPEGCloseMovieFile(void);
void JPEGUninitialize(void);
void JPEGErrorInFrame(int frame);
void JPEGErrorInIndexTable(void);
float JPEGPercentComplete(void);
void JPEGDeleteDestinationFile(void);



/*
 * Prototypes for functions in help.c
 */

void InitializeHelp(void);
void DisableHelp(void);
int OpenHelpFile(void);
void DisplayHelp(int);
void CleanHelpLine(char *helpLine);
