/* $Header: /plx/source/Xclients/generic/RCS/aixAudio.h,v 1.1 1995/08/23 01:52:09 drapeau Exp $ */
/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Log: aixAudio.h,v $
 * Revision 1.1  1995/08/23  01:52:09  drapeau
 * Added two methods to the object: AudioOverrun(), which queries the
 * audio device as to whether audio overflow occurred (i.e., if the audio
 * device was filling up faster than the application could pull out audio
 * data); and AudioBytesInBuffer(), which asks the audio device how many
 * bytes are left in the audio buffer.
 *
 * Revision 1.0  1995/06/16  19:59:01  drapeau
 * Initial revision
 * */
#ifndef _IBMAudioHeader_
#define _IBMAudioHeader_

static char aixAudioHeaderRcsId[] = "$Header: /plx/source/Xclients/generic/RCS/aixAudio.h,v 1.1 1995/08/23 01:52:09 drapeau Exp $";

int IBMAudioDeviceAudioWrite(char *audioData, int audioslice);
int IBMAudioDeviceAudioRead(char *audioData, int audioslice);
void IBMAudioDeviceAudioPlayConnect(void);
void IBMAudioDeviceAudioPlayDisconnect(void);
void IBMAudioDeviceAudioRecordConnect(void);
void IBMAudioDeviceAudioRecordDisconnect(void);
void IBMAudioDeviceAudioRecordPause(void);
void IBMAudioDeviceAudioRecordResume(void);
void IBMAudioDeviceAudioPlayPause(void);
void IBMAudioDeviceAudioPlayResume(void);
void IBMAudioDevicePrintAudioInfo(PortableAudio* audioInfo);
int IBMAudioDeviceInitializeAudio(void);
void IBMAudioDeviceSetAudioPlayVolume(int percent);
void IBMAudioDeviceSetAudioRecordVolume(int percent);
void IBMAudioDeviceSetAudioMonitorVolume(int percent);
void IBMAudioDeviceSetPlaybackDevice(int deviceType);
void IBMAudioDeviceSetRecordDevice(int deviceType);
int IBMAudioDeviceSetAudioPlaybackConfiguration(Audio_hdr* audioInfo);
void IBMAudioDeviceAudioClose(void);
void IBMAudioDeviceSyncAudioPlaybackDevice(void);
void IBMAudioDeviceSyncAudioRecordDevice(void);
void IBMAudioDeviceAudioStopPlayDevice(void);
void IBMAudioDeviceAudioStopRecordDevice(void);
Boolean IBMAudioDeviceAudioReadOverrun(void);
long IBMAudioDeviceAudioReadUsed(void);

#endif /* _IBMAudioHeader_ */
