/* $Header: /plx/source/Xclients/generic/RCS/noAudio.c,v 1.2 1995/08/23 01:57:48 drapeau Exp $ */
/*
 *   Copyright (c) 1994 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */
/* $Log: noAudio.c,v $
 * Revision 1.2  1995/08/23  01:57:48  drapeau
 * Added two methods to the object: AudioOverrun(), which queries the
 * audio device as to whether audio overflow occurred (i.e., if the audio
 * device was filling up faster than the application could pull out audio
 * data); and AudioBytesInBuffer(), which asks the audio device how many
 * bytes are left in the audio buffer.
 *
 * Revision 1.1  1995/04/27  00:31:50  lovvik
 * Initial revision
 * */

static char noAudioRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/noAudio.c,v 1.2 1995/08/23 01:57:48 drapeau Exp $";

#include <stdio.h>
#include <stdlib.h>

#include "MovieTool.h"
#include "PortableAudio.h"
#include "noAudio.h"

AudioObject  noAudioObject= 
{
  NoAudioDeviceAudioWrite,
  NoAudioDeviceAudioRead,
  NoAudioDeviceAudioPlayConnect,
  NoAudioDeviceAudioPlayDisconnect,
  NoAudioDeviceAudioRecordConnect,
  NoAudioDeviceAudioRecordDisconnect,
  NoAudioDeviceAudioRecordPause,
  NoAudioDeviceAudioRecordResume,
  NoAudioDeviceAudioPlayPause,
  NoAudioDeviceAudioPlayResume,
  NoAudioDevicePrintAudioInfo,
  NoAudioDeviceInitializeAudio,
  NoAudioDeviceSetAudioPlayVolume,
  NoAudioDeviceSetAudioRecordVolume,
  NoAudioDeviceSetAudioMonitorVolume,
  NoAudioDeviceSetPlaybackDevice,
  NoAudioDeviceSetRecordDevice,
  NoAudioDeviceSetAudioPlaybackConfiguration,
  NoAudioDeviceAudioClose,
  NoAudioDeviceSyncAudioPlaybackDevice,
  NoAudioDeviceSyncAudioRecordDevice,
  NoAudioDeviceAudioStopPlayDevice,
  NoAudioDeviceAudioStopRecordDevice,
  NoAudioDeviceAudioReadOverrun,
  NoAudioDeviceAudioBytesInBuffer
};

int NoAudioDeviceAudioWrite(char *audioData, int audioslice)                    /* Write audio data to the audio device */
{
  return(0);
}  /* end function AudioWrite */


int NoAudioDeviceAudioRead(char *audioData, int audioslice)                     /* Read the audio information from the audio device */
{
  return(0);
}  /* end function AudioRead */


void NoAudioDeviceAudioPlayConnect(void)
{

}


void NoAudioDeviceAudioPlayDisconnect(void)
{

}


void NoAudioDeviceAudioRecordConnect(void)
{

}


void NoAudioDeviceAudioRecordDisconnect(void)
{

}

void NoAudioDeviceAudioRecordPause(void)
{

}  /* end function AudioRecordPause */


void NoAudioDeviceAudioRecordResume(void)
{

}  /* end function AudioRecordResume */


void NoAudioDeviceAudioPlayPause(void)
{

}  /* end function AudioPlayPause */


void NoAudioDeviceAudioPlayResume(void)
{

}  /* end function AudioPlayResume */


void NoAudioDevicePrintAudioInfo(PortableAudio* audioInfo)
{

}  /* end function PrintAudioInfo */


int NoAudioDeviceInitializeAudio(void) /* returns status:  -1 = fail, 0 = ok */
{
  return(-1);
}  /* end function InitializeAudio */


void NoAudioDeviceSetAudioPlayVolume(int percent)
{

}  /* end function SetAudioPlayVolume */


void NoAudioDeviceSetAudioRecordVolume(int percent)
{

}  /* end function SetAudioRecordVolume */


void NoAudioDeviceSetAudioMonitorVolume(int percent)
{

}  /* end function SetAudioMonitorVolume */


void NoAudioDeviceSetPlaybackDevice(int deviceType)
{

}  /* end function SetPlaybackDevice */


void NoAudioDeviceSetRecordDevice(int deviceType)
{

}  /* end function SetRecordDevice */


int NoAudioDeviceSetAudioPlaybackConfiguration(Audio_hdr* audioInfo)
{
  return(0);
}  /* end function SetAudioPlaybackConfiguration */


void NoAudioDeviceAudioClose(void)
{

}  /* end function AudioClose */


void NoAudioDeviceSyncAudioPlaybackDevice(void)
{


}  /* end function SyncAudioPlaybackDevice */

void NoAudioDeviceSyncAudioRecordDevice(void)
{

}  /* end function SyncAudioRecordDevice */


void NoAudioDeviceAudioStopPlayDevice(void)
{

}


void NoAudioDeviceAudioStopRecordDevice(void)
{
  
}



Boolean NoAudioDeviceAudioReadOverrun(void)
{
  return(False);
}



long NoAudioDeviceAudioBytesInBuffer(void)
{
  return(0);
}
