/* $Header: /plx/source/Xclients/generic/RCS/noAudio.h,v 1.3 1995/08/23 01:58:12 drapeau Exp $ */
/*
 *   Copyright (c) 1994 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */
/* $Log: noAudio.h,v $
 * Revision 1.3  1995/08/23  01:58:12  drapeau
 * Added two methods to the object: AudioOverrun(), which queries the
 * audio device as to whether audio overflow occurred (i.e., if the audio
 * device was filling up faster than the application could pull out audio
 * data); and AudioBytesInBuffer(), which asks the audio device how many
 * bytes are left in the audio buffer.
 *
 * Revision 1.2  1995/04/27  16:53:16  lovvik
 * Fixed a problem in which 2 copies of the variable noAudioRcsid
 * were being compiled into noAudio.c.
 *
 * Revision 1.1  1995/04/27  00:34:47  lovvik
 * Initial revision
 * */

static char noAudioIncludeRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/noAudio.h,v 1.3 1995/08/23 01:58:12 drapeau Exp $";

/* Prototypes for audio primatives using no audio support */

int NoAudioDeviceAudioWrite(char *audioData, int audioslice);
int NoAudioDeviceAudioRead(char *audioData, int audioslice);
void NoAudioDeviceAudioPlayConnect(void);
void NoAudioDeviceAudioPlayDisconnect(void);
void NoAudioDeviceAudioRecordConnect(void);
void NoAudioDeviceAudioRecordDisconnect(void);
void NoAudioDeviceAudioRecordPause(void);
void NoAudioDeviceAudioRecordResume(void);
void NoAudioDeviceAudioPlayPause(void);
void NoAudioDeviceAudioPlayResume(void);
void NoAudioDevicePrintAudioInfo(PortableAudio* audioInfo);
int NoAudioDeviceInitializeAudio(void);
void NoAudioDeviceSetAudioPlayVolume(int percent);
void NoAudioDeviceSetAudioRecordVolume(int percent);
void NoAudioDeviceSetAudioMonitorVolume(int percent);
void NoAudioDeviceSetPlaybackDevice(int deviceType);
void NoAudioDeviceSetRecordDevice(int deviceType);
int NoAudioDeviceSetAudioPlaybackConfiguration(Audio_hdr* audioInfo);
void NoAudioDeviceAudioClose(void);
void NoAudioDeviceSyncAudioPlaybackDevice(void);
void NoAudioDeviceSyncAudioRecordDevice(void);
void NoAudioDeviceAudioStopPlayDevice(void);
void NoAudioDeviceAudioStopRecordDevice(void);
Boolean NoAudioDeviceAudioReadOverrun(void);
long NoAudioDeviceAudioBytesInBuffer(void);
