/* $Header: /plx/source/Xclients/generic/RCS/RTMovieTool.c,v 1.3 1995/11/20 20:41:51 lovvik Exp $ */

/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */

/* $Log: RTMovieTool.c,v $
 * Revision 1.3  1995/11/20  20:41:51  lovvik
 * Removed a printf statement that was used for testing.
 *
 * Revision 1.2  1995/11/15  02:58:20  lovvik
 * Added code to catch a quit call from the window manager.
 *
 * Revision 1.1  1995/10/02  23:34:11  lovvik
 * Initial revision
 * */

static char movieToolRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/RTMovieTool.c,v 1.3 1995/11/20 20:41:51 lovvik Exp $";

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <X11/StringDefs.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/SelectioB.h>
#include <Xm/Separator.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/CascadeBG.h>
#include <Xm/LabelG.h>
#include <Xm/PushBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/ToggleBG.h>
#include <Xm/Protocols.h>
#include <stdio.h>

#include <XPlxExt.h>
#include "interface.h"
#include "structs.h"
#include "prototypes.h"


XtAppContext app_context;
Display *display;       /*  Display             */
static Atom deleteWindowAtom;

void WMDeleteWindowCallback(Widget widget,
			    XtPointer clientData,
			    XtPointer callData)
{
  Quit(widget, (XtPointer)NULL, (XtPointer)NULL);
}

int main (int argc, char **argv)
{
	XtSetLanguageProc ( (XtAppContext) NULL, (XtLanguageProc) NULL, (XtPointer) NULL );
	XtToolkitInitialize ();
	app_context = XtCreateApplicationContext ();
	display = XtOpenDisplay (app_context, NULL, argv[0], "RTMovieTool",
	                         NULL, 0, &argc, argv);
	if (!display)
	{
	    printf("%s: can't open display, exiting...\n", argv[0]);
	    exit (-1);
	}
	create_mainWindow ( display, argv[0], argc, argv );
	create_errorShell ( mainWindow );
	create_inputSettingsShell ( mainWindow );
	create_alertShell ( mainWindow );
	create_audioShell ( mainWindow );
	create_input1Shell ( mainWindow );
	create_fileDialog ( mainWindow );
	create_smartMovieShell ( mainWindow );
	create_movieShell ( mainWindow );
	create_aboutShell ( mainWindow );
	create_helpShell ( mainWindow );
	create_diagnosticsShell ( mainWindow );

	/*
	 * Catch the Delete Window call from the window manager.
	 */
	deleteWindowAtom = XmInternAtom(display,
					"WM_DELETE_WINDOW",
					False);
	XmAddWMProtocolCallback(mainWindow, deleteWindowAtom,
				(XtCallbackProc)WMDeleteWindowCallback,
				(XtPointer)NULL);

	InitializeMovieTool();
	XtRealizeWidget (mainWindow);
	XtAppMainLoop (app_context);
	exit (0);
}

