/* $Header: /plx/source/Xclients/generic/RCS/colorSettings.c,v 1.1 1995/10/02 23:38:21 lovvik Exp $ */

/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */

/* $Log: colorSettings.c,v $
 * Revision 1.1  1995/10/02  23:38:21  lovvik
 * Initial revision
 * */

static char movieToolRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/colorSettings.c,v 1.1 1995/10/02 23:38:21 lovvik Exp $";

/* Module for the Color Settings dialog */
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <X11/StringDefs.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/SelectioB.h>
#include <Xm/Separator.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/CascadeBG.h>
#include <Xm/LabelG.h>
#include <Xm/PushBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/ToggleBG.h>
#include <stdio.h>

#include "interface.h"
#include "structs.h"
#include "globals.h"
#include "prototypes.h"

static ColorSettingsStruct color;



void InitializeColorSettingsDialog(void)
{
  color.brightness = 128;
  color.contrast = 128;
  color.hue = 128;
  color.saturation = 128;
}


int GetBrightness(void)
{
  return(color.brightness);
}


void SetBrightness(int brightness)
{
  color.brightness = brightness;
  SetVideoBrightness(color.brightness);
}


int GetContrast(void)
{
  return(color.contrast);
}


void SetContrast(int contrast)
{
  color.contrast = contrast;
  SetVideoContrast(color.contrast);
}


int GetHue(void)
{
  return(color.hue);
}


void SetHue(int hue)
{
  color.hue = hue;
  SetVideoHue(color.hue);
}


int GetSaturation(void)
{
  return(color.saturation);
}


void SetSaturation(int saturation)
{
  color.saturation = saturation;
  SetVideoSaturation(color.saturation);
}


void DefaultColorSettings(void)
{
  color.brightness = 128;
  color.contrast = 128;
  color.hue = 128;
  color.saturation = 128;
  
  SetColorSettings(color.brightness,
		   color.contrast,
		   color.hue,
		   color.saturation);
  
  XmScaleSetValue(brightnessSlider, color.brightness);
  XmScaleSetValue(contrastSlider, color.contrast);
  XmScaleSetValue(hueSlider, color.hue);
  XmScaleSetValue(saturationSlider, color.saturation);
}





