/* $Header: /plx/source/Xclients/generic/RCS/compression.c,v 1.2 1995/10/12 20:11:07 lovvik Exp $ */

/*
 *   Copyright (c) 1995 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Paul Lovvik
 */

/*$Log: compression.c,v $
 * Revision 1.2  1995/10/12  20:11:07  lovvik
 * Modified SetBandwidth() to include an argument that tells this
 * function whether or not the value was set by the slider.  The
 * bandwidth can now be changed by the Rtv process.  (This happens
 * if Rtv cannot write to the device fast enough).  The added code
 * simply reflects these changes in the interface.
 *
 * Revision 1.1  1995/10/02  23:39:40  lovvik
 * Initial revision
 * */

static char movieToolRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/compression.c,v 1.2 1995/10/12 20:11:07 lovvik Exp $";

/* Module for the JPEG Compression Preferences dialog */
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <X11/StringDefs.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/SelectioB.h>
#include <Xm/Separator.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/CascadeBG.h>
#include <Xm/LabelG.h>
#include <Xm/PushBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/ToggleBG.h>
#include <stdio.h>

#include "interface.h"
#include "structs.h"
#include "prototypes.h"

static CompressionStruct compression;

void InitializeJPEGCompressionDialog(void)
{
  /* The default will be 640 x 480 compression with a bandwidth of 8 */
  compression.width = 640;
  compression.height = 480;
  compression.bandwidth = 16;
  compression.qfactor = 60;
  return;
}

int GetBandwidth(void)
{
  return(compression.bandwidth);
}

void SetBandwidth(int newBandwidth, int setBySlider)
{
  if(compression.bandwidth == newBandwidth)
  {
    /*
     * No need to change the bandwidth.
     */
    return;
  }
  
  compression.bandwidth = newBandwidth;
  if(setBySlider == True)
  {
    SetRTVBandWidth(newBandwidth);
  }
  else
  {
    /*
     * Bandwidth set by the application.  Indicate the new
     * value.
     */
    XmScaleSetValue(imageQualitySlider, newBandwidth);
  }
  return;
}

int GetQfactor(void)
{
  return(compression.qfactor);
}

void SetQfactor(int newQfactor)
{
  compression.qfactor = newQfactor;
  SetRTVQfactor(newQfactor);
}


void SetCompressionSize(int newWidth, int newHeight)
{
  compression.width = newWidth;
  compression.height = newHeight;
  return;
}

int GetCompressionWidth(void)
{
  return(compression.width);
}


int GetCompressionHeight(void)
{
  return(compression.height);
}
