/*
 *   Copyright (c) 1990 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Murali. V. Srinivasan
 */
/* #define ASYNC_IO /* */
#define DOMAINLOOP /* */

#ifndef lint
static char *sid_xvideo_c = "@(#)xvideo.c	1.14 9/7/90 	Parallax Graphics Inc";
#endif

#define BLOCKSIZE 512

#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/asynch.h>
#include <sys/time.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#ifdef SYSTYPES
#include <sys/types.h>
#endif
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#ifdef ASYNC_IO
#include <sys/asynch.h>
#endif

#include <XPlxExt.h>
#include <Xm/Xm.h>
/*
#include <X11/Protocols.h>
*/
#include <Xm/Form.h>
#include <Xm/PanedW.h>
#include <Xm/BulletinB.h>
/* Menus */
#include <Xm/RowColumn.h>
#include <Xm/PushBG.h>

extern void exit();

static Widget top, swidget, dwidget;
static Widget popupshell;
static Atom exit_atom;
int videowidth = 320;
int videoheight = 240;
static int sourcewidth, sourceheight, sourcestart;
static Arg args[25];
static unsigned int n;
static short QFactor;
static GC compressGC, decompressGC;
static Display *display, *dpy;
static Window sourceWindow, destinationWindow, topWindow, pwin;
static int record_flag = -1;
static int print_flag = -1;
static int usingSharedMemory;
static int wait_flag = False;
static int first=1;
static int first1=1;
static int recfd, size;
static XPlxCImage *shmimage = NULL;
static XShmSegmentInfo shminfo;
static XEvent shm_ev;
static struct timeval ts, te;
static int frame_count = 0;
static unsigned long frame_size = 0;
static int max_frame_size = 0;
static int min_frame_size = 0x7fffffff;
static float seconds;
static unsigned char *qt;
static int holdit = 1 ;
static int location;

#ifdef ASYNC_IO
static  aio_result_t aiorslt[256];
static int whichaio = 0;
#endif

char pad_buffer[BLOCKSIZE];
XPlxCImage *pad_image;


/*
 * To clean up when program exit.
 */
static void
exit_func(sig, code, scp)
     int         code;
     int         sig;
     struct sigcontext *scp;
{
  if (usingSharedMemory)
  {
    XPlxShmDetach(dpy, &shminfo);
    shmdt(shminfo.shmid);
    shmctl(shminfo.shmid, IPC_RMID, 0);
  }
  close(recfd);
  exit(0);
}

#ifdef DOMAINLOOP
static void ehandler(w, cldata, event)
     Widget w;
     caddr_t cldata;
     XClientMessageEvent *event;
     
{
  int data = (int) cldata;
{
  if (event->data.l[0] == exit_atom)
    exit_func();
}
}

#else /* DOMAINLOOP */
static void ehandler(w, data, event)
     caddr_t data;
     Widget w;
     XEvent *event;
{
  XClientMessageEvent *me;
  if (event->type == ClientMessage && (w == swidget || w == dwidget))
  {
    me = (XClientMessageEvent *)event;
    if (me->data.l[0] == exit_atom)
      exit_func();
  }
}
#endif

static void exposit(w, data, event)
     Widget w;
     caddr_t data;
     XExposeEvent *event;
{
  if (w == swidget)
    first = 1;
  else
    first1 = 1;
}

static void get_size(dpy, win, w, h, bw)
     Display *dpy;
     Window win;
     int *w, *h, *bw;
{
  XWindowAttributes attrib;

  XGetWindowAttributes(dpy, win, &attrib);
  *w = attrib.width;
  *h = attrib.height;
  *bw = attrib.border_width;
}

static int flag = 0;

static void configit(w, data, event)
     Widget w;
     caddr_t data;
     XEvent *event;
{
  int i, j;
  if ((first == 0) || flag)
  {
    int bw;
    flag = 1;
    get_size(dpy, topWindow, &videowidth, &videoheight, &bw);

    if (videowidth > sourcewidth)
      videowidth = sourcewidth;
    if (videoheight > sourceheight)
      videoheight = sourceheight;
    if (((videowidth * 3) / 4) > ((videoheight * 4) / 3))
      videoheight = (videowidth * 3) / 4;
    else
      videowidth = (videoheight * 4) / 3;

    XtResizeWidget(top, videowidth, videoheight, bw);
    XtResizeWidget(swidget, videowidth, videoheight, bw);
    XtResizeWidget(popupshell, videowidth, videoheight, bw);
    XtResizeWidget(dwidget, videowidth, videoheight, bw);
    first = first1 = 1;
  }
}

static int loopflag = 0;

static void buttonp(w, data, event)
     Widget w;
     caddr_t data;
     XButtonEvent *event;
{
  if (w == dwidget)
  {
    loopflag = !loopflag;
    return;
  }
  if (record_flag < 0)
    record_flag = 0;
  record_flag = !record_flag;
  if (!record_flag)
  {
#ifdef ASYNC_IO
    aiowait(0);
    aiowait(0);
    lseek(recfd, location, SEEK_SET );
#endif
    pad_image->size = 0 ;
    if (write(recfd, pad_image, BLOCKSIZE) == -1)
    {
      perror("END MARKER");
      exit(-1);
    }
    /*
     * End of recording, print out statistic
     */
    gettimeofday(&te, 0);
    seconds = (float) (te.tv_sec - ts.tv_sec) +
      ((float) (te.tv_usec - ts.tv_usec) / (float) 1000000);
    printf("Recording:\n");
    printf("        %f frames per second\n", ((float) frame_count) / seconds);
    printf("        %f bytes per second\n", ((float) frame_size) / seconds);
    printf("        %d bytes maximum frame size\n", max_frame_size);
    printf("        %f bytes average frame size\n", ((float) frame_size) / frame_count);
    printf("        %d bytes minimum frame size\n", min_frame_size);
    /*
     * Start replaying statistic.
     */
    frame_count = 0;
    frame_size = 0;
    print_flag = !print_flag;
    gettimeofday(&ts, 0);
  }
  else
  {
    if (usingSharedMemory && wait_flag)
    {
      /*
       * Wait for the done event for last share memory put image.
       */
#ifdef HACK
      struct timeval tmps, tmpe;
      float sec;
      int ctl_flag = TRUE;

      gettimeofday(&tmps, 0);
      while (ctl_flag)
      {
	if (!XCheckTypedWindowEvent(dpy, destinationWindow,
				    XPlxShmGetEventBase(dpy) + ShmCompletion,
				    &shm_ev))
	{
	  gettimeofday(&tmpe, 0);
	  sec = (float) (tmpe.tv_sec - tmps.tv_sec) +
	    ((float) (tmpe.tv_usec - tmps.tv_usec) / (float) 1000000);
	  if (sec >= 10)
	  {
	    printf ("failed to get ShmCompletion event\n");
	    ctl_flag = FALSE;
	  }
	}
	else
	  ctl_flag = FALSE;
      }
#endif
      while (!XCheckTypedWindowEvent(dpy, destinationWindow,
				     XPlxShmGetEventBase(dpy) + ShmCompletion,
				     &shm_ev));
      wait_flag = False;
    }
    /*
     * Start recording statistic.
     */
    frame_count = 0;
    frame_size = 0;
    max_frame_size = 0;
    min_frame_size = 0x7fffffff;
    gettimeofday(&ts, 0);
  }
  if (lseek(recfd, 0L, SEEK_SET ) < 0)
  {
    perror("SEEK");
    exit(-1);
  } 
  first = 1;
  first1 = 1;
  location = 0;
}

#ifdef DOMAINLOOP
Boolean worker_shm(XtPointer data)
#else
     worker_shm()
#endif
{
  int i, count;
  
  if (record_flag < 0)
    return(FALSE);
  if (first)
    XPlxVideoTag(dpy, sourceWindow, compressGC, PLX_VIDEO);
  if (first1)
    XPlxVideoTag(dpy, destinationWindow, decompressGC, PLX_VIDEO);
  if (record_flag)
  {
    XPlxVideoSqueezeStill(dpy, sourceWindow, compressGC, 0, sourcestart, sourcewidth,
			  sourceheight, 0, 0, videowidth, videoheight);
    shmimage->width = videowidth;
    shmimage->height = videoheight;
    
#ifdef ASYNC_IO
    if (location)
    {
      aiowait(0);
      aiowait(0);
    }
#endif
    XPlxShmGetCImage(dpy, sourceWindow, compressGC, shmimage, 0, 0,
		     videowidth, videoheight);
    
    *pad_image = *shmimage ;
#ifdef ASYNC_IO
    if ((i = aiowrite(recfd, pad_image, BLOCKSIZE, location,
		      0, &aiorslt[whichaio])) < 0)
#else
      if (write(recfd, pad_image, BLOCKSIZE) < 0)
#endif
      {
	perror("W-HDR");
	exit(-1);
      }
    
#ifdef ASYNC_IO
    whichaio = (whichaio + 1) & 0xff;
    location += BLOCKSIZE;
    if ((i = aiowrite(recfd, shmimage->data, ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)), location,
		      0, &aiorslt[whichaio])) < 0)
#else
      if (write(recfd, shmimage->data, ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1))) < 0)
#endif
      {
	perror("W-IMAGE");
	exit(-1);
      }
    
#ifdef ASYNC_IO
    whichaio = (whichaio + 1) & 0xff;
    location += ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1));
#endif
    
    if (shmimage->size > max_frame_size)
      max_frame_size = shmimage->size;
    if (shmimage->size < min_frame_size)
      min_frame_size = shmimage->size;
    frame_size += shmimage->size;
    frame_count++;
  }
  else
  {
    if (!wait_flag)
      wait_flag = True;
    else
    {
      /*
       * Wait for the done event for last share memory put image.
       */
#ifdef HACK
      struct timeval tmps, tmpe;
      float sec;
      int ctl_flag = TRUE;
      
      gettimeofday(&tmps, 0);
      while (ctl_flag)
      {
	if (!XCheckTypedWindowEvent(dpy, destinationWindow,
				    XPlxShmGetEventBase(dpy) + ShmCompletion,
				    &shm_ev))
	{
	  gettimeofday(&tmpe, 0);
	  sec = (float) (tmpe.tv_sec - tmps.tv_sec) +
	    ((float) (tmpe.tv_usec - tmps.tv_usec) / (float) 1000000);
	  if (sec >= 10)
	  {
	    printf ("failed to get ShmCompletion event\n");
	    ctl_flag = FALSE;
	  }
	}
	else
	  ctl_flag = FALSE;
      }
#endif
      while (!XCheckTypedWindowEvent(dpy, destinationWindow,
				     XPlxShmGetEventBase(dpy) + ShmCompletion,
				     &shm_ev));
    }
    count = read(recfd, pad_image, BLOCKSIZE);
    if (count != BLOCKSIZE)
    {
      perror("HDR");
      exit(-1);
    }
    *shmimage = *pad_image ;
    if (shmimage->size == 0)
    {
      /*
       * End of replaying, print out statistic.
       */
      if (!print_flag)
      {
	gettimeofday(&te, 0);
	seconds = (float) (te.tv_sec - ts.tv_sec) +
	  ((float) (te.tv_usec - ts.tv_usec) / (float) 1000000);
	printf("Replaying:\n");
	printf("        %f frames per second\n", ((float) frame_count) / seconds);
	printf("        %f bytes per second\n", ((float) frame_size) / seconds);
	print_flag = !print_flag;
      }
      wait_flag = False;
      if (loopflag)
	lseek(recfd, 0, 0);
      else
	record_flag = -1;
      return(FALSE);
    }
    count = read(recfd, shmimage->data, ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)));
    if (count != ((shmimage->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)))
    {
      perror("IMAGE");
      exit(-1);
    }
    frame_size += shmimage->size;
    frame_count++;
    XPlxShmPutCImage(dpy, destinationWindow, decompressGC, shmimage, 0, 0, videowidth,
		     videoheight, 0, 0,  videowidth, videoheight, 0, True);
  } 
  if (first)
  {
    XPlxVideoTag(dpy, sourceWindow, compressGC, PLX_VIDEO_OVR);
    first = 0;
  }
  if (first1)
  {
    XPlxVideoTag(dpy, destinationWindow, decompressGC, PLX_VIDEO_OVR);
    first1 = 0;
  }
  return(FALSE);
} /* end function worker_shm */

#ifdef DOMAINLOOP
Boolean worker_nonshm(XtPointer data)
#else
     worker_nonshm()
#endif
{
  static XPlxCImage *image = NULL, recimage;
  XPlxCImage *timage;
  int i, count;
  char ibuf[0x10000];

  if (record_flag < 0)
    return(FALSE);

  if (first)
    XPlxVideoTag(dpy, sourceWindow, compressGC, PLX_VIDEO);
  if (first1)
    XPlxVideoTag(dpy, destinationWindow, decompressGC, PLX_VIDEO);

  if (record_flag)
  {
    timage = image;
    XPlxVideoSqueezeStill(dpy, sourceWindow, compressGC, 0, sourcestart, sourcewidth,
			  sourceheight, 0, 0, videowidth, videoheight);
    image = (XPlxCImage *) XPlxGetCImage(dpy, sourceWindow, compressGC, 0, 0,
					 videowidth, videoheight, videowidth, videoheight);
#ifdef ASYNC_IO
    if (timage)
    {
      aiowait(0);
      aiowait(0);
      XPlxDestroyCImage(timage);
    }
#endif
    *pad_image = *image;
#ifdef ASYNC_IO
    if((i = aiowrite(recfd, pad_image, BLOCKSIZE, location,
		     0, &aiorslt[whichaio])) < 0)
#else
      if (write(recfd, pad_image, BLOCKSIZE) < 0)
#endif
      {
	perror("W-HDR");
	exit(-1);
      }
#ifdef ASYNC_IO
    whichaio = (whichaio + 1) & 0xff;
    location += BLOCKSIZE;
    if((i = aiowrite(recfd, image->data, ((image->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)),location,
		     0, &aiorslt[whichaio])) < 0)
#else
      if (write(recfd, image->data, ((image->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1))) < 0)
#endif
      {
	perror("W-IMAGE");
	exit(-1);
      }

    if (image->size > max_frame_size)
      max_frame_size = image->size;
    if (image->size < min_frame_size)
      min_frame_size = image->size;
    frame_size += image->size;
    frame_count++;

#ifdef ASYNC_IO
    whichaio = (whichaio + 1) & 0xff;
    location += ((image->size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1));
#else
    XPlxDestroyCImage(image);
#endif
  }
  else
  {
    count = read(recfd, pad_image, BLOCKSIZE);

    if (count != BLOCKSIZE)
    {
      perror("HDR");
      exit(-1);
    }
    recimage = *pad_image ;

    recimage.data = ibuf;

    if (recimage.size == 0)
    {
      /*
       * End of replaying, print out statistic.
       */
      if (!print_flag)
      {
	gettimeofday(&te, 0);
	seconds = (float) (te.tv_sec - ts.tv_sec) +
	  ((float) (te.tv_usec - ts.tv_usec) / (float) 1000000);
	printf("Replaying:\n");
	printf("        %f frames per second\n", ((float) frame_count) / seconds);
	printf("        %f bytes per second\n", ((float) frame_size) / seconds);
	print_flag = !print_flag;
      }

      if (loopflag)
	lseek(recfd, 0, 0);
      else
	record_flag = -1;

      return(FALSE);
    }

    count = read(recfd, recimage.data, ((recimage.size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)));

    if (count != ((recimage.size + (BLOCKSIZE - 1)) & ~(BLOCKSIZE - 1)))
    {
      perror("IMAGE");
      exit(-1);
    }

    frame_size += recimage.size;
    frame_count++;

    XPlxPutCImage(dpy, destinationWindow, decompressGC, &recimage, 0, 0, videowidth,
		  videoheight, 0, 0,  videowidth, videoheight, 1);
  }

  if (first)
  {
    XPlxVideoTag(dpy, sourceWindow, compressGC, PLX_VIDEO_OVR);
    first = 0;
  }

  if (first1)
  {
    XPlxVideoTag(dpy, destinationWindow, decompressGC, PLX_VIDEO_OVR);
    first1 = 0;
  }

  return(FALSE);
}

static void usage(c)
     char *c;
{
  printf("usage: %s [-q #] [-f filename] [-n]\n", c);
  exit(1);
}


void main(argc, argv)
     int argc;
     char **argv;
{
  XtAppContext app_context;
  plx_IO *plxio;
  plx_IO_list *iolist;
  plx_signal_list *siglist;
  plx_signal *sig;
  int i, tmp, badsync;
  char *name1 = ":0.0";
  char *name2 = "unix:0.0";
  char *msg = "Fail to create shared memory, it is running on non-shared memory\n";
  static char *filename = "/tmp/theimage";
  static int mask = ButtonPressMask | ExposureMask;
  static int mask1 = StructureNotifyMask;
  static Boolean (*worker)(XtPointer) = worker_nonshm;
  int screen;
  Colormap colormap;
  int copy_of_argc;
  char ** copy_of_argv;
  int argv_size;
  XVisualInfo * visualInfo;
    
  pad_image = (XPlxCImage *)pad_buffer;
  usingSharedMemory = True;
  QFactor = 100;						    /* default valuse */
  /*
   * install signal handler for kill and crahses.
   */
  signal (SIGINT, exit_func);
  signal (SIGSEGV, exit_func);
  signal (SIGBUS, exit_func);
  
  /*
   * command line option to overrride the default
   * value of the QFactor and filename. The -n
   * option is for turning off shared memory.
   */
  for (i = 1; i < argc; ++i)
  {
    if (strcmp("-q", argv[i]) == 0)
    {
      if (sscanf(argv[++i], "%d", &tmp) != 1)
	usage(argv[0]);
      QFactor = tmp;
    }
    else if (strcmp("-f", argv[i]) == 0)
      filename = argv[++i];
    else if(strcmp("-n", argv[i]) == 0)
      usingSharedMemory = False;
    else
      usage(argv[0]);
  }
  size = MakeQTables(QFactor, &qt);				    /* Make the q tables. if you change the qfactor you must... */
  n = 0;							    /* ...call MakeQTables(). */
  XtSetArg(args[n], XtNborderWidth, 0); n ++;
  XtSetArg(args[n], XtNwidth, videowidth); n ++;
  XtSetArg(args[n], XtNheight, videoheight); n++;
  
  XtToolkitInitialize();
  app_context = XtCreateApplicationContext();
  copy_of_argc = argc;
  argv_size = argc * (sizeof(char*));
  copy_of_argv = (char**) XtMalloc(argv_size);
  memcpy(copy_of_argv, argv, argv_size);
  
  display = XtOpenDisplay(app_context,
			  NULL,
			  NULL,
			  "fcomp",
			  (XrmOptionDescList) NULL,
			  0,
			  &argc, argv);
  if((Display *) NULL == display)
  {
    printf("Unable to open local display check permisions\n");
    exit(1);
  }
  screen = DefaultScreen(display);
  visualInfo = XPlxGetVideoVisual(screen, display);
  if(visualInfo == (XVisualInfo*)NULL)
  {
    XtWarning("Could not find a visual suitable for displaying video and JPEG images.");
    exit(-1);
  }
  colormap = XCreateColormap(display,
			     XRootWindow(display, screen),
			     visualInfo->visual,
			     AllocNone);
  n = 0;
  XtSetArg(args[n], XmNvisual, visualInfo->visual); n++;
  XtSetArg(args[n], XmNdepth, visualInfo->depth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  XtSetArg(args[n], XmNargc, copy_of_argc); n++;
  XtSetArg(args[n], XmNargv, copy_of_argv); n++;
  
  top = XtAppCreateShell("fcomp",
			 "tcomp",
			 applicationShellWidgetClass,
			 display,
			 args, n);
  
  n = 0;
  XtSetArg(args[n], XmNvisual, visualInfo->visual); n++;
  XtSetArg(args[n], XmNdepth, visualInfo->depth); n++;
  XtSetArg(args[n], XmNcolormap, colormap); n++;
  
  popupshell = XtAppCreateShell("destination",
				"Compress",
				applicationShellWidgetClass,
				display,
				args, n);
  
  n = 0;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  XtSetArg(args[n], XmNwidth, videowidth); n ++;
  XtSetArg(args[n], XmNheight, videoheight); n++;
  swidget = XtCreateManagedWidget("src", xmBulletinBoardWidgetClass, top,
				  args, n);
  dwidget = XtCreateManagedWidget("dest", xmBulletinBoardWidgetClass,
				  popupshell, args, n);
  /*
   * all set up, let her fly.
   */
  XtRealizeWidget(top);
  XtRealizeWidget(popupshell);
  dpy = XtDisplay(swidget);
  topWindow = XtWindow(top);
  pwin = XtWindow(popupshell);
  sourceWindow = XtWindow(swidget);
  destinationWindow = XtWindow(dwidget);
  compressGC = XCreateGC(dpy, sourceWindow, 0, 0);
  decompressGC = XCreateGC(dpy, destinationWindow, 0, 0);
  XSetForeground(dpy, compressGC, 0);
  XSetForeground(dpy, decompressGC, 0);
  
  XPlxPutTable(dpy, sourceWindow, compressGC, qt, size, 0);	    /* Store qtables for compress and decompress in the GCs */
  XPlxPutTable(dpy, destinationWindow, decompressGC, qt, size, 1);
  if (usingSharedMemory &&
      ((strncmp (name1, dpy->display_name, strlen(name1)) == 0) ||
       (strncmp (name2, dpy->display_name, strlen(name2)) == 0)))
  {
    tmp = XPlxShmGetEventBase(dpy) + ShmCompletion;
    shminfo.shmid = shmget(IPC_PRIVATE, 256 * 1024, IPC_CREAT|0777);
    if (shminfo.shmid < 0)
    {
      perror(msg);
      usingSharedMemory = False;
    }
    else
    {
      shminfo.shmaddr = (char *)shmat(shminfo.shmid, 0, 0);
      if (shminfo.shmaddr == ((char *)-1))
      {
	perror(msg);
	usingSharedMemory = False;
      }
      else
      {
	shmimage = (XPlxCImage *)XPlxShmCreateCImage(dpy, shminfo.shmaddr,
						     &shminfo, 0, 0, 0);
	shminfo.readOnly = False;
	XPlxShmAttach(dpy, &shminfo);
	worker = worker_shm;
      }
    }
  }
  if ((recfd = open(filename, O_RDWR | O_CREAT)) < 0) {
    perror(filename);
    exit(-1);
  }
  unlink(filename);
  
#ifdef DOMAINLOOP
  XtAddEventHandler(swidget, ButtonPressMask, False, buttonp, NULL);
  XtAddEventHandler(dwidget, ButtonPressMask, False, buttonp, NULL);
  XtAddEventHandler(swidget, StructureNotifyMask, False, configit, NULL);
  XtAddEventHandler(swidget, ExposureMask, False, exposit, NULL);
  XtAddEventHandler(dwidget, ExposureMask, False, exposit, NULL);
  XtAddEventHandler(top, 0, False, ehandler, NULL);
  XtAddEventHandler(popupshell, 0, False, ehandler, NULL);
  XtAppAddWorkProc(app_context, worker, NULL);
#endif
  exit_atom = XInternAtom(dpy, "WM_DELETE_WINDOW", False);
  
  plxio = (plx_IO *) XPlxQueryConfig(dpy, sourceWindow, compressGC); /* Query the server to get hardware/signal information. */
  if(plxio->hardware != PLX_XVIDEO_24)				    /* If the hardware type is not XVideo, can't work */
  {
    printf("%s can only run on Parallax XVideo hardware\n", argv[0]);
    exit(1);
  }
  for (iolist = plxio->inputs;					    /* Find a pointer to channel one input */
       iolist && (iolist->channel != PLX_INPUT_0);
       iolist = iolist->next_IO);				    /* has to work, can't fail */
  badsync = 1;							    /* Go through the list of signals and find an active signal */
  for (siglist = iolist->signal_list; siglist;
       siglist = siglist->next_signal)
  {
    /*
     * do an input select
     * we are only using input 0 so it, and PLX_COMP are hard coded
     * we also know that all the XVideo hardware can do is PLX_RGB24
     */
    XPlxVideoInputSelect(dpy, sourceWindow, compressGC, PLX_INPUT_0,
			 siglist->signal->standard,
			 PLX_COMP, PLX_RGB24);
    sig = (plx_signal *) XPlxQueryVideo(dpy, sourceWindow, compressGC);	/* Now do a query video to find out if there is sync */
    if (sig->sync_ok)
    {
      badsync = 0;
      break;
    }
  }
  if (badsync)
  {
    printf("no video connected to input 0\n");
    exit(1);
  }
  sourcewidth = sig->w;
  tmp = (sig->w * 3) / 4;
  sourceheight = tmp;
  tmp = sig->h - tmp;
  sourcestart = tmp + 1;
  
#ifdef DOMAINLOOP
  XtAppMainLoop(app_context);
#else
  XSelectInput(dpy, sourceWindow, mask);
  XSelectInput(dpy, destinationWindow, mask);
  while(1)
  {
    XEvent event;
    XExposeEvent *xevent;
    XConfigureEvent *cevent;
    XClientMessageEvent *mevent;
    
    if (record_flag >= 0)
      worker();
    if (XPending(dpy))
    {
      if (XCheckWindowEvent(dpy, sourceWindow, mask, &event))
      {
	if (event.type == ButtonPress)
	  buttonp(swidget, 0, &event);
	else
	  first = 1;
	continue;
      }
      if (XCheckWindowEvent(dpy, destinationWindow, mask, &event))
      {
	if (event.type == ButtonPress)
	  loopflag = !loopflag;
	else
	  first1 = 1;
	continue;
      }
      if (XCheckWindowEvent(dpy, topWindow, mask1, &event))
      {
	configit(swidget, 0, &event);
	continue;
      }
      if (XCheckTypedWindowEvent(dpy, topWindow, ClientMessage, &event))
      {
	mevent = (XClientMessageEvent *)&event;
	if (mevent->data.l[0] == exit_atom)
	  exit_func();
      }
      if (XCheckTypedWindowEvent(dpy, pwin, ClientMessage, &event))
      {
	mevent = (XClientMessageEvent *)&event;
	if (mevent->data.l[0] == exit_atom)
	  exit_func();
      }
    }
  }
#endif
} /* end program */
