/*
 *   Copyright (c) 1991 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Dave Arnold
 */
#ifndef lint
static char *sid_tcomp = "@(#)tcomp.c	1.0 9/1/91 	Parallax Graphics Inc";
#endif

#define DOMAINLOOP /* */
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#ifndef OPENLOOK
#include <Xm/Xm.h>
/*
#include <X11/Protocols.h>
*/
#include "Xm/PanedW.h"
#include "Xm/BulletinB.h"
 
/* Menus */
#include "Xm/RowColumn.h"
#include "Xm/PushBG.h"
#include "Xm/XmStrDefs.h"
 
/* Added for use with Motif pushbuttons */
 
#include "Xm/CascadeB.h"
#include "Xm/PushB.h"
#include "Xm/RowColumn.h"
#include "Xm/Form.h"
#include "Xm/DrawingA.h"
#else
#include <Xol/OpenLook.h>
#include <Xol/BulletinBo.h>
#include <Xol/OlClients.h>
#include <Xol/OpenLook.h>
#include <Xol/Button.h>
#include <Xol/Exclusives.h>
#include <Xol/Menu.h>
#include <Xol/MenuButton.h>
#include <Xol/OblongButt.h>
#include <Xol/OlClients.h>
#include <Xol/ControlAre.h>
#include <Xol/FooterPane.h>
#include <Xol/RectButton.h>
#include <Xol/StaticText.h>
#include <Xol/TextField.h>
#include <Xol/Form.h>

#endif 	/* OPENLOOK */

#include <XPlxExt.h>
#include <XVideoIn.h>

XVisualInfo* GetDefaultVisualInfo(int screenNumber,
			      Display* display);
XVisualInfo* GetTrueColorVisual(int 		screenNumber,
				Display*	display);

static Widget top, swidgetform, swidget, dwidgetform, dwidget;
static Widget stop,start;
static Widget controlPopup,remotePopup,control,form;
int videowidth = 320;
int videoheight = 240;
static int sourcewidth, sourceheight, sourcestart;
static Arg args[25];
static unsigned int n;
static GC localGC, remoteGC;
static Display *localDisplay, *remoteDisplay;
static Window localVideoWindow, remoteJPEGWindow, localTopWindow, remoteTopWindow;
static int first = 1, first1 = 1;

/* external declarations necessary now but not forever */

static unsigned char *qt;
static int size;
static short QFactor;
static int holdit = 1 ;

/*
 *	this function figures the size of a window since sometimes the
 *	the xt functions don't work properly.
 */
static void get_size(localDisplay, win, w, h, bw)
Display *localDisplay;
Window win;
int *w, *h, *bw;
{
        XWindowAttributes attrib;

        XGetWindowAttributes(localDisplay, win, &attrib);
        *w = attrib.width;
        *h = attrib.height;
        *bw = attrib.border_width;
}

/*
 *	function to make the destination window the same size as the source
 *	when the source size changes.
 */

static int flag = 0;
void configit(Widget	w,
	      XtPointer	data,
	      XEvent*	event,
	      Boolean*	unusedBooleanPointer)
{
	if((first == 0) || flag)
	{
		int bw;
		flag = 1;

		get_size(localDisplay, localTopWindow, &videowidth, &videoheight, &bw);
		if(videowidth > sourcewidth)
		    videowidth = sourcewidth;
		if(videoheight > sourceheight)
		    videoheight = sourceheight;
		if(((videowidth * 3) / 4) > ((videoheight * 4) / 3))
		    videoheight = (videowidth * 3) / 4;
		else
		    videowidth = (videoheight * 4) / 3;
		XtResizeWidget(top, videowidth, videoheight, bw);
		XtResizeWidget(remotePopup, videowidth, videoheight, bw);
		first = 1;
		first1 = 1;
	}
}

/*
 *	Since we tag the windows such that the tag is not drawn
 *	we need to tag as video so the next video/decompress
 *	will set the tags properly
 */

void exposit(Widget	w,
	     XtPointer	data,
	     XEvent*	event,
	     Boolean*	unusedBooleanPointer)
{
	if(w == swidget)
	    first = 1;
	else
	    first1 = 1;
}

static int loopflag = 0;

/*
 *      Start things going on first button press
 */

void Start(Widget w, XtPointer data, XtPointer event)
{
        holdit = 0 ;
}

void Stop(Widget w, XtPointer data, XtPointer event)
{
  XPlxVideoStop(localDisplay, localVideoWindow, localGC);
  exit(0);
}

void buttonp(Widget w, XtPointer data, XtPointer event)
{
	holdit = 0 ;
}

/*
 *	Main work process.
 *	compress a video image, then decompress it
 */

Boolean	worker(XtPointer data)
{
	static XPlxCImage *image = NULL,recimage;
	int count;
	char ibuf[0x10000];
	int i;

	if (holdit) return FALSE; /* wait until button is pressed */

	if(first)
	{
	  XPlxVideoTag(localDisplay, localVideoWindow, localGC, PLX_VIDEO);
	  
	  /* Start the live video in the local display */
	  XPlxVideoSqueezeLive(localDisplay, localVideoWindow, localGC, 0,
			       sourcestart, sourcewidth, sourceheight, 0, 0,
			       videowidth, videoheight);
	}
	if(first1)
	    XPlxVideoTag(remoteDisplay, remoteJPEGWindow, remoteGC, PLX_VIDEO);

	/* Get a compressed image */
	image = (XPlxCImage *) XPlxGetCImage(localDisplay, localVideoWindow, localGC, 0, 0,
		  videowidth, videoheight, videowidth, videoheight);

	/* decompress the image into the destination window */
	XPlxPutCImage(remoteDisplay, remoteJPEGWindow, remoteGC, image, 0, 0, 
	    videowidth, videoheight, 0, 0,  videowidth, videoheight, 1);

	/* free up storage */
	XPlxDestroyCImage(image);

	/*
	 * set the tag such that subsequent video/decompress will not
	 * set the tag bits, saves time.
	 */

	if(first) /* only do this when necessary */
	{
	    XPlxVideoTag(localDisplay, localVideoWindow, localGC, PLX_VIDEO_OVR);
	    first = 0;
	}

	if(first1) /* only do this when necessary */
	{
	    XPlxVideoTag(remoteDisplay, remoteJPEGWindow, remoteGC, PLX_VIDEO_OVR);
	    first1 = 0;
	}

	return(FALSE); /* work processes must return FALSE */
}

static void usage()
{
	printf("tcomp remote display [-q qfactor]\n");
	exit(1);
}

void main(argc, argv)
int argc;
char **argv;
{
	XtAppContext app_context;
	char *displayName;
	plx_IO *plxio;
	plx_IO_list *iolist;
	plx_signal_list *siglist;
	plx_signal *sig;
	static int mask = ButtonPressMask | ExposureMask;
	static int mask1 = StructureNotifyMask;
	int localScreen, remoteScreen;
	Colormap localColormap, remoteColormap;
	XVisualInfo *localVisual;
	XVisualInfo *remoteVisual;
	XVisualInfo *defaultVisual;
	int copy_of_argc;
	char** copy_of_argv;
	int argv_size;
	int i, tmp, badsync;
        XWindowAttributes winAttrs;


	/*
	 * make the q tables. if you change the qfactor you must call
	 * MakeQtables
	 */

	QFactor = 50;

	/* the rest from here is straight xt/openlook stuff */


	XtToolkitInitialize();
        app_context = XtCreateApplicationContext();

	copy_of_argc = argc;
	argv_size = argc * (sizeof(char*));
	copy_of_argv = (char**) XtMalloc(argv_size);
	memcpy(copy_of_argv, argv, argv_size);

        localDisplay = XtOpenDisplay(app_context,
				     NULL,
				     NULL,
				     "tcomp",
				     (XrmOptionDescList) NULL,
				     0,
				     &argc, argv);
	if((Display *) NULL == localDisplay)
	{
	    printf("Unable to open local display check permisions\n");
	    exit(1);
	}

	localScreen = DefaultScreen(localDisplay);
        /*
         * Set up the TrueColor visual:
         */

        localVisual = GetTrueColorVisual(localScreen, localDisplay);
	if(localVisual == (XVisualInfo*)NULL)
	{
	  XtWarning("Could not find the TrueColor visual being requested.");
	  exit(-1);
	}

	n = 0;
	XtSetArg(args[n], XmNvisual, localVisual->visual); n++;
	XtSetArg(args[n], XmNdepth, localVisual->depth); n++;

	defaultVisual = GetDefaultVisualInfo(localScreen, localDisplay);
	if((defaultVisual->class == localVisual->class) &&
	   (defaultVisual->depth == localVisual->depth))
	{
	  XGetWindowAttributes(localDisplay,
			       XRootWindow(localDisplay, localScreen),
			       &winAttrs);
	  localColormap = winAttrs.colormap;
	}
	else
	{
	  localColormap = XCreateColormap(localDisplay,
					  XRootWindow(localDisplay, localScreen),
					  localVisual->visual,
					  AllocNone);
	}

	XtSetArg(args[n], XmNcolormap, localColormap); n++;
	XtSetArg(args[n], XmNargc, copy_of_argc); n++;
	XtSetArg(args[n], XmNargv, copy_of_argv); n++;

	top = XtAppCreateShell("tcomp",
			       "tcomp",
			       applicationShellWidgetClass,
			       localDisplay,
			       args, n);

	if(argc < 2)
	    usage();
        displayName = argv[1];

	if(argc > 2)
	{
	    int i;
	    if(strcmp(argv[2], "-q"))
		usage;
	    else
	    {
		sscanf(argv[3], "%d", &i);
		QFactor = i;
	    }
	}

	size = MakeQTables(QFactor,&qt);

	remoteDisplay=XtOpenDisplay(app_context, displayName, "tcomp", "tcomp",
				    NULL, 0, &argc, (String *)argv);
	
	if((Display *)NULL == remoteDisplay)
	{
	    printf("Unable to open display %s, check permisions\n", displayName);
	    exit(1);
	}

	remoteScreen = DefaultScreen(remoteDisplay);

	remoteVisual = GetTrueColorVisual(remoteScreen, remoteDisplay);
	if(remoteVisual == (XVisualInfo*)NULL)
	{
	  XtWarning("Could not find the TrueColor visual being requested.");
	  exit(-1);
	}

	n = 0;
	n = 0;
	XtSetArg(args[n], XmNvisual, remoteVisual->visual); n++;
	XtSetArg(args[n], XmNdepth, remoteVisual->depth); n++;

	defaultVisual = GetDefaultVisualInfo(remoteScreen, remoteDisplay);
	if((defaultVisual->class == remoteVisual->class) &&
	   (defaultVisual->depth == remoteVisual->depth))
	{
	  XGetWindowAttributes(remoteDisplay,
			       XRootWindow(remoteDisplay, remoteScreen),
			       &winAttrs);
	  remoteColormap = winAttrs.colormap;
	}
	else
	{
	  remoteColormap = XCreateColormap(remoteDisplay,
					   XRootWindow(remoteDisplay, remoteScreen),
					   remoteVisual->visual,
					   AllocNone);
	}

	XtSetArg(args[n], XmNcolormap, remoteColormap); n++;

	remotePopup = XtAppCreateShell("remote","tcomp",
		applicationShellWidgetClass, remoteDisplay, args, n);

#ifdef DOMAINLOOP
        n = 0;
        XtSetArg(args[n], XtNwidth, videowidth); n++;
        XtSetArg(args[n], XtNheight, 50); n++;

        controlPopup = XtAppCreateShell("Controls","Controls",
                applicationShellWidgetClass, XtDisplay(top), args, n);

	n = 0;
	XtSetArg(args[n], XtNborderWidth, 0); n++;
	form = XtCreateManagedWidget("form", xmFormWidgetClass,
                        controlPopup, args, n);

	n = 0;
	XtSetArg(args[n], XtNorientation, XmHORIZONTAL); n++;
        control = XtCreateManagedWidget("control", xmRowColumnWidgetClass,
                        form, args, n);

        n = 0;
        start = XtCreateManagedWidget("Start Session", xmPushButtonGadgetClass,
                        control, args, n);
        XtAddCallback(start,XmNactivateCallback,Start,NULL);
 
        n = 0;
        stop = XtCreateManagedWidget("Stop Session", xmPushButtonGadgetClass,
                        control, args, n);
        XtAddCallback(stop,XmNactivateCallback,Stop,NULL);
#endif

	n = 0;
        XtSetArg(args[n], XtNborderWidth, 0); n ++;
        XtSetArg(args[n], XtNwidth, videowidth); n ++;
        XtSetArg(args[n], XtNheight, videoheight); n++;
        swidgetform = XtCreateManagedWidget("src", xmFormWidgetClass, top,
              args, n);

        dwidgetform = XtCreateManagedWidget("dest", xmFormWidgetClass,
                remotePopup, args, n);

	n = 0;
	XtSetArg(args[n], XtNborderWidth, 0); n++;
	XtSetArg(args[n], XtNwidth, videowidth); n++;
	XtSetArg(args[n], XtNheight, videoheight); n++;
        swidget = XtVaCreateManagedWidget("src", xmDrawingAreaWidgetClass,
					  swidgetform,
					  XmNtopAttachment, XmATTACH_FORM,
					  XmNrightAttachment, XmATTACH_FORM,
					  XmNbottomAttachment, XmATTACH_FORM,
					  XmNleftAttachment, XmATTACH_FORM,
					  XmNbackground,
					  BlackPixel(localDisplay, localScreen),
					  NULL);  

        dwidget = XtVaCreateManagedWidget("dest", xmDrawingAreaWidgetClass,
					  dwidgetform,
					  XmNtopAttachment, XmATTACH_FORM,
					  XmNrightAttachment, XmATTACH_FORM,
					  XmNbottomAttachment, XmATTACH_FORM,
					  XmNleftAttachment, XmATTACH_FORM,
					  XmNbackground,
					  BlackPixel(remoteDisplay, remoteScreen),
					  NULL);  
					  

#ifdef DOMAINLOOP
	XtAddEventHandler(swidget, StructureNotifyMask, False, configit, NULL);
	XtAddEventHandler(swidget, ExposureMask, False, exposit, NULL);
	XtAddEventHandler(dwidget, ExposureMask, False, exposit, NULL);
	XtAppAddWorkProc(app_context, worker, NULL);

#endif


	/*
	 * all set up, let her fly.
	 */

	XtRealizeWidget(top);
	XtRealizeWidget(remotePopup);

#ifdef DOMAINLOOP
	XtRealizeWidget(controlPopup);
#endif

	localTopWindow = XtWindow(top);
	remoteTopWindow = XtWindow(remotePopup);
	localVideoWindow = XtWindow(swidget);
	remoteJPEGWindow = XtWindow(dwidget);
	localGC = XCreateGC(localDisplay, localVideoWindow, 0, 0);
	remoteGC = XCreateGC(remoteDisplay, remoteJPEGWindow, 0, 0);

	XSetForeground(localDisplay, localGC, 0);
	XSetForeground(remoteDisplay, remoteGC, 0);

	/*
	 * query the server to get hardware/signal information.
	 */
	plxio = (plx_IO *) XPlxQueryConfig(localDisplay, localVideoWindow, localGC);

	/* if the hardware type is not XVideo, can't work */

	if(plxio->hardware != PLX_XVIDEO_24)
	{
	    printf("%s can only run on Parallax XVideo hardware\n", argv[0]);
	    exit(1);
 	}

	/* find a pointer to channel one input */

	for (iolist = plxio->inputs; iolist && (iolist->channel != PLX_INPUT_0);
	     iolist = iolist->next_IO); /* has to work, can't fail */

	/* go through the list of signals and find an active signal */

	badsync = 1;

	for(siglist = iolist->signal_list; siglist;
	    siglist = siglist->next_signal)
	{
	    /*
	     * do an input select
	     * we are only using input 0 so it, and PLX_COMP are hard coded
	     * we also know that all the XVideo hardware can do is PLX_RGB24
	     */
	   
	    XPlxVideoInputSelect(localDisplay, localVideoWindow, localGC, PLX_INPUT_0,
				 siglist->signal->standard,
				 PLX_COMP, PLX_RGB24);

	    /* now do a query video to find out if there is sync */

	    sig = (plx_signal *) XPlxQueryVideo(localDisplay, localVideoWindow, localGC);
	    if(sig->sync_ok)
	    {
		badsync = 0;
		break;
	    }
	}

	if(badsync)
	{
	    printf("no video connected to input 0\n");
	    exit(1);
	}

	sourcewidth = sig->w;
	sourceheight = (sig->w * 3) / 4;
	sourcestart = sig->h - sourceheight;

	/* store qtables for compress and decompress in the GCs */

	XPlxPutTable(localDisplay,
		     localVideoWindow,
		     localGC,
		     (char*)qt,
		     size,
		     0);
	XPlxPutTable(remoteDisplay,
		     remoteJPEGWindow,
		     remoteGC,
		     (char*)qt,
		     size,
		     1);

	XFlush(localDisplay);
	XFlush(remoteDisplay);

#ifdef DOMAINLOOP
	XtAppMainLoop(app_context);
#else
	XSelectInput(localDisplay, localVideoWindow, mask);
	XSelectInput(remoteDisplay, remoteJPEGWindow, mask);

	while(1)
	{
	    XEvent event;
	    XExposeEvent *xevent;
	    XConfigureEvent *cevent;

	    worker(NULL);

	    if(XPending(localDisplay))
	    {
		if(XCheckWindowEvent(localDisplay, localVideoWindow, mask, &event))
		{
		    if(event.type == ButtonPress)
		        buttonp(swidget, 0, &event);
		    else
			exposit(swidget, 0, &event, NULL);
		    continue;
		}

		if(XCheckWindowEvent(remoteDisplay, remoteJPEGWindow, mask, &event))
		{
		    if(event.type == ButtonPress)
		        buttonp(dwidget, 0, &event);
		    else
			exposit(dwidget, 0, &event, NULL);
		    continue;
		}

		if(XCheckWindowEvent(localDisplay, localTopWindow, mask1, &event))
		{
		    configit(swidget, 0, &event, NULL);
		    continue;
		}
	    }
	}
#endif
}

XVisualInfo* GetDefaultVisualInfo(int screenNumber,
			      Display* display)
{
  long			visualInfoMask;
  int			visualsMatched;
  XVisualInfo		visualHints;
  static XVisualInfo*	visualList = (XVisualInfo*)NULL;
  Visual*		tempVisual;

  if (visualList != (XVisualInfo*)NULL)
    free(visualList);
  tempVisual = XDefaultVisual(display,				    /* Failed to get a TrueColor visual, so get the default... */
			      XDefaultScreen(display));		    /* ...visual. */
  visualHints.visualid = tempVisual->visualid;
  visualInfoMask = (VisualIDMask);				    /* For the HP product, don't actually need a TrueColor class */
  visualList = XGetVisualInfo(display,
			      visualInfoMask,
			      &visualHints,	
			      &visualsMatched);
  if (visualsMatched == 0)					    /* Did the search for, in essence, *any* visual fail? */
    return((XVisualInfo*)NULL);					    /* Yes, return a NULL structure to represent failure */
  return(visualList);						    /* If this statement was reached, no good fallback was... */
								    /* ...found.  In this case, simply return the first... */
								    /* ...visual found. */
}


XVisualInfo* GetTrueColorVisual(int 		screenNumber,
				Display*	display)
{
  int			i;
  long			visualInfoMask;
  int			visualsMatched;
  XVisualInfo		visualHints;
  static XVisualInfo*	visualList = (XVisualInfo*)NULL;
  XVisualInfo*		theVisual;
  Visual*		tempVisual;
  
  if (visualList != (XVisualInfo*)NULL)				    /* Was data saved by a previous call to this function? */
    XFree((void*)visualList);					    /* Yes, release the data since it is no longer needed */
  visualHints.class = TrueColor;				    /* Set up hints to determine the type of visual needed... */
  visualHints.screen = screenNumber;				    /* ...to create a window that can display video */
  visualInfoMask = (VisualClassMask | VisualScreenMask);	    /* For Sun, need to get real TrueColor class */
  visualList = XGetVisualInfo(display,				    /* Try to find a visual that matches what is needed for... */
			      visualInfoMask,			    /* ... a window that will display video or TrueColor... */
			      &visualHints,			    /* ...graphics. */
			      &visualsMatched);
  if (visualsMatched != 0)					    /* Did the search for a TrueColor visual fail? */
  {								    /* No */
    for (theVisual = visualList, i = 0;				    /* Look at all the visuals returned by XGetVisualInfo... */
	 i < visualsMatched;					    /* ...to find the best match.  The idea match would be... */
	 i++, theVisual++)					    /* ...a 24-bit depth Visual. */
    {
      if (theVisual->depth == 24)					    /* Was an ideal match found? */
	return(theVisual);					    /* Yes, return this Visual */
    }
    for (theVisual = visualList, i = 0;				    /* If this statement is reached, no 24-bit TrueColor... */
	 i < visualsMatched;					    /* ...Visual was found; in this case, fallback and try... */
	 i++, theVisual++)					    /* ...to find the next best thing: any TrueColor visual... */
    {								    /* ...of depth >= 24 bits (probably a 32-bit is what will... */
      if (theVisual->depth >= 24)					    /* ...be found). */
	return(theVisual);					    /* Was a good fallback Visual found?  If so, return it. */
    }
  }

  return(GetDefaultVisualInfo(screenNumber, display));
}								    /* end function GetTrueColorVisual */
