/* (c) Copyright 1991-1995 Parallax Graphics Inc, All Rights Reserved */

static char* rcsid = "$Id: xlib_test.c,v 1.89 1995/09/19 21:33:01 drapeau Exp $";

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <XPlxExt.h>
#include <XPlxProtos.h>

Widget			top, video_widget;
plx_IO*			plxio = NULL;
plx_signal*		plxsignal = NULL;
static Arg		args[25];
static unsigned int	n;
int			videowidth = 640;
int			videoheight = 512;


void main(argc, argv)
     int argc;
     char **argv;
{
  Window		win;
  Display*		disp;
  int			scr;
  int			mask;
  GC			gc; 
  XEvent		event;
  XSetWindowAttributes	attr;
  XVisualInfo		vinfo;
  int			depth = 32;
  XVisualInfo*		visualInfo;
  
  disp = XOpenDisplay(getenv("DISPLAY"));			    /* Connect your client program with the X server	*/
  scr = (int) XDefaultScreen(disp);				    /* Get a default screen				*/
  visualInfo = XPlxGetVideoVisual(scr, disp);			    /* Get a proper Visual for using 24-bit video in a window */
  depth = visualInfo->depth;
  if (TrueColor == visualInfo->class)				    /* Was a TrueColor visual successfully obtained? */
  {								    /* Yes, create a colormap for this window */
    attr.colormap = XCreateColormap(disp, XRootWindow(disp, scr),
				    visualInfo->visual, AllocNone);
  }
  else								    /* No, use the default colormap for this display and screen */
  {
    attr.colormap = XDefaultColormap(disp, scr);
  }
  mask = CWBackPixel |						    /*	WARNING!!! Must set up the colormap, the... */
    CWColormap |						    /* ...background_pixel and the border_pixel to make it... */
      CWBorderPixel;						    /* ...work when the window depth is diff. from root depth.  */
  attr.background_pixel = BlackPixel(disp, DefaultScreen(disp));
  attr.border_pixel = WhitePixel(disp, DefaultScreen(disp));
  win = XCreateWindow(disp, RootWindow(disp, scr),		    /* 	Create the drawable for the XPlx calls		*/
		      0, 0, videowidth, videoheight, 1, depth,
		      InputOutput, visualInfo->visual, mask, &attr);
  gc = XCreateGC(disp, win, 0, 0);				    /* 	WARNING!!! Must create the gc with the window */
  XFlush(disp);
  plxio = XPlxQueryConfig(disp, win, gc);			    /*	Query the hardware for configuration parameters */
  XPlxVideoInputSelect(disp, win, gc,				    /* Ask for input on channel 0, with the following... */
		       PLX_INPUT_0,				    /* ...characteristics: */
		       PLX_NTSC,				    /* Standard = NTSC */
		       PLX_COMP,				    /* Format = Composite */
		       PLX_RGB24);				    /* Type = RGB24 */
  
  plxsignal = XPlxQueryVideo(disp, win, gc);			    /*	Query the Video to see if sync is there		*/
  while ( !plxsignal->sync_ok )					    /*	Wait until a signal is input into the board	*/
  {
    printf(" Sync Absent - Hook up an input source\n");
    XPlxSleep(500000);
    plxsignal = XPlxQueryVideo(disp, win, gc);                      /*  Query the Video again to check sync             */
  }
  videowidth = plxsignal->w;
  videoheight = plxsignal->h - plxsignal->b;
  XPlxVideoTag(disp, win, gc, PLX_VIDEO);
  XSelectInput(disp, win, ExposureMask);			    /*	Catch exposure events				*/
  XResizeWindow(disp, win, videowidth, videoheight);		    /*	Map windows					*/
  XMapWindow(disp, win); 
  while (1)							    /*	Continuously show live video with the standard signal... */
  {								    /* ... width and height. */
    XNextEvent(disp, &event);
    XPlxVideoLive(disp, win, gc, 0, 0,
		  0, 0, videowidth, videoheight);
  }
} /* end program */
