/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* This program demonstrates the ability of the JPEG widget to display a
 * JFIF file read in from disk.  The program takes one argument, the name of
 * the JFIF file to be read into the JPEG widget.  This file name is passed
 * into the JPEG widget, which takes care of the rest of the work.
 */
/* $Header: /plx/source/Xclients/generic/RCS/jpegFileTest.c,v 1.10 1993/09/10 12:37:25 drapeau Exp $ */
/* $Log: jpegFileTest.c,v $
 * Revision 1.10  1993/09/10  12:37:25  drapeau
 * First public version of this test program.
 * */
static char jpegFileTestRcsId[] = "$Header: /plx/source/Xclients/generic/RCS/jpegFileTest.c,v 1.10 1993/09/10 12:37:25 drapeau Exp $";

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <XPlxExt.h>
#include <JPEG.h>

Widget top, jpegWidget;

void main(int argc, char** argv)
{
  XtAppContext	appContext;
  
  top = XtVaAppInitialize(&appContext, "JPEGTest", NULL, 0,	    /* Create the top-level shell for this program */
			  &argc, argv,
			  NULL,
			  NULL);
  if (argc < 2)
  {
    printf("Usage: %s <fileName>.\n", argv[0]);
    exit(-1);
  }
  jpegWidget = XtVaCreateManagedWidget("jpeg", jpegWidgetClass,	    /* Create a JPEG widget, which will be used here only to... */
				       top,			    /* ...display an image loaded from a JFIF file. */
				       XtNjfifInputFile, argv[1],   /* Tell the widget the name of the JFIF file to display */
				       NULL);
  XtRealizeWidget(top);
  XtAppMainLoop(appContext);
}								    /* end function main */
