/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* The purpose of this program is to show how to create a widget for displaying
 * video in an X window.  This is about the simplest Xt program that can be
 * written for this purpose.
 * The program creates a top-level shell and a VideoIn widget.
 * The options[] array is created to allow you to modify some of the widget's
 * resources from the command line as well as from an X resource file.
 */
/* $Header: /plx/source/Xclients/generic/RCS/xvInTest.c,v 1.10 1993/09/10 12:37:37 drapeau Exp $ */
/* $Log: xvInTest.c,v $
 * Revision 1.10  1993/09/10  12:37:37  drapeau
 * First public version of this test program.
 * */
static char xvInTestRcsId[] = "$Header: /plx/source/Xclients/generic/RCS/xvInTest.c,v 1.10 1993/09/10 12:37:37 drapeau Exp $";

#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <XPlxExt.h>
#include <XVideoIn.h>

static XrmOptionDescRec options[] = {
	{"-brightness",		"*videoIn.brightness",			XrmoptionSepArg,	NULL, },
	{"-contrast",		"*videoIn.contrast",			XrmoptionSepArg,	NULL, },
	{"-hue",		"*videoIn.hue",				XrmoptionSepArg,	NULL, },
	{"-saturation",		"*videoIn.saturation",			XrmoptionSepArg,	NULL, },
	{"-cropped",		"*videoIn.cropped",			XrmoptionSepArg,	NULL, },
	{"-normalAspectRatio",	"*videoIn.normalAspectRatio",		XrmoptionSepArg,	NULL, },
	{"-live",		"*videoIn.live",			XrmoptionSepArg,	NULL, },
	{"-showBlankInterval",	"*videoIn.showBlankInterval",		XrmoptionSepArg,	NULL, },
	{"-channel",		"*videoIn.channel",			XrmoptionSepArg,	NULL, },
};

Widget top, videoWidget;

void main(int argc, char** argv)
{
  top = XtInitialize("xVideoIn", "XVideoIn",			    /* Create a top-level shell as well as initializing... */
		     options, XtNumber(options), &argc, argv);	    /* ...the toolkit. */
  videoWidget = XtVaCreateManagedWidget("videoIn",		    /* Create a widget for displaying video. */
					xVideoInWidgetClass, top,
					NULL);
  XtRealizeWidget(top);
  XtMainLoop();
}
