/* (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved */

/* This file is $OPENWINHOME/src/client/xview/comp_example/xvccomp.c */

static char *rcsid = "@(#)$Id: xvccomp.c,v 1.6 1995/10/27 20:43:58 drapeau Exp $ Parallax Graphics Inc";

#include <sys/param.h>
#include <X11/Xlib.h>
#include <xview/xview.h>
#include "Video.h"

static Frame frame, frame1;
static VideoIn video, video1;
static int videowidth  = 642;
static int videoheight = 482;
static Display *dpy;
static short QFactor=30;
static struct itimerval timeval;				    /* Timer parameters						*/


Notify_value quit(client, status)				    /* Quit routine */
     Notify_client client;
     Destroy_status status;
{
  if (status == DESTROY_CLEANUP)
  {
    frame=0;
    return(notify_next_destroy_func(client, status));
  }
  return(NOTIFY_DONE);
}



Notify_value worker()						    /* JPEG capture and display */
{
  JPEGImage *jpeg_image;
 
  xv_set(video, VIDEO_NEW_FRAME, TRUE);				    /* Grab next frame of video and display */
  jpeg_image = (JPEGImage *)xv_get(video, VIDEO_JPEG_IMAGE);	    /* Get a compressed image */
  xv_set(video1, VIDEO_JPEG_IMAGE, jpeg_image, NULL);		    /* Decompress the image into the destination window */
  XPlxDestroyCImage(jpeg_image);
  XSync(dpy, False);
  return(NOTIFY_DONE);
} /* end function worker */



main(argc, argv)
     int argc;
     char *argv[];
{
  register int n;
  
  xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
  frame = (Frame) xv_create((Xv_object)NULL, FRAME,
			    XV_LABEL,	"COMPRESSION",
			    XV_X,		100,
			    XV_Y,		100,
			    NULL);
  dpy = (Display *) xv_get(frame, XV_DISPLAY);
  notify_interpose_destroy_func(frame, quit);
  video = xv_create(frame, VIDEO_IN,
		    VIDEO_LIVE,	FALSE,
		    VIDEO_SQUEEZE,	TRUE,
		    VIDEO_Q_FACTOR,	QFactor,
		    XV_VISUAL_CLASS, TrueColor,
		    NULL);
  if ((VideoIn)NULL == video)
  {
    fprintf(stderr,
	    "%s: Can't create video canvas.  Check input connnection\n", argv[0]);
    exit(1);
  }
  frame1 = (Frame)xv_create(frame, FRAME,
			    XV_LABEL,	"DECOMPRESSION",
			    XV_X,		400,
			    XV_Y,		400,
			    NULL);
  video1 = xv_create(frame1, VIDEO_IN,
		     VIDEO_LIVE,	FALSE,
		     VIDEO_SQUEEZE,	TRUE,
		     VIDEO_Q_FACTOR,	QFactor,
		     XV_VISUAL_CLASS, TrueColor,
		     NULL);
 
  if ((VideoIn)NULL == video1)
  {
    fprintf(stderr,
	    "%s: Can't create video canvas.  Check input connnection\n", argv[0]);
    exit(1);
  }
  xv_set(frame, XV_SHOW, TRUE, NULL);
  xv_set(frame1, XV_SHOW, TRUE, NULL);
  timeval.it_value.tv_usec    = 28000;
  timeval.it_value.tv_sec     = 0;
  timeval.it_interval.tv_usec = 28000;
  timeval.it_interval.tv_sec  = 0;
  notify_set_itimer_func(video,worker,ITIMER_REAL,&timeval,NULL);
  xv_main_loop(frame);
} /* end program */
