/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: alert.c,v $
 * Revision 1.9  1992/05/27  16:20:15  eric
 * Moved from alert.c to ../../../lib/api/alert.c
 *
 * Revision 1.8  92/05/21  15:07:44  schen
 * checkin demo19
 * 
 * Revision 1.3  91/08/19  13:09:01  eric
 * added rcs header
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: alert.c,v 1.9 1992/05/27 16:20:15 eric Deleted $ Parallax Graphics Inc";
#endif

/*
 *	alert.c - Handles the display of alerts to the user
 *
 *	Written by John Malleo-Roach
 *
 */

/* INCLUDE FILES */

#include	<stdio.h>
#include	<strings.h>
#include    <xview/xview.h>
#include    <xview/font.h>
#include    <xview/fullscreen.h>
#include    <xview/notice.h>

/* CONSTANTS */

#define BOOLEAN     int
#ifndef FALSE
#define FALSE       0
#endif
#ifndef TRUE
#define TRUE        1
#endif

/* STATIC VARIABLES */

static Xv_Font NoticeFont=NULL;			/* Font used for notices (Fixed)	*/

static char *NoticeMessageArray[5];		/* Array of notice message strings  */

/* FUNCTIONS */

void ShowAlert(a,b,c,d,e)
char *a,*b,*c,*d,*e;
{	
	int i;
	Xv_Window win;

	i = 0;
	if (a) {
		NoticeMessageArray[i++] = a;
		if (b) {
			NoticeMessageArray[i++] = b;
			if (c) {
				NoticeMessageArray[i++] = c;
				if (d) {
					NoticeMessageArray[i++] = d;
					if (e) {
						NoticeMessageArray[i++] = e;
					}
					else NoticeMessageArray[i] = NULL;
				}
				else NoticeMessageArray[i] = NULL;
			}
			else NoticeMessageArray[i] = NULL;
		}
		else NoticeMessageArray[i] = NULL;
	}
	else NoticeMessageArray[i] = NULL;

	if (NoticeFont == NULL) {
		NoticeFont = xv_find(NULL,FONT,
			FONT_NAME,	"-adobe-courier-bold-r-normal-*-14-*-*-*-m-90-iso8859-1",
			NULL);
	}

	win = (Xv_Window) xv_create(NULL,FRAME,XV_SHOW,FALSE,NULL);

	(void) notice_prompt(win,NULL,
		NOTICE_MESSAGE_STRINGS_ARRAY_PTR,	NoticeMessageArray,
		NOTICE_BUTTON_YES,					"OK",
		NOTICE_FONT,						NoticeFont,
		NULL);

	xv_destroy_safe(win);
}

void SystemError(number,message)
int number;
char *message;
{
	extern int sys_nerr;
	extern char *sys_errlist[];
	char buffer[256];

	if (number < 0 || number >= sys_nerr)
		sprintf(buffer, "Unknown system error:  #%d", number);
	else	sprintf(buffer, "System error:  %s", sys_errlist[number]);
	ShowAlert(buffer,NULL);
}

BOOLEAN ShowConfirm(a,b,c,d,e)
char *a,*b,*c,*d,*e;
{
	Xv_Window win;
	int		i;
	int		answer;

	i = 0;
	if (a) {
		NoticeMessageArray[i++] = a;
		if (b) {
			NoticeMessageArray[i++] = b;
			if (c) {
				NoticeMessageArray[i++] = c;
				if (d) {
					NoticeMessageArray[i++] = d;
					if (e) {
						NoticeMessageArray[i++] = e;
					}
					else NoticeMessageArray[i] = NULL;
				}
				else NoticeMessageArray[i] = NULL;
			}
			else NoticeMessageArray[i] = NULL;
		}
		else NoticeMessageArray[i] = NULL;
	}
	else NoticeMessageArray[i] = NULL;

	if (NoticeFont == NULL) {
		NoticeFont = xv_find(NULL,FONT,
			FONT_NAME,	"-adobe-courier-bold-r-normal-*-14-*-*-*-m-90-iso8859-1",
			NULL);
	}

	win = (Xv_Window) xv_create(NULL,FRAME,XV_SHOW,FALSE,NULL);

	answer = FALSE;
	answer = notice_prompt(win,NULL,
		NOTICE_MESSAGE_STRINGS_ARRAY_PTR,	NoticeMessageArray,
		NOTICE_BUTTON_YES,					"Yes",
		NOTICE_BUTTON_NO,					"No",
		NOTICE_FONT,						NoticeFont,
		NULL);

	xv_destroy_safe(win);

    return(answer);
}

BOOLEAN ShowNote(a,b,c,d,e)
char *a,*b,*c,*d,*e;
{
	Xv_Window win;
	int		i;

	i = 0;
	if (a) {
		NoticeMessageArray[i++] = a;
		if (b) {
			NoticeMessageArray[i++] = b;
			if (c) {
				NoticeMessageArray[i++] = c;
				if (d) {
					NoticeMessageArray[i++] = d;
					if (e) {
						NoticeMessageArray[i++] = e;
					}
					else NoticeMessageArray[i] = NULL;
				}
				else NoticeMessageArray[i] = NULL;
			}
			else NoticeMessageArray[i] = NULL;
		}
		else NoticeMessageArray[i] = NULL;
	}
	else NoticeMessageArray[i] = NULL;

	if (NoticeFont == NULL) {
		NoticeFont = xv_find(NULL,FONT,
			FONT_NAME,	"-adobe-courier-bold-r-normal-*-14-*-*-*-m-90-iso8859-1",
			NULL);
	}

	win = (Xv_Window) xv_create(NULL,FRAME,XV_SHOW,FALSE,NULL);

	(void) notice_prompt(win,NULL,
		NOTICE_MESSAGE_STRINGS_ARRAY_PTR,	NoticeMessageArray,
		NOTICE_BUTTON_YES,					"Okay",
		NOTICE_FONT,						NoticeFont,
		NULL);

	xv_destroy_safe(win);

	return(FALSE);
}

/* end of alert.c */
