/************************************************************************/
/******								   ******/
/******Compression Monitor for C-Cube Microsystems CL550 processor ******/
/******			January 17, 1991 			   ******/
/******         	Version 1.00				   ******/
/******								   ******/
/************************************************************************/
/******								   ******/
/******		MakeQ.c contains:				   ******/
/****** 	MakeQTables() 	Drives the making of the Q tables  ******/
/******								   ******/
/************************************************************************/
static char makeQRcsId[] = "$Header: /plx/source/Xclients/generic/RCS/MakeQ.c,v 1.11 1995/08/17 20:28:57 drapeau Exp $";


#include <stdio.h>
#include "qtab.h"

static char zig_zag[64] =
{
  1,   2,   6,   7,  15, 16, 28, 29,
  3,   5,   8,  14,  17, 27, 30, 43,
  4,   9,  13,  18,  26, 31, 42, 44,
  10, 12,  19,  25,  32, 41, 45, 54,
  11, 20,  24,  33,  40, 46, 53, 55,
  21, 23,  34,  39,  47, 52, 56, 61,
  22, 35,  38,  48,  51, 57, 60, 62,
  36, 37,  49,  50,  58, 59, 63, 64,
};

int MakeQTables(unsigned int factor, unsigned char*	buf[])
{
  register unsigned char *obuf, *ibuf, *rbuf;
  register int i, temp;
  int j;
  static unsigned char mungtable[0x86];
  static unsigned char *qt, *munq;
  
  rbuf = obuf = (unsigned char *) malloc(sizeof(DQTmarker));
  *buf = obuf;
  ibuf = (unsigned char *) &DQTmarker;
  
  *obuf++ = *ibuf++;						    /* move the first four chars */
  *obuf++ = *ibuf++;
  *obuf++ = *ibuf++;
  *obuf++ = *ibuf++;
  
  for(j = 2; j--;)						    /* two sets of things */
  { 
    *obuf++ = *ibuf++;					    /* move one then scale the rest */
    for(i = 0; i < 64; ++i)
    {
      temp = (((unsigned int) *ibuf++) * factor) / 50;
      *obuf++ = (temp < 256) ? temp : 255;
    }
  }

  qt = rbuf;

  munq = &mungtable[5];

  for(j = 1; j < 65; ++j)
  {
    for(i = 0; i < 64; ++i)
    {
	  if(zig_zag[i] == j)
	    *munq++ = qt[i+5];
    }
  }

  *munq++ = qt[69];

  for(j = 1; j < 65; ++j)
  {
    for(i = 0; i < 64; ++i)
    {
	if(zig_zag[i] == j)
	    *munq++ = qt[i+70];
    }
  }
  memcpy(&rbuf[5], &mungtable[5], 129);

  return (sizeof(DQTmarker));
}
