/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Header: /plx/source/Xclients/generic/RCS/WindowToPortID.h,v 1.14 1994/10/22 23:21:07 drapeau Exp $ */
/* $Log: WindowToPortID.h,v $
 * Revision 1.14  1994/10/22  23:21:07  drapeau
 * Use the correct, standard Xv include file instead of the old Xv-to-Plx
 * include file.
 *
 * Revision 1.13  1994/10/03  16:15:16  drapeau
 * Added support for a Delete() method.
 *
 * Revision 1.12  1994/09/03  05:57:22  drapeau
 * Fixed order of include files to support function prototypes.
 *
 * Revision 1.11  1993/12/15  06:14:55  drapeau
 * Slight modifications to make the code more portable, and self-reliant
 * upon the Parallax software release.  Currently, not all workstations
 * release the Xv X extension as part of their distributed software, so
 * Parallax must distribute its own source and header files.  These small
 * changes allow this software to use the Parallax version of Xv.
 *
 * Revision 1.1  1993/11/20  00:40:15  drapeau
 * Initial revision
 * */
static char windowToPortIDHeaderRcsid[] = "$Header: /plx/source/Xclients/generic/RCS/WindowToPortID.h,v 1.14 1994/10/22 23:21:07 drapeau Exp $";

#ifndef _WindowToPortIDHeader_
#define _WindowToPortIDHeader_

#include	<Xvlibint.h>
#include	<XPlxExt.h>

typedef struct _WindowToPortID
{
  Window			window;
  XvPortID			xvPortID;
  struct _WindowToPortID*	next;
} WindowToPortID;


WindowToPortID*	NewWindowToPortIDList(void);
void		DestroyWindowToPortIDList(WindowToPortID*);
void		WindowToPortIDAdd(Window, XvPortID, WindowToPortID**);
WindowToPortID*	WindowToPortIDFind(Window, WindowToPortID*);
void		WindowToPortIDPrint(WindowToPortID*);
WindowToPortID*	WindowToPortIDDelete(Window, WindowToPortID*);

extern WindowToPortID*	windowToPortIDList;

#endif
