/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: live.c,v $
 * Revision 1.9  1994/01/20  01:32:16  drapeau
 * Removed extraneous conditional compilation directives, since including
 * "string.h" always works no matter what OS platform.
 *
 * Revision 1.8  1993/11/19  04:32:13  drapeau
 * Modified the code to add support for SVR4.
 *
 * Revision 1.2  91/08/19  13:09:22  eric
 * added rcs header
 * 
 *
 */

#ifndef lint
static char *rcsid = "@(#)$Id: live.c,v 1.9 1994/01/20 01:32:16 drapeau Exp $ Parallax Graphics Inc";
#endif

/*
 *	live.c - low level routines for driving a live (non-controllable) source.
 *
 *	Written by John Malleo-Roach
 *
 */

/* INCLUDE FILES */

#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/termios.h>
#include	<sys/filio.h>
#include	<fcntl.h>
#include	<string.h>
#include	<errno.h>
#include	"alert.h"

/* CONSTANTS */

/* Player status codes, these are the same in all device driver files */

#define PLAYER_STATUS_UNKNOWN	0
#define PLAYER_STATUS_STOP		1
#define PLAYER_STATUS_STILL		2
#define PLAYER_STATUS_PLAY		3
#define PLAYER_STATUS_EMPTY		4

/* GLOBALS */

extern int PlayerId;			/* File descriptor for the virtual videodisc player	*/

/* FUNCTIONS */

/* Initialize the virtual videodisc player to a known state */

int InitializeLive(device,speed)
char *device;
int speed;
{
	PlayerId = 0;
	return(NULL);
}

/* Return a simple status code for the player */

int LiveStatus()
{
	return(PLAYER_STATUS_UNKNOWN);
}

/* Return current frame number from player */

int LiveFrameNumber()
{
	return(0);
}

/* Set Audio parameters */

int SetLiveAudio(mode)
int mode;
{
	return(NULL);
}

/* Set whether the video is visible or not */

int SetLiveVideo(mode)
int mode;
{
	return(NULL);
}

/* Seek and show a single frame */

int ShowLiveFrame(frame)
int frame;
{
	return(NULL);
}

/* Seek and show a single frame by elapsed time */

static int ShowLiveTime(minutes,seconds)
int minutes,seconds;
{
	return(NULL);
}

/* Seek and show a complete video segment */

int ShowLiveSegment(start,end)
int start,end;
{
	return(NULL);
}

/* Seek and show a complete video segment by times */

static int ShowLiveTimeSegment(smin,ssec,emin,esec)
int smin,ssec,emin,esec;
{
	return(NULL);
}

/* Command : play forward */

int LivePlay()
{
	return(NULL);
}

/* Command : play reverse */

int LiveReverse()
{
	return(NULL);
}

/* Command : Continue an interrupted segment */

int LiveContinue()
{
	return(NULL);
}

/* Command : pause during playback */

int LiveStill()
{
	return(NULL);
}

/* Command : Stop playback */

int LiveStop()
{
	return(NULL);
}

/* Command : move 1 frame forward */

int LiveStepForward()
{
	return(NULL);
}

/* Command : move 1 frame backward */

int LiveStepReverse()
{
	return(NULL);
}

/* Command : move slow forward */

int LiveSlowForward()
{
	return(NULL);
}

/* Command : move slow reverse */

int LiveSlowReverse()
{
	return(NULL);
}

/* Command : move fast forward */

int LiveFastForward()
{
	return(NULL);
}

/* Command : move fast reverse */

int LiveFastReverse()
{
	return(NULL);
}

/* Command : display visual frame location */

int LiveIndex(status)
int status;
{
	return(NULL);
}

/* Ejects the platter from the player */

int LiveEject()
{
	return(NULL);
}

/* end of live.c */
